=begin
 Copyright 2012, Jaime Díaz
 ESTE SOFTWARE SE ENTREGA "TAL CUAL", SIN NINGUNA GARANTÍA EXPRESA O IMPLÍCITA, 
 INCLUYENDO, SIN LIMITACIÓN, LAS GARANTÍAS DE COMERCIALIZACIÓN Y APTITUD 
 PARA UN PROPÓSITO PARTICULAR.
---------------------------------------------------------------------------------------------------
 Nombre        		:	SolidSection 1.0
 Descripción   		:	Hace tapas en secciones
 -------------------------------- CLASES ---------------------------------------------------------		  		
 Fecha        			:	19/04/2011
 Tipo        				:	Opción de menu contextual
---------------------------------------------------------------------------------------------------
=end
module Iscarnet_Extensions
module Mac
##
# Cross platform MAC address determination.  Works for:
# * /sbin/ifconfig
# * /bin/ifconfig
# * ifconfig
# * ipconfig /all
#
# To return the first MAC address on the system:
#
#   Mac.address
#
# To return an array of all MAC addresses:
#
#   Mac.address.list
  #VERSION = '1.0.0' #if !$DibacMac
  #def Mac.version() ::Mac::VERSION end
  class << self
    ##
    # Accessor for the system's first MAC address, requires a call to #address
    # first
    attr_accessor "mac_address"
    ##
    # Discovers and returns the system's MAC addresses.  Returns the first
    # MAC address, and includes an accessor #list for the remaining addresses:
    #
    #   Mac.addr # => first address
    #   Mac.addr.list # => all addresses
    def address
		#return Mac.dibacmac if Mac.dibacmac
		return @mac_address if defined? @mac_address and @mac_address
		re = %r/[^:\-](?:[0-9A-F][0-9A-F][:\-]){5}[0-9A-F][0-9A-F][^:\-]/io
		cmds = '/sbin/ifconfig', '/bin/ifconfig', 'ifconfig', 'ipconfig /all'
		null = test(?e, '/dev/null') ? '/dev/null' : 'NUL'
		cmd = 'ipconfig /all' if Mac.win
			cmd = 'ifconfig' if Mac.mac
		  lines = nil
		  #cmds.each do |cmd|
		Dir::chdir( RUBY_PLATFORM !~ /darwin/i ? "#{ENV['USERPROFILE']}/Desktop" : "~/Desktop" ){
		IO.popen("#{ cmd } 2> #{ null } > my_pipe"){|fd| fd.readlines} #rescue next
        #next unless stdout and stdout.size > 0
		lines = open("my_pipe", :encoding => 'ISO-8859-1').readlines
		File.delete("my_pipe")
		
      #end
      raise "all of #{ cmds.join ' ' } failed" unless lines
      raise "all of comands failed" unless lines
      #candidates = lines.select{|line| line =~ re}
	  candidates=[]
	  candidates = lines.select{|line| re.match(line)}
begin	  
      raise 'no mac address candidates' unless candidates.first
      candidates.map!{|c| c[re].strip}
      maddr = candidates.first
      raise 'no mac address found' unless maddr
      maddr.strip!
      maddr.instance_eval{ @list = candidates; def list() @list end }
      @mac_address = maddr
end
}	  
    end
    ##
    # Shorter alias for #address
    alias_method "addr", "address"
  end
	module_function
	def mac; @mac end
	def mac= v; @mac = v end
	def win; @win end
	def win= v; @win = v end
	
	Mac.mac =( Object::RUBY_PLATFORM =~ /darwin/i ? true : false ) 
	Mac.win =((Object::RUBY_PLATFORM =~ /mswin/i || Object::RUBY_PLATFORM =~ /mingw/i) ? true : false ) 
	
end # del moculo Mac
module SS_Extension
require "sketchup" 
require "extensions"
class SS_Lenguaje
  def initialize
    @strings =Hash.new;
    self.ParseLangFile
	Iscarnet_SS.description = GetString(Iscarnet_SS.description)
  end
  def ParseLangFile
	file_rec = Sketchup.find_support_file("SolidSection.strings", "plugins//iscarnet_ss"+"//resources//"+(Sketchup.read_default("Dibac","Language",Sketchup.get_locale[0,2])))
	file_rec = Sketchup.find_support_file("SolidSection.strings", "plugins//iscarnet_dibac"+"//resources//"+(Sketchup.read_default("Dibac","Language",Sketchup.get_locale[0,2]))) if (!file_rec || file_rec.length==0)
    if file_rec==nil || file_rec.length==0 #si no hay idioma
		file_rec = Sketchup.find_support_file("SolidSection.strings", "plugins//iscarnet_ss"+"//resources//"+Sketchup.get_locale[0,2])
	end	
    if file_rec==nil || file_rec.length==0
      return false
    end
    langFile = File.open(file_rec, "r")
    entryString = ""
    inComment = false
    langFile.each do |line|
      #ignore simple comment lines - BIG assumption the whole line is a comment
      if !line.include?("//")
        #also ignore comment blocks
        if line.include?("/*")
          inComment = true
        end
        if inComment==true
          if line.include?("*/")
            inComment=false
          end
        else
          entryString += line
        end
      end
      if entryString.include?(";")
        #parse the string into key and value
        
        #remove the white space
        entryString.strip!
        #pull out the key
        keyvalue = entryString.split("\"=\"")
        
        #strip the leading quotation out
        key = keyvalue[0][(keyvalue[0].index("\"")+1)..(keyvalue[0].length+1)]
		result=keyvalue[1].to_s
 		#pull out the value
		result.gsub!(";", "")
        value = result.gsub("\"", "") 
        #add to @strings
        @strings[key]=value
        entryString = ""
      end
    end
	langFile.close
    return true
  end
  def GetString(key)
    #puts "GetString key = " + key.to_s
    retval = @strings[key]
    #puts "GetString retval = " + retval.to_s
    if retval!= nil
         retval.chomp!
    else
        retval = key
    end
    return retval
  end
def unchecked(menu, item) # lo metemos aqui para aprovechar el objeto $DibacStrings
	menu.set_validation_proc(item)  {
		MF_UNCHECKED
	}
end
  
end #de la clase SS_Lenguaje
class Dibac_Licencia  
	
def ord(caracter)
	begin
		return caracter.ord
	rescue
		return caracter
	end	
end
	
def sacaclave(texto)	
#---------------------------------------------------------------------------------	
	modulo =128 #modulo para cambiar generacion de numeros
#---------------------------------------------------------------------------------	
	return '' if(texto==nil || texto=='')
	aleatorio1=ord(texto[0]) % modulo
	aleatorio2=ord(texto[texto.length-1]) % modulo
	i=0
	clave=''
	a=(aleatorio2 + modulo).chr
	while i<texto.length do
		a <<(aleatorio1+ord(texto[i]) % modulo).chr
		a <<(aleatorio2 + ord(a[2*i+1]) % modulo).chr
		i +=1
	end
	jj=0
	i=1
	j=(a.length)/11
	if a.length>10
		while i+j<a.length do
			for ii in 0 ... j 
				jj=jj+ord(a[i-1])
				i+=1
			end
			jj=jj % 10
			jj +=39 if jj>9
			clave=clave+(jj+48).chr
		end	
	end 
	return clave
end
def licencia (grabar)
	usuario		= Sketchup.read_default("Dibac","User","")
	email		= Sketchup.read_default("Dibac","Email","")
	numserie	= Sketchup.read_default("Dibac","Serial","")
	clave		= Sketchup.read_default("Dibac","Key","")
	defaultkey	= Sketchup.read_default("Preferences","ValidDefaultKey","")
	num1=sacaclave(email+DibacMac)
	num2=sacaclave(num1)
	if((num1 != numserie) || (num2 != defaultkey))
		if numserie != ""
			usuario		= ""
			Sketchup.write_default("Dibac","User","")
			email		= ""
			Sketchup.write_default("Dibac","Email","")
			numserie	= ""
			Sketchup.write_default("Dibac","Serial","")
			Sketchup.write_default("Dibac","Key","")
			defaultkey=""
			num1=sacaclave(email+DibacMac)
			num2=sacaclave(num1)
		end
		if (defaultkey.to_i-num2.to_i).abs > 57600 || defaultkey.to_i-num2.to_i < 0
			defaultkey = num2
			grabar=true
		end	
		tiempo_uso = (Time.now - DibacHoraInicio).to_i
		tiempo_tope = (num2.to_i  + 57600) #16 horas
		tiempo_actual = defaultkey.to_i
		if tiempo_actual < tiempo_tope
			acumulado= tiempo_actual+tiempo_uso
			acumulado= tiempo_tope if acumulado > tiempo_tope
			Sketchup.write_default("Preferences","ValidDefaultKey", acumulado.to_s) if grabar
			numserie='promo' 
			diff = (tiempo_tope-acumulado)
			seconds = diff % 60
			minutes = (diff / 60) % 60
			hours = diff / 3600
			defaultkey= hours.to_s+':'+minutes.to_s+':'+seconds.to_s	
		else
			numserie = ""
			defaultkey=""
		end	
	end
	return [usuario,email,numserie,clave,defaultkey]
end
def informacion(datoslicencia)
	usuario=datoslicencia[0]
	email=datoslicencia[1]
	numserie=datoslicencia[2]
	clave=datoslicencia[3]
	defaultkey=datoslicencia[4]
	texto=DibacStrings.GetString('Dibac for Sketchup')+"\n" + Iscarnet_Dibac.description + "\n"
	if numserie == 'promo'
		texto=texto + DibacStrings.GetString("Promotional license")+"  ("+defaultkey+")"
	elsif clave != '' 
		texto = texto + DibacStrings.GetString('User') + ": " + usuario + " - " + email + "\n"
		texto=texto + DibacStrings.GetString('Serial number') + ": " + numserie
	else
		texto=texto+DibacStrings.GetString("Sorry. Your promotional license has expired.")+"\n"
		texto=texto+DibacStrings.GetString("Please contact your dealer.")+"\n"+"www.dibac.com"
	end	
	UI.messagebox(texto)
end
end #de la clase Dibac_Licencia
class SS_Licencia  
def ord(caracter)
	begin
		return caracter.ord
	rescue
		return caracter
	end	
end
	
def sacaclave(texto)	
#---------------------------------------------------------------------------------	
	modulo =129 #modulo para cambiar generacion de numeros
#---------------------------------------------------------------------------------	
	return "" if(texto==nil || texto=='')
	aleatorio1=ord(texto[0]) % modulo
	aleatorio2=ord(texto[texto.length-1]) % modulo 
	i=0
	clave=''
	a=(aleatorio2 + modulo).chr
	while i<texto.length do
		a <<(aleatorio1+ord(texto[i]) % modulo).chr
		a <<(aleatorio2 + ord(a[2*i+1]) % modulo).chr
		i +=1
	end
	jj=0
	i=1
	j=(a.length)/11
	if a.length>10
		while i+j<a.length do
			for ii in 0 ... j 
				jj=jj+ord(a[i-1])
				i+=1
			end
			jj=jj % 10
			jj +=39 if jj>9
			clave=clave+(jj+48).chr
		end	
	end 
	return clave
end
def licencia (grabar)
	if DibacLicencia
		licenciadibac=DibacLicencia.licencia(false)
		#return licenciadibac if licenciadibac[2] != ""
	end
	usuario		= Sketchup.read_default("SolidSection","User","")
	email		= Sketchup.read_default("SolidSection","Email","")
	numserie	= Sketchup.read_default("SolidSection","Serial","")
	clave		= Sketchup.read_default("SolidSection","Key","")
	defaultkey	= Sketchup.read_default("Preferences","ValidDefaultSerial","")
	num1=sacaclave(email+SSMac)
	num2=sacaclave(num1)
	if((num1 != numserie) || (num2 != defaultkey))
		#Si tiene licencia de dibac la tiene de SolidSection
		if licenciadibac[2] != "" 
			licenciadibac[2]=licenciadibac[2]+' (Dibac)'
			return licenciadibac
		end	if DibacLicencia
		if numserie != ""
			usuario		= ""
			Sketchup.write_default("SolidSection","User","")
			email		= ""
			Sketchup.write_default("SolidSection","Email","")
			numserie	= ""
			Sketchup.write_default("SolidSection","Serial","")
			Sketchup.write_default("SolidSection","Key","")
			defaultkey=""
			num1=sacaclave(email+SSMac)
			num2=sacaclave(num1)
		end
		if (defaultkey.to_i-num2.to_i).abs > 57600 || defaultkey.to_i-num2.to_i < 0
			defaultkey = num2
			grabar=true
		end	
		tiempo_uso = (Time.now - SSHoraInicio).to_i
		tiempo_tope = (num2.to_i  + 57600) #16 horas
		tiempo_actual = defaultkey.to_i
		if tiempo_actual < tiempo_tope
			acumulado= tiempo_actual+tiempo_uso
			acumulado= tiempo_tope if acumulado > tiempo_tope
			Sketchup.write_default("Preferences","ValidDefaultSerial", acumulado.to_s) if grabar
			numserie='promo' 
			diff = (tiempo_tope-acumulado)
			seconds = diff % 60
			minutes = (diff / 60) % 60
			hours = diff / 3600
			defaultkey= hours.to_s+':'+minutes.to_s+':'+seconds.to_s	
		else
			numserie = ""
			defaultkey=""
		end	
	end
	return [usuario,email,numserie,clave,defaultkey]
end
def informacion(datoslicencia)
	usuario=datoslicencia[0]
	email=datoslicencia[1]
	numserie=datoslicencia[2]
	clave=datoslicencia[3]
	defaultkey=datoslicencia[4]
	texto=SSStrings.GetString('Solid Section')+"\n" + Iscarnet_SS.description + "\n"
	if numserie == 'promo'
		texto=texto + SSStrings.GetString("Promotional license")+"  ("+defaultkey+")"
	elsif clave != '' 
		texto = texto + SSStrings.GetString('User') + ": " + usuario + " - " + email + "\n"
		texto=texto + SSStrings.GetString('Serial number') + ": " + numserie
	else
		texto=texto+SSStrings.GetString("Sorry. Your promotional license has expired.")+"\n"
		texto=texto+SSStrings.GetString("Please contact your dealer.")+"\n"+"www.dibac.com"
	end	
	UI.messagebox(texto)
end
end #de la clase SS_Licencia
class SS_ObservadorModel < Sketchup::ModelObserver
def onActivePathChanged(model)
	SeccionSolida.cambio(SS_Extension.seccion) if SS_Extension.seccion
	SeccionSolida.borrar(SS_Extension.borrar) if SS_Extension.borrar
	return if SS_Extension.paths.include?(model.active_entities)
	SS_Extension.paths= model.active_entities
	SeccionSolida.iniciosecciones
end
end # de la clase ObservadorModel
class SS_ObservadorApp < Sketchup::AppObserver
def onNewModel(model)
	Sketchup.active_model.add_observer(SS_ObservadorModel.new)
	SeccionSolida.iniciosecciones
end
	
def onOpenModel(model)
	Sketchup.active_model.add_observer(SS_ObservadorModel.new)
	SeccionSolida.iniciosecciones
end	
def onQuit()
	SSLicencia.licencia(true)
end
end # de la clase ObservadorApp
class SS_ObservadorEntities < Sketchup::EntitiesObserver
def onElementAdded(entities, entity)
	if entity.is_a?(Sketchup::SectionPlane)
		entity.add_observer(SS_ObservadorSeccion.new)
		SeccionSolida.face(nil, entity, false) if SSLicencia.licencia(false)[2] != ""
	end
end	
	
end # de la clase ObservadorEntities
class SS_ObservadorSeccion < Sketchup::EntityObserver
def onChangeEntity(entity)
	#Sketchup.active_model.select_tool SeccionSolida.cambio(entity)
	#SS_Extension.seccion=entity
	UI.start_timer(0.001,false) {SeccionSolida.cambio(entity)}	
	#SeccionSolida.cambio(entity)	
end	
	
def onEraseEntity(entity) 
	#SS_Extension.borrar=entity
	UI.start_timer(0.001,false) {SeccionSolida.borrar(entity)}	
end	
end # de la clase ObservadorSeccion
class SS_Inicio
def conexion_valida
	return true if Sketchup.is_online
	UI.messagebox(SSStrings.GetString("No Internet connection"))
	return false	
end
def datos_licencia(grabar)
	datoslicencia=SSLicencia.licencia(grabar)
	@@usuario=datoslicencia[0]
	@@email=datoslicencia[1]
	@@numserie=datoslicencia[2]
	@@clave=datoslicencia[3]
	@@defaultkey=datoslicencia[4]
	@@datoslicencia=[@@usuario,@@email,@@numserie,@@clave,@@defaultkey]
end
def licencia_autorizar
	return false if !conexion_valida
	
	#UI.messagebox('Hay conexion a internet')
	
	prompts = 	[	SSStrings.GetString("User")+":",
							SSStrings.GetString("E_mail")+":",
							#$DibacStrings.GetString("Serial number")+":",
							SSStrings.GetString("Authorization number")+":     "
						]
						
	defaults = 	[	"",
							"",
							#"",
							""
						]
						
	list = 			[	"",
							"",
							#"",
							""
						]
	input = UI.inputbox prompts, defaults, list,SSStrings.GetString("Solid Section")+": "+SSStrings.GetString("User License")
	if input
		usuario=input[0].to_s
		email=input[1].to_s
		numserie=SSLicencia.sacaclave(input[1].to_s+SSMac)
		defaultkey=SSLicencia.sacaclave(numserie)
		clave=input[2].to_s
		wd=UI::WebDialog.new(SSStrings.GetString("Authorize")+'...')
		param='request=activation'
		param=param+'&email='+email
		param=param+'&licence_key='+clave
		param=param+'&product_id=SOLIDSECTION'
		param=param+'&instance='+numserie
		wd.set_url("http://www.dibac.com/wp-content/plugins/woocommerce-software-add-on/licencias/licencias-dibac.php?"+param)
		wd.set_size(200,200)
		wd.set_position(600,400)
		wd.show{	
			mensaje=wd.get_element_value("miprueba")
			#UI.messagebox('Respuesta del servidor: '+mensaje)
			if mensaje[13..16] =='true'
				texto=SSStrings.GetString("Your license has been activated successfully. Thank you.")
				Sketchup.write_default("SolidSection","User",usuario)
				Sketchup.write_default("SolidSection","Email",email)
				Sketchup.write_default("SolidSection","Serial",numserie)
				Sketchup.write_default("SolidSection","Key",clave)
				Sketchup.write_default("Preferences","ValidDefaultSerial",defaultkey)
				datos_licencia(false)
			elsif  mensaje[10..17] =='Exceeded'
				texto=SSStrings.GetString("Unable to activate license: no more activations available.")
			else
				texto=SSStrings.GetString("Invalid license. Please check the email and auth number and try again.")
			end	
			UI.messagebox(texto)
			Sketchup.active_model.active_view.invalidate
			wd.close
		}
	end
end	
def licencia_desautorizar
	return false if !conexion_valida
	texto = SSStrings.GetString("You are about to remove the authorization to use")+' '+SSStrings.GetString('Solid Section')
	texto=texto+'. '+SSStrings.GetString("You can not run again if the product does not authorize a valid license.")+"\n"
	texto=texto+' '+SSStrings.GetString("Are you sure you want to continue?")
	if UI.messagebox(texto, MB_YESNO) == 6 then
		wd=UI::WebDialog.new(SSStrings.GetString("Unathorize")+'...')
		param='request=deactivation'
		param=param+'&email='+@@email
		param=param+'&licence_key='+@@clave
		param=param+'&product_id=SOLIDSECTION'
		param=param+'&instance='+@@numserie
		wd.set_url("http://www.dibac.com/wp-content/plugins/woocommerce-software-add-on/licencias/licencias-dibac.php?"+param)
		wd.set_size(200,200)
		wd.set_position(600,400)
		wd.show{	
			mensaje=wd.get_element_value("miprueba")
			if mensaje[9..12] =='true'
				texto=SSStrings.GetString("Your license has been de-activated successfully.")
				Sketchup.write_default("SolidSection","User","")
				Sketchup.write_default("SolidSection","Email","")
				Sketchup.write_default("SolidSection","Serial","")
				Sketchup.write_default("SolidSection","Key","")
				Sketchup.write_default("Preferences","ValidDefaultSerial","")
				#SSHoraInicio = Time.now
				datos_licencia(true)
			else
				texto=SSStrings.GetString("Error deactivating your license.")
			end
			UI.messagebox(texto)
			Sketchup.active_model.active_view.invalidate
			wd.close
		}	
	end	
end	
def initialize
	@@seccion=nil
	datos_licencia(true)
	unless file_loaded?("SolidSection.rbs")
		Sketchup.add_observer(SS_ObservadorApp.new)
		Sketchup.active_model.add_observer(SS_ObservadorModel.new)
		SeccionSolida.iniciosecciones
		licencia=SSLicencia.licencia(false)[2]
		if !Iscarnet_SS.version.index('Dibac') #|| SSLicencia.licencia(false)[2] == ""
			#add_separator_to_menu("Help") if !$DibacLicencia
			menu = UI.menu("Plugins").add_submenu(SSStrings.GetString("Solid Section"))
			item=menu.add_item(SSStrings.GetString("License Information")) {datos_licencia(false)
																															SSLicencia.informacion(@@datoslicencia)}
			SSStrings.unchecked(menu,item)	
			item=menu.add_item(SSStrings.GetString("Authorize")+'...'){licencia_autorizar}
			menu.set_validation_proc(item){
				MF_UNCHECKED
				if @@numserie != '' && @@numserie != 'promo' && !@@numserie.index('Dibac')
					MF_GRAYED
				else
					MF_ENABLED
				end	
			}
			item = menu.add_item(SSStrings.GetString("Unauthorize")){licencia_desautorizar}
			menu.set_validation_proc(item){
				MF_UNCHECKED
				if @@numserie == '' or @@numserie == 'promo' or @@numserie.index('Dibac')
					MF_GRAYED
				else
					MF_ENABLED
				end	
			}
		end
		UI.add_context_menu_handler do | menu |
			section = SeccionSolida.valida
			if section
				menu.add_separator
				opcionmenu = menu.add_item(SSStrings.GetString("Solid Section")) {SeccionSolida.fija_gruposeccion(nil, section, false)}
				menu.add_item(SSStrings.GetString("Create group Solid Section")) {SeccionSolida.fija_gruposeccion(SSStrings.GetString("Create group Solid Section"), section, false)}
				menu.add_item(SSStrings.GetString("Create group Dibac Plan"))  {SeccionSolida.fija_gruposeccion(SSStrings.GetString("Create group Dibac Plan"), section, true)} if (section.get_plane[2].abs == 1 && DibacLicencia)
				menu.set_validation_proc(opcionmenu) {
					if 	SeccionSolida.buscaseccion(section)	
						MF_CHECKED
					else
						MF_UNCHECKED
					end	
					
				}
			end 
		end 
	end	
	file_loaded("SolidSection.rbs")
	@@veces_que_entra = -1 #para que saque el letrero a la primera
end
end 
class SeccionSolida < SS_Inicio
def SeccionSolida::cambio(entity)
	seccion = SeccionSolida.buscaseccion(entity)
	if seccion
		material = seccion.material
		Sketchup.active_model.start_operation 'nada', false, true, true
		seccion.erase! 
		Sketchup.active_model.commit_operation
		SeccionSolida.face(nil, entity, false).material = material if SSLicencia.licencia(false)[2] != ""
	end	
end
def SeccionSolida::borrar(entity)
	seccion = SeccionSolida.buscaseccion(entity)
	Sketchup.active_model.start_operation 'nada', false, true, true
	seccion.erase! if seccion
	Sketchup.active_model.commit_operation
end	
def SeccionSolida::nolicencia(inhabilitar)
	return false if SSLicencia.licencia(false)[2] != "" 
	@@veces_que_entra +=1
	@@veces_que_entra = 0 if inhabilitar
	SSLicencia.informacion(@@datoslicencia) if (@@veces_que_entra % 1 == 0)
	Sketchup.active_model.select_tool nil if inhabilitar	
	return true
end
def SeccionSolida::primera_carpinteria(entities)
	carpinteria=nil
	for e in entities
		if e.is_a?(Sketchup::Group)
			carpinteria = primera_carpinteria(e.entities)
		 elsif e.is_a?(Sketchup::ComponentInstance)	
			return e if SeccionSolida.es_carpinteria(e)
		end if !carpinteria
	end
	return carpinteria
end
	
def SeccionSolida::es_carpinteria(carp)
	# comprobamos que esta dentro de un ComponentInstance y que es una carpinteria
	return false if !carp.definition.name.upcase.index('3D') 
	if carp.definition.name[0,12].upcase == "DIBAC_PUERTA" || carp.definition.name[0,13] .upcase== "DIBAC_VENTANA" || carp.definition.name[0,13].upcase == "DIBAC_ARMARIO"
		return true
	else
		return false
	end
end
def SeccionSolida::fija_gruposeccion(comando, section, dibac)
	seccion = SeccionSolida.buscaseccion(section)
	if seccion && !comando
		Sketchup.active_model.start_operation 'Solid Section', false, false, false
		seccion.erase! 
		Sketchup.active_model.commit_operation
		return nil
	end
	seccion=SeccionSolida.face(comando, section, dibac)
	
if dibac #comprobamos si solo hay una escalera
		if seccion.entities.count == 1
			if seccion.entities[0].get_attribute "dibac", "escalera2d"
				seccion.set_attribute "dibac", "escalera2d", (seccion.entities[0].get_attribute "dibac", "escalera2d")
				seccion.entities[0].explode
			end	
		end
	end
	if seccion && comando
		seccion.name=''
		Sketchup.active_model.selection.clear
		Sketchup.active_model.selection.add seccion
		Sketchup.send_action "selectMoveTool:"
	end
end	
def SeccionSolida::saca_gruposeccion(entities, trans, grupo, material, dibac)
	grupo_faces=@gruposeccion.entities.add_group
	grupo_edges=@gruposeccion.entities.add_group
	for e in entities
		next if e == @gruposeccion || e==grupo#para que no aplique el material
		mat_grupo=e.material
		mat_grupo=material if !mat_grupo
		entidades=nil # aqui van las entidades que no son grupo ni componente
		carpinteria=nil
		escalera=nil
		if e.is_a?(Sketchup::Group)
			if e.get_attribute("dibac","escalera3d") && dibac #es una escalera
				escalera=e 
			else	
				entidades = e.entities if !e.get_attribute("dibac","escalera2d") #no seccionamos la escalera recien creada comprobar en dibac si es escalera2d
			end
		elsif e.is_a?(Sketchup::ComponentInstance) 
			entidades = e.definition.entities
			if dibac
				if SeccionSolida.es_carpinteria(e)
					carpinteria=e
					entidades=nil
				end
			end
		end if e.visible? && e.layer.visible?
		if entidades
			SeccionSolida.saca_gruposeccion(entidades, trans*e.transformation, grupo, mat_grupo, dibac)
		elsif escalera
			grupo_comprueba = @gruposeccion.entities.add_group
			e.entities.intersect_with true, trans*e.transformation, grupo_comprueba, grupo.transformation, false, grupo
			if grupo_comprueba.entities.count>0 #comporbamos que la escalera es seccionada
				grupo_escalera = @gruposeccion.entities.add_instance(e.entities.parent, trans*e.transformation)
				grupo_escalera.name='escalera'
				punto0=Geom::Point3d.new(0,0,0)
				vector = [punto0, Geom::Vector3d.new(0,0,1)]
				punto1 = Geom.intersect_line_plane(vector, @plane)
				masalto=0
				borrar=[]
				for f in grupo_escalera.entities #borramos todas las que no son horizontales primero
					if f.is_a?(Sketchup::Face)
						if f.plane[2].abs != 1
							borrar.push(f)
							for g in f.edges
								horizontal=false
								for h in g.faces
									horizontal=true if h.plane[2].abs == 1
								end	
								borrar.push(g) if !horizontal
							end
						end
					elsif f.is_a?(Sketchup::Edge)
						borrar.push(f) if f.faces.size == 0
					else
						borrar.push(f)
					end 		
				end
				grupo_escalera.entities.erase_entities(borrar)
				for f in grupo_escalera.entities.grep(Sketchup::Face) #solo deben estar las horizontales
					punto2 = Geom.intersect_line_plane(vector, f.plane)
					altura = (punto0-punto2).length
					dist =  (punto1-punto2)
					grupo_escalera.entities.transform_entities((Geom::Transformation.translation dist), f)
					f.set_attribute "dibac", "escalon",  altura
					masalto=altura if masalto<altura
				end
				grupo_escalera.set_attribute "dibac", "escalera2d", masalto
			end
			@gruposeccion.entities.erase_entities(grupo_comprueba)
		elsif carpinteria
			#comprobamos que hay interseccion
			grupo_comprueba=@gruposeccion.entities.add_group
			e.definition.entities.intersect_with true, trans*e.transformation, grupo_comprueba, grupo.transformation, false, grupo
			if grupo_comprueba.entities.count>0	
#=be			
				if e.definition.name[0,12].upcase == "DIBAC_PUERTA"
					hoja2=e.get_attribute("dynamic_attributes", "a01hoja2",e.definition.get_attribute("dynamic_attributes", "a01hoja2", 0))
					if hoja2 != 0
						pathcarpinteria = Sketchup.find_support_file("DIBAC_PUERTA_DOBLE.skp", "Plugins/iscarnet_dibac")
					else
						pathcarpinteria = Sketchup.find_support_file("DIBAC_PUERTA.skp", "Plugins/iscarnet_dibac")
					end	
					componente = Sketchup.active_model.definitions.load(pathcarpinteria)
					Sketchup.active_model.start_operation SSStrings.GetString("Create group Dibac Plan") ,false, true, false
					carp = @gruposeccion.entities.add_instance(componente, trans*e.transformation)
					v=e.get_attribute("dynamic_attributes", "mocheta",e.definition.get_attribute("dynamic_attributes", "mocheta"))
					carp.set_attribute("dynamic_attributes", "mocheta", v)
					v=e.get_attribute("dynamic_attributes", "a01hoja1",e.definition.get_attribute("dynamic_attributes", "a01hoja1"))
					carp.set_attribute("dynamic_attributes", "a01hoja1", v)
					v=e.get_attribute("dynamic_attributes", "a01hoja2",e.definition.get_attribute("dynamic_attributes", "a01hoja2"))
					carp.set_attribute("dynamic_attributes", "a01hoja2", v)
					v=e.get_attribute("dynamic_attributes", "a02dintel",e.definition.get_attribute("dynamic_attributes", "a02dintel"))
					carp.set_attribute("dynamic_attributes", "a02dintel", v)
					v=e.get_attribute("dynamic_attributes", "a02gruesoh",e.definition.get_attribute("dynamic_attributes", "a02gruesoh"))
					carp.set_attribute("dynamic_attributes", "a02gruesoh", v)
					v=e.get_attribute("dynamic_attributes", "anchomarco",e.definition.get_attribute("dynamic_attributes", "anchomarco"))
					carp.set_attribute("dynamic_attributes", "anchomarco", v)
					v=e.get_attribute("dynamic_attributes", "gruesmarco",e.definition.get_attribute("dynamic_attributes", "gruesmarco"))
					carp.set_attribute("dynamic_attributes", "gruesmarco", v)
					v=e.get_attribute("dynamic_attributes", "a02alineac",e.definition.get_attribute("dynamic_attributes", "a02alineac"))
					carp.set_attribute("dynamic_attributes", "a02alineac", v)
					$dc_observers.get_latest_class.redraw(carp)
				elsif e.definition.name[0,13].upcase == "DIBAC_VENTANA" #and @h>=1.m
					pathcarpinteria = Sketchup.find_support_file("DIBAC_VENTANA.skp", "Plugins/iscarnet_dibac")
					componente = Sketchup.active_model.definitions.load(pathcarpinteria)
					v=(e.get_attribute "dynamic_attributes", "a03alfeizar", (e.definition.get_attribute "dynamic_attributes", "a03alfeizar")).to_f
					#if @h>=v-0.03.m #Grueso alfeizar
						Sketchup.active_model.start_operation SSStrings.GetString("Create group Dibac Plan") ,false, true, false
						carp = @gruposeccion.entities.add_instance(componente, trans*e.transformation)
						carp.set_attribute("dynamic_attributes", "a03alfeizar", v+e.transformation.origin.z) #por si he subido o bajado la ventana
						v=e.get_attribute("dynamic_attributes", "mocheta",e.definition.get_attribute("dynamic_attributes", "mocheta"))
						carp.set_attribute("dynamic_attributes", "mocheta", v)
						v=e.get_attribute("dynamic_attributes", "a01ancho",e.definition.get_attribute("dynamic_attributes", "a01ancho"))
						carp.set_attribute("dynamic_attributes", "a01ancho", v)
						v=e.get_attribute("dynamic_attributes", "a02alto",e.definition.get_attribute("dynamic_attributes", "a02alto"))
						carp.set_attribute("dynamic_attributes", "a02alto", v)
						v=e.get_attribute("dynamic_attributes", "a02hojas",e.definition.get_attribute("dynamic_attributes", "a02hojas"))
						carp.set_attribute("dynamic_attributes", "a02hojas", v)
						v=e.get_attribute("dynamic_attributes", "frontalalf",e.definition.get_attribute("dynamic_attributes", "frontalalf"))
						carp.set_attribute("dynamic_attributes", "frontalalf", v)
						v=e.get_attribute("dynamic_attributes", "carpancho",e.definition.get_attribute("dynamic_attributes", "carpancho"))
						carp.set_attribute("dynamic_attributes", "carpancho", v)
						v=e.get_attribute("dynamic_attributes", "carpgrueso",e.definition.get_attribute("dynamic_attributes", "carpgrueso"))
						carp.set_attribute("dynamic_attributes", "carpgrueso", v)
						v=e.get_attribute("dynamic_attributes", "a02alineac",e.definition.get_attribute("dynamic_attributes", "a02alineac"))
						carp.set_attribute("dynamic_attributes", "a02alineac", v)
						$dc_observers.get_latest_class.redraw(carp)
					#end	
				elsif e.definition.name[0,13].upcase == "DIBAC_ARMARIO" #and @h >= 0.07.m
					hojas=(e.get_attribute "dynamic_attributes", "a01hojas", (e.definition.get_attribute "dynamic_attributes", "a01hojas")).to_i
					if hojas == 1
						pathcarpinteria = Sketchup.find_support_file("DIBAC_ARMARIO_1.skp", "Plugins/iscarnet_dibac")
					else
						pathcarpinteria = Sketchup.find_support_file("DIBAC_ARMARIO_2.skp", "Plugins/iscarnet_dibac")
					end	
					componente = Sketchup.active_model.definitions.load(pathcarpinteria)
					v=(e.get_attribute "dynamic_attributes", "a01umbral",(e.definition.get_attribute "dynamic_attributes", "a01umbral")).to_f
					#if @h>=v
						Sketchup.active_model.start_operation SSStrings.GetString("Create group Dibac Plan") ,false, true, false
						carp = @gruposeccion.entities.add_instance(componente, trans*e.transformation)
						carp.set_attribute("dynamic_attributes", "a01umbral", v+e.transformation.origin.z) # Por si hemos subido o bajado el armario
						v=e.get_attribute("dynamic_attributes", "mocheta",e.definition.get_attribute("dynamic_attributes", "mocheta"))
						carp.set_attribute("dynamic_attributes", "mocheta", v)
						v=e.get_attribute("dynamic_attributes", "a01ancho",e.definition.get_attribute("dynamic_attributes", "a01ancho"))
						carp.set_attribute("dynamic_attributes", "a01ancho", v)
						v=e.get_attribute("dynamic_attributes", "a02dintel",e.definition.get_attribute("dynamic_attributes", "a02dintel"))
						carp.set_attribute("dynamic_attributes", "a02dintel", v)
						carp.set_attribute("dynamic_attributes", "a01hojas", hojas)
						$dc_observers.get_latest_class.redraw(carp)
					#end	
				end
#=en			
				# Ahora corregimos altura
				vector = [carp.transformation.origin, Geom::Vector3d.new(0,0,1)]
				punto = Geom.intersect_line_plane(vector, @plane)
				dist =  (punto-carp.transformation.origin)
				carp.transform!(Geom::Transformation.translation(dist))
			end	
			@gruposeccion.entities.erase_entities(grupo_comprueba)
		end
	end
	if entities
		entities.intersect_with(false, trans, grupo_faces, grupo.transformation, false, grupo)
		entities.intersect_with(false, trans, grupo_edges, grupo.transformation, false, grupo)
	end
	grupo_faces.entities.grep(Sketchup::Edge).each {|e| e.find_faces}
	grupo_edges.entities.grep(Sketchup::Edge).each {|e| e.find_faces}
	grupo_faces.entities.each do |e| 
		if e.is_a?(Sketchup::Face)
			e.reverse! if e.normal != [@plane[0], @plane[1], @plane[2]]
		elsif e.is_a?(Sketchup::Edge)
			grupo_faces.entities.erase_entities(e) if e.faces.size == 0
		end	
	end
	SeccionSolida.sacacaras(grupo_faces, material)
	borrar=[]
	grupo_edges.entities.grep(Sketchup::Edge){|e| borrar.push(e) if e.faces.size>0}
	grupo_edges.entities.erase_entities(borrar)
	lineas=grupo_edges.entities.count
	grupo_edges.explode
	if lineas>0
		@gruposeccion.entities.grep(Sketchup::Edge).each {|e| e.find_faces if e.faces.size==0}
		SeccionSolida.sacacaras(@gruposeccion, material)
	end	
end	
def SeccionSolida::sacacaras(grupo, material)	
	faces = grupo.entities.grep(Sketchup::Face)
	faces = faces.uniq
	caras = []
	while faces.size > 0
		cara = faces[0]
		for face in faces
			cara = face if face.area>cara.area
		end	
		caras.push(cara)
		faces = faces-[cara]
	end	
	for cara in caras
		borrar = true
		for edge in cara.edges
			borrar = false if edge.faces.size == 1
		end
		if borrar
			cara.erase! 
		else
			cara.reverse! if cara.normal != [ @plane[0], @plane[1], @plane[2] ]
			cara.back_material=material
		end	
	end 	
	grupo.explode if (grupo != @gruposeccion && grupo.entities.count == 0)
end
  
def SeccionSolida::face(comando, section, dibac)
	seccion = SeccionSolida.buscaseccion(section)
	return nil if seccion && !comando
	SeccionSolida.nolicencia(false)
	 
	model = Sketchup.active_model
	if(Sketchup.version.split(".")[0].to_i<5)
		UI.beep
		UI.messagebox("Sorry.  This is Version 5+ program only !")
		return nil
	end
	bounds = model.bounds
	entities = model.active_entities
	ss = model.selection
	view = model.active_view
	@plane = section.get_plane
	bmin  = bounds.min
	bmax  = bounds.max
	c1 = Geom::Point3d.new(bmin.x, bmin.y, bmin.z)
	c2 = Geom::Point3d.new(bmax.x, bmin.y, bmin.z)
	c3 = Geom::Point3d.new(bmin.x, bmin.y, bmax.z)
	c4 = Geom::Point3d.new(bmax.x, bmin.y, bmax.z)
	c5 = Geom::Point3d.new(bmin.x, bmax.y, bmax.z)
	c6 = Geom::Point3d.new(bmax.x, bmax.y, bmax.z)
	c7 = Geom::Point3d.new(bmin.x, bmax.y, bmin.z)
	c8 = Geom::Point3d.new(bmax.x, bmax.y, bmin.z)
	line1 = [c1,(c1-c2)]
	line2 = [c3,(c3-c4)]
	line3 = [c5,(c5-c6)]
	line4 = [c7,(c7-c8)]
	line5 = [c1,(c1-c3)]
	line6 = [c2,(c2-c4)]
	line7 = [c7,(c7-c5)]
	line8 = [c8,(c8-c6)]
	line9 = [c1,(c1-c7)]
	line10 = [c3,(c3-c5)]
	line11 = [c4,(c4-c6)]
	line12 = [c2,(c2-c8)]
	p1 = Geom.intersect_line_plane line1, @plane
	p2 = Geom.intersect_line_plane line2, @plane
	p3 = Geom.intersect_line_plane line3, @plane
	p4 = Geom.intersect_line_plane line4, @plane
	p5 = Geom.intersect_line_plane line5, @plane
	p6 = Geom.intersect_line_plane line6, @plane
	p7 = Geom.intersect_line_plane line7, @plane
	p8 = Geom.intersect_line_plane line8, @plane
	p9 = Geom.intersect_line_plane line9, @plane
	p10 = Geom.intersect_line_plane line10, @plane
	p11 = Geom.intersect_line_plane line11, @plane
	p12 = Geom.intersect_line_plane line12, @plane
	if dibac
		e = SeccionSolida.primera_carpinteria(entities)
		$dc_observers.get_latest_class.redraw_with_undo(e) if e
	end
	if !comando
		model.start_operation SSStrings.GetString("Solid Section") ,true, true, true
	else		
		model.start_operation comando ,false, true, false
	end	
	grupo = entities.add_group
	if p1 # No z 
		face = grupo.entities.add_face p1,p2,p3,p4
	elsif  p5 # en z
		face = grupo.entities.add_face p5,p6,p8,p7
	else
		face = grupo.entities.add_face p9,p10,p11,p12,p9
	end
	#	inicioundo("Seccion Solida")	
	@gruposeccion= entities.add_group
	@gruposeccion.name= "SS-"+section.entityID.to_s
	section.set_attribute('SolidSection', 'seccion', @gruposeccion.name) if !comando
# 	ahora recorremos el modelo desde fuera hacia dentro haciendo las intersecciones dentro de los grupos
	SeccionSolida.saca_gruposeccion(entities, grupo.transformation, grupo, nil, dibac)
	#entities.intersect_with true, grupo.transformation, gruposeccion, grupo.transformation, false, grupo
	#for e in @gruposeccion.entities
	#	if e.is_a?(Sketchup::Edge)
	#		e.find_faces
	#	end
	#end 
=begin	
	faces = @gruposeccion.entities.grep(Sketchup::Face)
	faces = faces.uniq
	caras = []
	while faces.size > 0
		cara = faces[0]
		for face in faces
			cara = face if face.area>cara.area
		end	
		caras.push(cara)
		faces = faces-[cara]
	end	
	for cara in caras
		borrar = true
		for edge in cara.edges
			borrar = false if edge.faces.size == 1
		end
		if borrar
			cara.erase! 
		else
			cara.reverse! if cara.normal != [ @plane[0], @plane[1], @plane[2] ]
		end	
	end 
=end	#esto lo pasamos a saca_gruposeccion
	if @gruposeccion.entities.count > 0
		grupo.erase! 
		# 	desplazamos la seccion 1 decima de milimetro
		vector=Geom::Vector3d.new(@plane[0],@plane[1],@plane[2])
		tpoint=ORIGIN.offset(vector,0.1.mm)
		transf = Geom::Transformation.new tpoint
		@gruposeccion.move! transf
	#else
	end
# 	finalundo
	#model.commit_operation
	Sketchup.active_model.start_operation "", false, false, false
	view.invalidate
	return(@gruposeccion) if @gruposeccion.entities.count > 0
	grupo.name="SS-"+section.entityID.to_s
	grupo.visible=false
	return grupo
	return nil
end	
def SeccionSolida::valida
	model = Sketchup.active_model
	ss = model.selection
	return ss[0] if !ss.empty? && ss[0].is_a?(Sketchup::SectionPlane)
end 
def SeccionSolida::iniciosecciones
	Sketchup.active_model.active_entities.add_observer(SS_ObservadorEntities.new)
	for e in Sketchup.active_model.active_entities.grep(Sketchup::SectionPlane)
		e.add_observer(SS_ObservadorSeccion.new)
		seccion = SeccionSolida.buscaseccion(e)
		if seccion
			seccion.name="SS-"+e.entityID.to_s
			e.set_attribute('SolidSection', 'seccion', seccion.name)
		end	
	end	
end	
def SeccionSolida::buscaseccion(seccion)
	for e in Sketchup.active_model.active_entities.grep(Sketchup::Group)
		 return e if (e.name == seccion.get_attribute('SolidSection', 'seccion') || e.name == "SS-"+seccion.entityID.abs.to_s)
	end
	return nil
end	
end # de la clase SeccionSolida
module_function
def seccion; @seccion end
def seccion= v; @seccion = v end
def borrar; @borrar end
def borrar= v; @borrar = v end
@paths=[Sketchup.active_model.active_entities]
def paths; @paths end
def paths= v; @paths.push(v) end

dibac=false
Sketchup.extensions.each do |e| 
	Iscarnet_SS=e if e.name=='SolidSection'
	if e.name=='Dibac'
		#if e.loaded?
			paso=e.description.split'#'
			if paso.size==2
				dibac=paso[1]
				e.description=paso[0]
			end
		#end		
	end	
end		
if dibac
	DibacLicencia = Dibac_Licencia.new 
else
	DibacLicencia = nil
end	
SSStrings = SS_Lenguaje.new
SSLicencia = SS_Licencia.new
if dibac
	SSMac=dibac
	DibacMac=dibac
else	
	SSMac = Mac.address 
	DibacMac = Mac.address
end	
SSHoraInicio = Time.now
DibacHoraInicio = Time.now
SS_Inicio.new
end
end
