=begin
 Copyright 2010, Jaime Díaz
 ESTE SOFTWARE SE ENTREGA "TAL CUAL", SIN NINGUNA GARANTÍA EXPRESA O IMPLÍCITA, 
 INCLUYENDO, SIN LIMITACIÓN, LAS GARANTÍAS DE COMERCIALIZACIÓN Y APTITUD 
 PARA UN PROPÓSITO PARTICULAR.
---------------------------------------------------------------------------------------------------
 Nombre        		:	Dibac 1.0.10
 Descripción   		:	Un conjunto de herramientas para crear distribuciones en planta y 3D
 -------------------------------- CLASES ---------------------------------------------------------		  		
 ObservadorApp	:	Llama a Observ adorTools con cada nuevo documento
 ObservadorTools 	:   Sobreescribe la funcion borrar 
 Dibac       			:   Clase Raiz. Contiene procedimientos comunes.
 Borrar       			:   Borrado inteligente de elementos de dibac.
 Muro         			:   Dibuja muros en planta
 Murop        			:   Dibuja muros paralelos a una arista.
 EstiraMuro       	:   Alarga muros y realiza las conexiones con otros
 Carpinteria   		:   Clase raiz de carpinterias, contiene las propiedades comunes
 Puerta        			:   Procedimientos particulares para colocar puertas
 Ventana     			:   Procedimientos particulares para colocar ventanas
 Armario    			:   Procedimientos particulares para colocar armarios
 CotaContinua		:   Acota automaticamente distribuciones interiores y fachadas
 ImprimeDibac		:   Imprime utilizando el gestor de impresion de Dibac
 TresDimensiones	:   Crea un modelo en 3D a partir de la distribucion en planta
 Escalera				:	Dibuja escaleras generadas automaticamente o por recorrido
					
 Fecha        			:	03/07/2013
 Tipo        				:	Conjunto de Herramientas
---------------------------------------------------------------------------------------------------
=end
module Iscarnet_Extensions
module Mac
##
# Cross platform MAC address determination.  Works for:
# * /sbin/ifconfig
# * /bin/ifconfig
# * ifconfig
# * ipconfig /all
#
# To return the first MAC address on the system:
#
#   Mac.address
#
# To return an array of all MAC addresses:
#
#   Mac.address.list
  #VERSION = '1.0.0' 
  #def Mac.version() ::Mac::VERSION end
  class << self
    ##
    # Accessor for the system's first MAC address, requires a call to #address
    # first
    attr_accessor "mac_address"
    ##
    # Discovers and returns the system's MAC addresses.  Returns the first
    # MAC address, and includes an accessor #list for the remaining addresses:
    #
    #   Mac.addr # => first address
    #   Mac.addr.list # => all addresses
    def address
	@mac_address="00-00-00-00-00-00"
      return @mac_address if defined? @mac_address and @mac_address
      re = %r/[^:\-](?:[0-9A-F][0-9A-F][:\-]){5}[0-9A-F][0-9A-F][^:\-]/io
	
      cmds = '/sbin/ifconfig', '/bin/ifconfig', 'ifconfig', 'ipconfig /all'
		null = test(?e, '/dev/null') ? '/dev/null' : 'NUL'
		cmd = 'ipconfig /all' if Mac.win
		cmd = 'ifconfig' if Mac.mac
		regex = Regexp.compile('(..[:-]){5}..')
		lines = nil
      #cmds.each do |cmd|
		Dir::chdir( RUBY_PLATFORM !~ /darwin/i ? "#{ENV['USERPROFILE']}/Desktop" : "~/Desktop" ){
		IO.popen("#{ cmd } 2> #{ null }> my_pipe") {|fd| fd.readlines}
		#IO.popen("ipconfig/all >temp.txt") {|fd| fd.readlines}
		
		lines = open("my_pipe", :encoding => 'ISO-8859-1').readlines		
		#puts(lines)
		#stdout = %x[#{ cmd } 2> #{ null }]
		#UI.messagebox(stdout)
      #next unless stdout and stdout.size > 0
		#UI.messagebox(lines)
	   #end
      raise "all of #{ cmds.join ' ' } failed" unless lines
      raise "all of comands failed" unless lines
	
	candidates=[]
	#candidates = lines.select{|line| line =~ re}
	candidates = lines.select{|line| re.match(line.encode("utf-8", replace: nil))}
	
	
	
	#UI.messagebox ('Buscando candidatos')
	  
	#UI.messagebox('candidatos='+candidates.to_s)
   
begin	
	raise 'no mac address candidates' unless candidates.first
      candidates.map!{|c| c[re].strip}
      maddr = candidates.first
      raise 'no mac address found' unless maddr
      maddr.strip!
      maddr.instance_eval{ @list = candidates; def list() @list end }
      @mac_address = maddr
end
}
end
    ##
    # Shorter alias for #address
    alias_method "addr", "address"
end
	
	module_function
	def mac; @mac end
	def mac= v; @mac = v end
	def win; @win end
	def win= v; @win = v end
	Mac.mac =( Object::RUBY_PLATFORM =~ /darwin/i ? true : false ) 
	Mac.win =((Object::RUBY_PLATFORM =~ /mswin/i || Object::RUBY_PLATFORM =~ /mingw/i) ? true : false ) 
end # del moculo Mac
module Dibac_Extension
require "sketchup" 
require "extensions" 
class Dibac_Lenguaje
def initialize
    @strings =Hash.new
    self.ParseLangFile
	#iscarnet_dibac=nil
	#Sketchup.extensions.each{|e| iscarnet_dibac=e if e.name=='Dibac'}
  end
def ParseLangFile
	@strings.clear
	file_rec = Sketchup.find_support_file("Dibac.strings", "plugins//indoor"+"//resources//"+(Sketchup.read_default("Dibac","Language",Sketchup.get_locale[0,2])))
    if file_rec==nil || file_rec.length==0
      return false
    end
    langFile = File.open(file_rec, "r")
    entryString = ""
    inComment = false
    langFile.each do |line|
      #ignore simple comment lines - BIG assumption the whole line is a comment
      if !line.include?("//")
        #also ignore comment blocks
        if line.include?("/*")
          inComment = true
        end
        if inComment==true
          if line.include?("*/")
            inComment=false
          end
        else
          entryString += line
        end
      end
      if entryString.include?(";")
        #parse the string into key and value
        
        #remove the white space
        entryString.strip!
        #pull out the key
        keyvalue = entryString.split("\"=\"")
        
        #strip the leading quotation out
        key = keyvalue[0][(keyvalue[0].index("\"")+1)..(keyvalue[0].length+1)]
		result=keyvalue[1].to_s
 		#pull out the value
		result.gsub!(";", "")
        value = result.gsub("\"", "") 
        #add to @strings
        @strings[key]=value
        entryString = ""
      end
    end
	langFile.close
	Iscarnet_Dibac.description =GetString('Plugin for architectural drawing.')
    return true
  end
def GetString(key)
    #puts "GetString key = " + key.to_s
    retval = @strings[key]
    #puts "GetString retval = " + retval.to_s
    if retval!= nil
         retval.chomp!
    else
        retval = key
    end
    return retval
  end
def unchecked(menu, item) # lo metemos aqui para aprovechar el objeto DibacStrings
	menu.set_validation_proc(item)  {
		MF_UNCHECKED
	}
end
end #de la clase Dibac_Lenguaje
class Dibac_Licencia  
	
def ord(caracter)
	begin
		return caracter.ord
	rescue
		return caracter
	end	
end
	
def sacaclave(texto)	
#---------------------------------------------------------------------------------	
	modulo =128 #modulo para cambiar generacion de numeros
#---------------------------------------------------------------------------------	
	return '' if(texto==nil || texto=='')
	aleatorio1=ord(texto[0]) % modulo
	aleatorio2=ord(texto[texto.length-1]) % modulo
	i=0
	clave=''
	a=(aleatorio2 + modulo).chr
	while i<texto.length do
		a <<(aleatorio1+ord(texto[i]) % modulo).chr
		a <<(aleatorio2 + ord(a[2*i+1]) % modulo).chr
		i +=1
	end
	jj=0
	i=1
	j=(a.length)/11
	if a.length>10
		while i+j<a.length do
			for ii in 0 ... j 
				jj=jj+ord(a[i-1])
				i+=1
			end
			jj=jj % 10
			jj +=39 if jj>9
			clave=clave+(jj+48).chr
		end	
	end 
	return clave
end
def licencia (grabar)
	# usuario		= Sketchup.read_default("Dibac","User","")
	# email		= Sketchup.read_default("Dibac","Email","")
	# numserie	= Sketchup.read_default("Dibac","Serial","")
	# clave		= Sketchup.read_default("Dibac","Key","")
	# defaultkey	= Sketchup.read_default("Preferences","ValidDefaultKey","")
usuario ="-AFU-全屋定制"
email="afu321.com"
numserie="0000-0000-0000"
clave=""
defaultkey=""	
return [usuario,email,numserie,clave,defaultkey]
	num1=sacaclave(email+DibacMac)
	num2=sacaclave(num1)
	if((num1 != numserie) || (num2 != defaultkey))
		if numserie != ""
			usuario		= ""
			Sketchup.write_default("Dibac","User","")
			email		= ""
			Sketchup.write_default("Dibac","Email","")
			numserie	= ""
			Sketchup.write_default("Dibac","Serial","")
			Sketchup.write_default("Dibac","Key","")
			defaultkey=""
			num1=sacaclave(email+DibacMac)
			num2=sacaclave(num1)
		end
		if (defaultkey.to_i-num2.to_i).abs > 57600 || defaultkey.to_i-num2.to_i < 0
			defaultkey = num2
			grabar=true
		end	
		tiempo_uso = (Time.now - DibacHoraInicio).to_i
		tiempo_tope = (num2.to_i  + 57600) #16 horas
		tiempo_actual = defaultkey.to_i
		if tiempo_actual < tiempo_tope
			acumulado= tiempo_actual+tiempo_uso
			acumulado= tiempo_tope if acumulado > tiempo_tope
			Sketchup.write_default("Preferences","ValidDefaultKey", acumulado.to_s) if grabar
			numserie='promo' 
			diff = (tiempo_tope-acumulado)
			seconds = diff % 60
			minutes = (diff / 60) % 60
			hours = diff / 3600
			defaultkey= hours.to_s+':'+minutes.to_s+':'+seconds.to_s	
		else
			numserie = ""
			defaultkey=""
		end	
	end
	return [usuario,email,numserie,clave,defaultkey]
end
def informacion(datoslicencia)
	usuario=datoslicencia[0]
	email=datoslicencia[1]
	numserie=datoslicencia[2]
	clave=datoslicencia[3]
	defaultkey=datoslicencia[4]
	texto=DibacStrings.GetString('Dibac for Sketchup')+"\n" + Iscarnet_Dibac.description + "\n"
	if numserie == 'promo'
		texto=texto + DibacStrings.GetString("Promotional license")+"  ("+defaultkey+")"
	elsif clave != '' 
		texto = texto + DibacStrings.GetString('User') + ": " + usuario + " - " + email + "\n"
		texto=texto + DibacStrings.GetString('Serial number') + ": " + numserie
	else
		texto=texto+DibacStrings.GetString("Sorry. Your promotional license has expired.")+"\n"
		texto=texto+DibacStrings.GetString("Please contact your dealer.")+"\n"+"www.dibac.com"
	end	
	UI.messagebox(texto)
end
end #de la clase Dibac_Licencia
=begin
class Dibac_ObservadorModel < Sketchup::ModelObserver
def onActivePathChanged(model)
	return if Dibac_Extension.paths.include?(model.active_entities)
	Dibac_Extension.paths = model.active_entities
	model.active_entities.add_observer(Dibac_ObservadorEntities.new)
end
end
=end
class Dibac_ObservadorApp < Sketchup::AppObserver
def onNewModel(model)
	model.tools.add_observer(Dibac_ObservadorTools.new)
	model.tools.add_observer(Dibac_ObservadorTools.new)
	#model.entities.add_observer(Dibac_ObservadorEntities.new)
end
def onOpenModel(model)
	model.tools.add_observer(Dibac_ObservadorTools.new)
	#Sketchup.active_model.entities.add_observer(Dibac_ObservadorEntities.new)
end
def onQuit()
	DibacLicencia.licencia(true)
end

end # de la clase Dibac_ObservadorApp
 
=begin
class Dibac_ObservadorEntities < Sketchup::EntitiesObserver
def onElementAdded(entities, entity)
	if entity.is_a?(Sketchup::Group)
		Sketchup.active_model.start_operation('08-02-14',true,true,true)
		entity.name=entity.name
		Sketchup.active_model.commit_operation
	end	
end
end	
=end 
class Dibac_ObservadorTools < Sketchup::ToolsObserver
# def onActiveToolChanged(tools, tool_name, tool_id)
# 	# Aqui metemos la licencia por horas
# 	Sketchup.active_model.select_tool Dibac_Borrar.new if tool_id == 21019
# end
end # de la clase Dibac_ObservadorTools
class Dibac_Inicio  #Aqui inicializamos las variables de clase
def conexion_valida
	return true if Sketchup.is_online
	UI.messagebox(DibacStrings.GetString("No Internet connection"))
	return false	
end
def datos_licencia(grabar)
	datoslicencia=DibacLicencia.licencia(grabar)
	@@usuario=datoslicencia[0]
	@@email=datoslicencia[1]
	@@numserie=datoslicencia[2]
	@@clave=datoslicencia[3]
	@@defaultkey=datoslicencia[4]
	@@datoslicencia=[@@usuario,@@email,@@numserie,@@clave,@@defaultkey]
end
def licencia_autorizar
	return false if !conexion_valida
	
	#UI.messagebox('Hay conexion a internet')
	
	prompts = 	[	DibacStrings.GetString("User")+":",
							DibacStrings.GetString("E_mail")+":",
							#DibacStrings.GetString("Serial number")+":",
							DibacStrings.GetString("Authorization number")+":     "
						]
						
	defaults = 	[	"",
							"",
							#"",
							""
						]
						
	list = 			[	"",
							"",
							#"",
							""
						]
	input = UI.inputbox prompts, defaults, list,DibacStrings.GetString("Dibac for Sketchup")+": "+DibacStrings.GetString("User License")
	if input
		usuario=input[0].to_s
		email=input[1].to_s
		numserie=DibacLicencia.sacaclave(input[1].to_s+DibacMac)
		defaultkey=DibacLicencia.sacaclave(numserie)
		clave=input[2].to_s
		wd=UI::WebDialog.new(DibacStrings.GetString("Authorize")+'...')
		param='request=activation'
		param=param+'&email='+email
		param=param+'&licence_key='+clave
		param=param+'&product_id=DIBAC'
		param=param+'&instance='+numserie
		wd.set_url("http://www.dibac.com/wp-content/plugins/woocommerce-software-add-on/licencias/licencias-dibac.php?"+param)
		wd.set_size(200,200)
		wd.set_position(600,400)
		wd.show{	
			mensaje=wd.get_element_value("miprueba")
			#UI.messagebox('Respuesta del servidor: '+mensaje)
			if mensaje[13..16] =='true'
				texto=DibacStrings.GetString("Your license has been activated successfully. Thank you.")
				Sketchup.write_default("Dibac","User",usuario)
				Sketchup.write_default("Dibac","Email",email)
				Sketchup.write_default("Dibac","Serial",numserie)
				Sketchup.write_default("Dibac","Key",clave)
				Sketchup.write_default("Preferences","ValidDefaultKey",defaultkey)
				datos_licencia(false)
			elsif  mensaje[10..17] =='Exceeded'
				texto=DibacStrings.GetString("Unable to activate license: no more activations available.")
			else
				texto=DibacStrings.GetString("Invalid license. Please check the email and auth number and try again.")
			end	
			UI.messagebox(texto)
			Sketchup.active_model.active_view.invalidate
			wd.close
		}
	end
end	
def licencia_desautorizar
	return false if !conexion_valida
	texto = DibacStrings.GetString("You are about to remove the authorization to use")+' '+DibacStrings.GetString('Dibac for Sketchup')
	texto=texto+'. '+DibacStrings.GetString("You can not run again if the product does not authorize a valid license.")+"\n"
	texto=texto+' '+DibacStrings.GetString("Are you sure you want to continue?")
	if UI.messagebox(texto, MB_YESNO) == 6 then
		wd=UI::WebDialog.new(DibacStrings.GetString("Unathorize")+'...')
		param='request=deactivation'
		param=param+'&email='+@@email
		param=param+'&licence_key='+@@clave
		param=param+'&product_id=DIBAC'
		param=param+'&instance='+@@numserie
		wd.set_url("http://www.dibac.com/wp-content/plugins/woocommerce-software-add-on/licencias/licencias-dibac.php?"+param)
		wd.set_size(200,200)
		wd.set_position(600,400)
		wd.show{	
			mensaje=wd.get_element_value("miprueba")
			if mensaje[9..12] =='true'
				texto=DibacStrings.GetString("Your license has been de-activated successfully.")
				Sketchup.write_default("Dibac","User","")
				Sketchup.write_default("Dibac","Email","")
				Sketchup.write_default("Dibac","Serial","")
				Sketchup.write_default("Dibac","Key","")
				Sketchup.write_default("Preferences","ValidDefaultKey","")
				#DibacHoraInicio = Time.now
				datos_licencia(true)
			else
				texto=DibacStrings.GetString("Error deactivating your license.")
			end
			UI.messagebox(texto)
			Sketchup.active_model.active_view.invalidate
			wd.close
		}	
	end	
end	
def initialize
	if !file_loaded?("dibac_cmd.rb")
		datos_licencia(true)
		#buscamos signo decimal
		s=9.1.mm.to_s
		@@coma=s[1].chr
		if(s[1].chr) =='.'
			@@separador_listas=','
		else
			@@separador_listas=';'
		end
		#Observadores
		Sketchup.add_observer(Dibac_ObservadorApp.new)
		#Sketchup.active_model.add_observer(Dibac_ObservadorModel.new)
		#Sketchup.active_model.entities.add_observer(Dibac_ObservadorEntities.new)
		Sketchup.active_model.tools.add_observer(Dibac_ObservadorTools.new)
		#Muro
		@@murocmd = UI::Command.new("Muro") { Sketchup.active_model.select_tool Dibac_Muro.new }
		@@murocmd.small_icon =Sketchup.find_support_file "muro.png","plugins/indoor"
		@@murocmd.large_icon =Sketchup.find_support_file "muro.png","plugins/indoor"
		@@murocmd.tooltip = %Q(绘制墙体) 
		@@murocmd.status_bar_text = ("从一个点到另一个点的方式来生成墙体的平面图。")
		#Muro paralelo
		@@muropcmd = UI::Command.new("Muro paralelo") { Sketchup.active_model.select_tool Dibac_Murop.new }
		@@muropcmd.small_icon =Sketchup.find_support_file("murop.png","plugins/indoor")
		@@muropcmd.large_icon = Sketchup.find_support_file("murop.png","plugins/indoor")
		@@muropcmd.tooltip = %Q(偏移墙体) 
		@@muropcmd.status_bar_text = ("根据选定的边线偏移墙体。")
		#Estirar muros
		@@Estiramurocmd = UI::Command.new("Prolongar muro") { Sketchup.active_model.select_tool Dibac_Estiramuro.new }
		@@Estiramurocmd.small_icon = Sketchup.find_support_file("estirarmuro.png","plugins/indoor")
		@@Estiramurocmd.large_icon = Sketchup.find_support_file("estirarmuro.png","plugins/indoor")
		@@Estiramurocmd.tooltip = %Q(延伸墙体) 
		@@Estiramurocmd.status_bar_text = ("延长 / 缩短墙体。")
		#Puertas
		#@@puertacmd = UI::Command.new("Puerta") { Sketchup.active_model.select_tool Dibac_Puerta.new }
		#@@puertacmd.small_icon = Sketchup.find_support_file("puerta.png","plugins/indoor")
		#@@puertacmd.large_icon = Sketchup.find_support_file("puerta.png","plugins/indoor")
		#@@puertacmd.tooltip = DibacStrings.GetString("Door")
		#@@puertacmd.status_bar_text = DibacStrings.GetString("Place doors in walls.")
		#Ventanas
		#@@ventanacmd = UI::Command.new("Ventana") { Sketchup.active_model.select_tool Dibac_Ventana.new }
		#@@ventanacmd.small_icon = Sketchup.find_support_file("ventana.png","plugins/indoor")
		#@@ventanacmd.large_icon = Sketchup.find_support_file("ventana.png","plugins/indoor")
		#@@ventanacmd.tooltip = DibacStrings.GetString("Window")
		#@@ventanacmd.status_bar_text = DibacStrings.GetString("Place windows in walls.")
		#Armarios
		#@@armariocmd = UI::Command.new("Armario") { Sketchup.active_model.select_tool Dibac_Armario.new }
		#@@armariocmd.small_icon = Sketchup.find_support_file("armario.png","plugins/indoor")
		#@@armariocmd.large_icon = Sketchup.find_support_file("armario.png","plugins/indoor")
		#@@armariocmd.tooltip = DibacStrings.GetString("Wardrobe")
		#@@armariocmd.status_bar_text = DibacStrings.GetString("Place wardrobes in walls.")
		#Elegir
		#@@elegircmd = UI::Command.new("Elegir") { Sketchup.active_model.select_tool Dibac_Elegir.new }
		#@@elegircmd.small_icon = Sketchup.find_support_file("elegir.png","plugins/indoor")
		#@@elegircmd.large_icon = Sketchup.find_support_file("elegir.png","plugins/indoor")
		#@@elegircmd.tooltip = DibacStrings.GetString("Choose joinery")
		#@@elegircmd.status_bar_text = DibacStrings.GetString("Place select joinery in walls.")
		#Mobiliario
		#@@mobiliariocmd = UI::Command.new("Mobiliario") { Sketchup.active_model.select_tool Dibac_Mobiliario.new }
		#@@mobiliariocmd.small_icon = Sketchup.find_support_file("mesa.png","plugins/indoor")
		#@@mobiliariocmd.large_icon = Sketchup.find_support_file("mesa.png","plugins/indoor")
		#@@mobiliariocmd.tooltip = DibacStrings.GetString("Component")
		#@@mobiliariocmd.status_bar_text = DibacStrings.GetString("Place components.")
		#borrarcmd = UI::Command.new("Borrar") { Sketchup.active_model.select_tool Borrar.new }
		#path_comando = Sketchup.find_support_file "Borrar.png", "Plugins//indoor"
		#borrarcmd.small_icon = path_comando if path_comando
		#borrarcmd.large_icon = path_comando if path_comando
		#Escaleras
		#@@escaleracmd = UI::Command.new("Escalera") { Sketchup.active_model.select_tool Dibac_Escalera.new }
		#@@escaleracmd.small_icon = Sketchup.find_support_file("escalera.png","plugins/indoor")
		#@@escaleracmd.large_icon = Sketchup.find_support_file("escalera.png","plugins/indoor")
		#@@escaleracmd.tooltip = DibacStrings.GetString("Stair")
		#@@escaleracmd.status_bar_text = DibacStrings.GetString("Draw stairs from point to point or by path.")
		#Acotado continuo
		#@@cotacontinuacmd = UI::Command.new("Acotado continuo") { Sketchup.active_model.select_tool Dibac_CotaContinua.new }
		#@@cotacontinuacmd.small_icon =  Sketchup.find_support_file("cotacontinua.png","plugins/indoor")
		#@@cotacontinuacmd.large_icon = Sketchup.find_support_file("cotacontinua.png","plugins/indoor")
		#@@cotacontinuacmd.tooltip = DibacStrings.GetString("Continuous dimension")
		#@@cotacontinuacmd.status_bar_text = DibacStrings.GetString("Continuous interior dimensions between two points.")
		#Licencia
		#licenciacmd = UI::Command.new("Informacion de licencia") { Sketchup.active_model.select_tool Licencia.new }
		#path_comando = Sketchup.find_support_file "Usuario.png", "Plugins//indoor"
		#licenciacmd.small_icon = path_comando if path_comando
		#licenciacmd.large_icon = path_comando if path_comando
		#licenciacmd.tooltip = DibacStrings.GetString("User License")
		#Preferencias
		#@@preferenciascmd = UI::Command.new("Preferencias") { Sketchup.active_model.select_tool Dibac_Preferencias.new }
		#@@preferenciascmd.small_icon = Sketchup.find_support_file("preferencias.png","plugins/indoor")
		#@@preferenciascmd.large_icon = Sketchup.find_support_file("preferencias.png","plugins/indoor")
		#@@preferenciascmd.tooltip = DibacStrings.GetString("Options")
		#@@preferenciascmd.status_bar_text = DibacStrings.GetString("Select language")	
		#Impresion Dibac
		#imprimedibaccmd = UI::Command.new("Impresión Dibac") { Sketchup.active_model.select_tool ImprimeDibac.new }
		#path_comando = Sketchup.find_support_file "Impresora.png", "Plugins//indoor"
		#imprimedibaccmd.small_icon = path_comando if path_comando
		#imprimedibaccmd.large_icon = path_comando if path_comando
		#imprimedibaccmd.tooltip = DibacStrings.GetString("Print Dibac")
		@@tresdcmd = UI::Command.new("Convertir en 3D") { Sketchup.active_model.select_tool Dibac_TresDimensiones.new }
		@@tresdcmd.small_icon = Sketchup.find_support_file("3d.png","plugins/indoor")
		@@tresdcmd.large_icon = Sketchup.find_support_file("3d.png","plugins/indoor")
		@@tresdcmd.tooltip = %Q(生成三维墙体) 	
		@@tresdcmd.status_bar_text = ("根据自定义的高度，把 2D 的平面图墙体生成 3D 墙体。")
		#colorescmd = UI::Command.new("Color de lineas") { Sketchup.active_model.select_tool Colores.new }
		#path_comando = Sketchup.find_support_file "colores.png", "Plugins//indoor"
		#colorescmd.small_icon = path_comando if path_comando
		#colorescmd.large_icon = path_comando if path_comando
		barradibac = UI::Toolbar.new "TC-绘制墙体v2.1.0"
		@@murocursor_id = nil
		@@muropcursor_id = nil
		@@estiramurocursor_id = nil
		murocursor_path = Sketchup.find_support_file("cursormuro.png", "Plugins/indoor")
		muropcursor_path = Sketchup.find_support_file("cursormurop.png", "Plugins/indoor")
		estiramurocursor_path = Sketchup.find_support_file("cursorestirarmuro.png", "Plugins/indoor")
		escaleracursor_path = Sketchup.find_support_file("cursorescalera.png", "Plugins/indoor")
		if Sketchup.version_number <=8000999
			borrarcursor_path = Sketchup.find_support_file("cursorborrar.png", "Plugins/indoor")
			@@borrarcursor_id = UI.create_cursor(borrarcursor_path, 5,21) if borrarcursor_path 
		else
			borrarcursor_path = Sketchup.find_support_file("cursorborrar2013.png", "Plugins/indoor")
			@@borrarcursor_id = UI.create_cursor(borrarcursor_path, 7,23) if borrarcursor_path 
		end
		borrarcursordibac_path = Sketchup.find_support_file("cursorborrardibac.png", "Plugins/indoor")
		@@murocursor_id = UI.create_cursor(murocursor_path, 4,28) if murocursor_path 
		@@muropcursor_id = UI.create_cursor(muropcursor_path, 6,27) if muropcursor_path 
		@@estiramurocursor_id = UI.create_cursor(estiramurocursor_path, 4,28) if estiramurocursor_path 
		@@escaleracursor_id = UI.create_cursor(escaleracursor_path, 4,28) if escaleracursor_path 
		@@borrarcursordibac_id = UI.create_cursor(borrarcursordibac_path, 5,21) if borrarcursordibac_path 
		barradibac = barradibac.add_item @@murocmd
		barradibac = barradibac.add_item @@muropcmd
		barradibac = barradibac.add_item @@Estiramurocmd
		#barradibac = barradibac.add_item @@puertacmd
		#barradibac = barradibac.add_item @@ventanacmd
		#barradibac = barradibac.add_item @@armariocmd
		#barradibac = barradibac.add_item @@elegircmd
		#barradibac = barradibac.add_item @@mobiliariocmd
		#barradibac = barradibac.add_item @@escaleracmd
		#barradibac = barradibac.add_item borrarcmd
		#barradibac = barradibac.add_item @@cotacontinuacmd
		#barradibac = barradibac.add_item imprimedibaccmd
		barradibac = barradibac.add_item @@tresdcmd
		#barradibac = barradibac.add_item @@preferenciascmd
		#barradibac = barradibac.add_item colorescmd
		barradibac.show
		add_separator_to_menu("Plugins")
		menu = UI.menu("Plugins").add_submenu("TC-绘制墙体")
		item=menu.add_item("绘制墙体") {Sketchup.active_model.select_tool Dibac_Muro.new}
		DibacStrings.unchecked(menu,item)
		item=menu.add_item("偏移墙体") {Sketchup.active_model.select_tool Dibac_Murop.new}
		DibacStrings.unchecked(menu,item)
		item=menu.add_item("延伸墙体") {Sketchup.active_model.select_tool Dibac_Estiramuro.new}
		DibacStrings.unchecked(menu,item)
		#item=menu.add_item(DibacStrings.GetString("Door")) {Sketchup.active_model.select_tool Dibac_Puerta_Nueva.new}
		#DibacStrings.unchecked(menu,item)
		#item=menu.add_item(DibacStrings.GetString("Window")) {Sketchup.active_model.select_tool Dibac_Ventana.new}
		#DibacStrings.unchecked(menu,item)
		#item=menu.add_item(DibacStrings.GetString("Wardrobe")) {Sketchup.active_model.select_tool Dibac_Armario.new}
		#DibacStrings.unchecked(menu,item)
		#item=menu.add_item(DibacStrings.GetString("Choose joinery")) {Sketchup.active_model.select_tool Dibac_Elegir.new}
		#DibacStrings.unchecked(menu,item)
		#item=menu.add_item(DibacStrings.GetString("Component")) {Sketchup.active_model.select_tool Dibac_Mobiliario.new}
		#DibacStrings.unchecked(menu,item)
		#item=menu.add_item(DibacStrings.GetString("Stair")) {Sketchup.active_model.select_tool Dibac_Escalera.new}
		#DibacStrings.unchecked(menu,item)
		#submenu.add_item("Borrar elentos Dibac") {Sketchup.active_model.select_tool Borrar.new}
		#item=menu.add_item(DibacStrings.GetString("Continuous dimension")) {Sketchup.active_model.select_tool Dibac_CotaContinua.new}
		#DibacStrings.unchecked(menu,item)
		#submenu.add_item("Impresion Dibac") {Sketchup.active_model.select_tool ImprimeDibac.new}
		item=menu.add_item("生成三维墙体") {Sketchup.active_model.select_tool Dibac_TresDimensiones.new}
		DibacStrings.unchecked(menu,item)
		#submenu.add_item("Color de linea") {Sketchup.active_model.select_tool Colores.new}
		#menu = UI.menu("Plugins").add_submenu("TC-绘制墙体")
	
	
		@@hv = [1,0]
		@@muro_width  = 0.25.m
		@@muro_gruesos = [0.07,0.10,0.15,0.25,0.40,0.50]
		@@muro_cara = 0
		@@muro_inc = true
		@@forzar_carpinteria=false
		@@puerta_ancho_marco = 0.04.m
		@@puerta_hueco = 0
		@@ventana_hueco = 0
		@@armario_hueco = 0
		@@elegir_hueco=0
		@@escalera_width = 1.0.m
		@@escalera_height = 3.3.m
		@@escalera_cara = 0
		@@escalera_inc = true
		@@escalera_huella = 0.30.m
		@@escalera_huellamin = 0.27.m
		@@escalera_tabica = 0.18.m
		@@escalera_tabicamax= 0.20.m
		@@escalera_slope= 0.63.m
		@@cota_minima = 0.25.m
		@@altura_planta = 3.00.m
		@@crear_grupo = false #Poner a true para conservar 2D por defecto
		@@color_lineas =  "<Ninguno>"
		@@color_superficies =  "<Ninguno>"
		@@color_seleccion =  "<Ninguno>"
		@@veces_que_entra = -1 #para que saque el letrero a la primera
		file_loaded("dibac_cmd.rb")
	end	
end
end #de la clase Dibac_Inicio
class Dibac_Base < Dibac_Inicio
=begin
 Clase	        		:	DibacBase
 Desciende de		:	
 Descripción   		:	Contiene funciones comunes a todos los descendientes
 Item de Menu  	:	
 Menú contextual	:	NO
 Uso         			:	
 Fecha        			:	14/11/2010
=end
def a_longitud(valor)
	valor=con_coma(valor.to_s,nil)
	begin
		numero=valor.to_l
	rescue	
		numero = 0
	end
	return(numero)
end	
def a_float
	valor = con_punto(valor.to_s)
	begin
		numero=valor.to_f
	rescue
		numero=0
	end
	return(numero)
end	
def activate
	nolicencia(false)
	Sketchup.active_model.active_view.invalidate
	menu
end	
def ancho_carpinteria(carp)
	if carp.definition.name[0,12].upcase == "DIBAC_PUERTA"
		#carp.definition.attribute_dictionaries.each {|a| puts(a.name)}
		#attrdict=carp.definition.attribute_dictionary 'dynamic_attributes'
		#attrdict.each { | key, value |
		#puts key.to_s + '=' + value.to_s
		#					}		
		ancho =(carp.get_attribute "dynamic_attributes", "a01hoja1",(carp.definition.get_attribute "dynamic_attributes", "a01hoja1", 0)).to_f.to_l+
				(carp.get_attribute "dynamic_attributes", "a01hoja2",(carp.definition.get_attribute "dynamic_attributes", "a01hoja2", 0)).to_f.to_l+	
				2*(carp.get_attribute "dynamic_attributes", "anchomarco",(carp.definition.get_attribute "dynamic_attributes", "anchomarco", 0)).to_f.to_l
	else
		ancho =(carp.get_attribute "dynamic_attributes", "a01ancho",(carp.definition.get_attribute "dynamic_attributes", "a01ancho", 0)).to_f.to_l
	end
	return ancho
end	
def angulo_recta(p1,p2)
	# devuelve el angulo con la horizontal de una recta dada por los extremos p1 y p2
	return nil if p1==p2
	if p1[0] == p2[0] #iguales x
		if p1[1] < p2[1]
			return Math::PI/2
		else
			return Math::PI*3/2
		end	
	elsif p1[1] == p2[1]
		if p1[0] < p2[0]
			return 0.0
		else	
			return Math::PI
		end	
	else
		result = Math::atan((p2[1]-p1[1])/(p2[0]-p1[0]))
		result += Math::PI if p1[0] > p2[0] 
		result += Math::PI*2 if result < 0.0 
		return result
	end	
end
def borra_auxiliares
	if !@cl1.deleted?
		Sketchup.active_model.active_entities.erase_entities [@cl1, @cl2]
	end if @cl1	
end
def borra_carpinteria(carp, entities)
	return false if tipo_bloque(carp) != 'carpinteria'
	entities=Sketchup.active_model.active_entities if !entities
	ambos=muro_carpinteria(carp)
	ptos = ambos[0]
	p_t = ambos[1]
	p=[]
	p_t.each do |t| 
		p.push(t.x.to_f) 
		p.push('#')
		p.push(t.y.to_f) 
		p.push('#') if t != p_t.last
	end
	#carp.set_attribute('dibac', 'trim', p)
	#UI.messagebox(carp.get_attribute('dibac', 'trim'))
	transform=carp.transformation
	#UI.messagebox(carp.definition.get_attribute('dibac','mocheta').to_l)
	entities.erase_entities carp
	lineasmuro=[]
	# hacemos el muro por los lados de la mocheta
	0.step(p_t.size-1,2) do |i|
		lineasmuro.push(entities.add_line(p_t[i].transform(transform),  p_t[i+1].transform(transform)))	
	end
	lineasmuro.push(entities.add_line(ptos[0], ptos[3]))
	lineasmuro.push(entities.add_line(ptos[1], ptos[2]))
	face = entities.add_face(lineasmuro)
	#face = entities.add_face(ptos[0],ptos[1],ptos[2],ptos[3] )
	# borramos lineas sobrantes
	borra_coplanarias(face.edges, entities)
	# para que no borre el muro inmediatamente despues de la ventana
	#@borrando = false
end
def borra_coplanarias(caras, entities)#edges
	selborrar = []
	caras.each do |e|
		if !e.deleted? 
			if(e.faces.size == 2) 
				selborrar.push e if(e.faces[0].normal.dot(e.faces[1].normal) > 0.99999999) 
			end
		end	
	end
	if 	selborrar != []
		entities.erase_entities selborrar
	end	
end 
def borra_muro(x, y, view, modoundo) # noundo indica si entra en revoca y si arregla los dos extremos
	cara1 = busca_cara(x, y, view)
#	Sketchup.active_model.active_entities.add_cpoint((view.inputpoint x,y).position)
	if cara1
		cara2 = otra_cara_perp(cara1,(view.inputpoint x,y).position)
		if cara2
			# Quitamos las caras de la seleccion 
			Sketchup.active_model.selection.remove(cara1, cara2)
			ptos = tramo_comun(edge_extremos(cara1), edge_extremos(cara2))
			pt1 = ptos[0]
			pt2 = pt1.project_to_line(cara2.line)
			pt3 = ptos[1]
			pt4 = pt3.project_to_line(cara2.line) 
			lado =(pt1 - (view.inputpoint(x,y)).position).length - (pt3 - (view.inputpoint(x,y)).position).length	
			
			
			#inicioundo("borrar muro") if modoundo
			# cerramos el segmento de muro a borrar
			extremos =[]
			extremos.push(Sketchup.active_model.active_entities.add_line(pt1, pt2))
			extremos.push(Sketchup.active_model.active_entities.add_line(pt3, pt4))
			# borramos las caras
			borrar = Sketchup.active_model.active_entities.add_line(pt1, pt3)
			Sketchup.active_model.active_entities.erase_entities(borrar)
			borrar = Sketchup.active_model.active_entities.add_line(pt2, pt4)
			Sketchup.active_model.active_entities.erase_entities(borrar)
			# preparamos contenedor para puntos de resultado
			result = [pt1, pt2, pt3, pt4] 
			# comprobamos si los extremos pertenecen a un muro
			extremo1=false # controlamos cada extremo
			extremos.each do |e|
				# si no estan borrados es que estan sueltos o en un resto triangular 
				if !e.deleted?
					if e.faces.size == 0
						# si no tiene caras borramos 
						Sketchup.active_model.active_entities.erase_entities(e)
					else	
						# las dos caras en los extremos
						pt = ptt = linea1 = linea2 = vert1 = vert2 = vert3 = linea3 = nil
						e.vertices.each do |vert|
							vert.edges.each do |lin|
								# tiene que ser un muro
								if lin != e  && lin.faces.size == 1
									if e.faces.first == lin.faces.first
										# ponemos linea1 como perpendicular
										if(perpendicular(e,lin) && !linea1) || linea2
											linea1 = lin
											vert1 = vert.position
											vert3 = lin.other_vertex vert
											vert3.edges.each do |lin2|
												if lin2.faces.size == 1
													linea3 = lin2 if lin2 != lin
												end
											end
										else
											linea2 = lin
											vert2 = vert.position
										end
									end	
								end
							end
						end
						# el muro esta interrumpido en el medio por una linea	
						if !perpendicular(e,linea2)
							if otra_cara_perp(linea2,vert2) == linea3 # hay solo dos muros
								if extremo1
									result[2] = vert2
									result[3] = vert3.position
								else
									result[0] = vert2
									result[1] = vert3.position
								end				
								# ponemos el extremo ortogonal al muro	
								if !modoundo &&((lado <= 0 && extremo1) ||(lado > 0 && !extremo1))
									Sketchup.active_model.active_entities.add_line(vert2, vert3)
									Sketchup.active_model.active_entities.erase_entities(linea1, e)
								else
									pon_color((Sketchup.active_model.active_entities.add_line(vert2, @ptperp)),linea1.material)
									linea3 = Sketchup.active_model.active_entities.add_line(vert3, @ptperp)
									pon_color(linea3,linea1.material)
									Sketchup.active_model.active_entities.erase_entities(linea1, e, linea3)
								end
							else
								ptt = Geom.intersect_line_line(linea3.line, linea2.line)
								pt = Geom.intersect_line_line(linea1.line, linea2.line) if !ptt #1.1.08 para pequeños errores de precision
								if pt # no son paralelas
									if extremo1
										result[2] = vert2
										result[3] = pt
									else
										result[0] = vert2
										result[1] = pt
									end	
									if ptt &&(ptt-vert2).length < (pt-vert2).length
										face = Sketchup.active_model.active_entities.add_face ptt, vert3.position, vert1, vert2
									else	
										face = Sketchup.active_model.active_entities.add_face pt, vert1, vert2
									end
									caras = face.edges
									Sketchup.active_model.active_entities.erase_entities(e)
									caras.each do |l|
										if !l.deleted?
											Sketchup.active_model.active_entities.erase_entities l if l.faces.size != 1
										end	
									end if caras
								end	
							end
						end
					end	
				end
				extremo1 = true if !extremo1	
			end	
			view.invalidate
			@borrando = false
			if !(result[0]-result[2]).parallel?(result[1]-result[3]) 
				paso = result[2]
				result[2] = result[3]
				result[3] = paso
			end
			return result
		end
	end
	return false
end
def busca_cara(x, y, view) #devuelve linea si esta en el mismo modelo, grupo o componente
	ph = view.pick_helper
	ph.do_pick x, y
	cara=ph.picked_edge
	if cara
		return cara if cara.parent.entities == Sketchup.active_model.active_entities
	end	
	return nil
end
def busca_carpinteria(x, y, view) #devuelve linea si esta en el mismo modelo, grupo o componente
	ph = view.pick_helper
	ph.do_pick x, y
	elemento=ph.best_picked
	if elemento.is_a?(Sketchup::ComponentInstance)
		if tipo_bloque(elemento) == 'carpinteria'
			return elemento if elemento.parent.entities == Sketchup.active_model.active_entities
		end	
	end if elemento	
	return nil
end
def reset #por si no lo hay
 end
 
def CambiaIdioma(key)
    return DibacStrings.GetString(key)
end
def carpinterias_2d3d(definicion)
	defbloque=definicion
	transf_nula=Geom::Transformation.new
	bloque2d=bloque3d=nil
	vueltas=0
	while vueltas<2 do #buscamos dos veces con un definicion distinto
		vueltas += 1
		if definicion.entities.count == 2 #las carpinterias dibac llevan dentro dos instances
			definicion.entities.each do |e| 
				if es_plano(e) 
					if e.is_a?(Sketchup::ComponentInstance)
						bloque2d=e.definition #buscamos componente plano dentro de la carpinteria
					elsif	e.is_a?(Sketchup::Group)
						bloque2d=e.parent
					end	
				else
					if e.is_a?(Sketchup::ComponentInstance)
						bloque3d=e.definition #buscamos componente plano dentro de la carpinteria
					elsif	e.is_a?(Sketchup::Group)
						bloque3d=e.parent
					end	
				end if e.is_a?(Sketchup::ComponentInstance) || e.is_a?(Sketchup::Group)
			end 
		end 
		 if bloque2d && bloque3d
			vueltas += 1
		else
			Sketchup.active_model.definitions.each{|d| definicion=d if d.name == 'Dibac_'+@carp_name}
			if	definicion.name != 'Dibac_'+@carp_name
				definicion = Sketchup.active_model.definitions.add('Dibac_'+@carp_name)
				vueltas +=1
			end
		end	
	end	
	
	bloque2d=bloque3d=nil if (!bloque2d || !bloque3d) # el bloque completo es el componente
	
	bloque3d=defbloque if !bloque3d
	if !bloque2d #fabricamos la representacion 2d del bloque proyectandolo sobre el suelo
		Sketchup.active_model.definitions.each{|d| bloque2d=d if d.name == '2d_'+@carp_name}
		if !bloque2d
			bloque2d=Sketchup.active_model.definitions.add('2d_'+@carp_name)	
			grupotrim3d=bloque2d.entities.add_group
			grupotrim3d.entities.add_instance(defbloque, transf_nula).explode
			caja=defbloque.bounds
			p1=[caja.min.x, caja.min.y,caja.center.z]
			p2=[caja.max.x, caja.min.y, caja.center.z]
			p3=[caja.max.x, caja.max.y, caja.center.z]
			p4=[caja.min.x, caja.max.y, caja.center.z]
			grupo=bloque2d.entities.add_group
			grupo_mover=bloque2d.entities.add_group
			grupo.entities.add_face(p1, p2, p3, p4)
			trim=busca_trim(grupotrim3d)
			if trim
				trans=trim.transformation
				trimdef=trim
				trimdef=trim.definition if trim.is_a?(Sketchup::ComponentInstance)
				grupo_trim=grupo_mover.entities.add_group
				trimdef.entities.intersect_with true, trans, grupo_trim, transf_nula, true, grupo
				ymin=grupo_trim.bounds.min.y
				ymax=grupo_trim.bounds.max.y
				borrar=[]
				grupo_trim.entities.each do |e| 
					if e.start.position.y==ymin || e.start.position.y==ymax
						borrar.push(e)
					end	if e.start.position.y== e.end.position.y
				end	
				grupo_trim.entities.erase_entities(borrar)
				grupo_trim.name='DIBAC_TRIM'
				grupotrim3d.entities.erase_entities(trim)
			end
			#instancia=bloque2d.entities.add_instance(definicion, transf_nula)			
			#hacemos la seccion por el centro
			bordes=perimetro_concavo(defbloque, false)
			cara=bloque2d.entities.add_face(bordes)
			bloque2d.entities.erase_entities(cara) if cara
			bloque2d.entities.intersect_with true, transf_nula, grupo_mover, transf_nula, true, grupo
			bloque2d.entities.erase_entities(grupotrim3d, grupo)
			tpoint=Geom::Point3d.new(0,0,-p1.z)
			transf = Geom::Transformation.new tpoint
			grupo_mover.move! transf
			grupo_mover.explode
		end
	end	
	definicion.entities.clear!
	diccionario=definicion.attribute_dictionary('dynamic_attributes')
	diccionario.each{|key, value| bloque2d.set_attribute('dynamic_attributes', key, value) if key[0,5] == 'dibac' || key[0,6] =='_dibac'} if diccionario
	#Sketchup.active_model.commit_operation
	Sketchup.active_model.start_operation('27-11-13/2',true,true,true)
	definicion.entities.add_instance(bloque2d, transf_nula)
	definicion.entities.add_instance(bloque3d, transf_nula)
	return bloque2d, bloque3d
end
def crea_auxiliares(pt)
	return #no hay auxiliares
	return if pt==[]
	@cl1 = Sketchup.active_model.active_entities.add_cline pt, [0,0]
	@cl2 = Sketchup.active_model.active_entities.add_cline pt, [0,0]
	@cl1.direction = [@@hv[0], @@hv[1]]
	@cl2.direction = [-@@hv[1], @@hv[0]]
	@cl1.stipple = @cl2.stipple = "."
	@cl1.start = @cl1.end = @cl2.start = @cl2.end = nil
end
def con_coma(text,sep) #pone coma o punto en funcion del separador de listas o fijo el caracter que se mande para convertir a float
	if !sep
		sep='.'
		sep=@@coma if @@separador_listas==';'
	end	
	texto=''
	for i in 0 .. text.length-1
		if text[i].chr=='.' || text[i].chr==@@coma
			texto=texto+sep
		else
			texto=texto+text[i].chr
		end	
	end
	return texto
end
def datos_menu(definicion, attr, prompts, defaults, units) #carpinteria y 3D
	diccionario=definicion.attribute_dictionary('dynamic_attributes')
	diccionario.each do |key, value|
		if value == 'TEXTBOX'
			propiedad=key.split('_')[1]
			propiedad=propiedad+'_'+key.split('_')[2] if propiedad == 'dibac'
			attr.push(propiedad)
			prompts[propiedad]=definicion.get_attribute('dynamic_attributes', '_'+propiedad+'_formlabel')
			units[propiedad]=definicion.get_attribute('dynamic_attributes', '_'+propiedad+'_units')
			defaults[propiedad]=definicion.get_attribute('dynamic_attributes', propiedad)
		end
	end if diccionario
	definicion.entities.each {|e| datos_menu(e.definition, attr, prompts, defaults, units) if e.is_a?(Sketchup::ComponentInstance)}#recursivo
end
def draw(view)
	textoevaluacion(view)
end	
def escalera_3d(escalera)
	altura=escalera.get_attribute "dibac","escalera2d"
	return if !altura
	escalera.make_unique
	cota=nil
	temp=[]
	escalera.entities.each do |p|
		temp.push p if p.get_attribute "dibac","escalon"
	end
	tabica=altura/temp.size  
	temp.each do |p|
		if !p.deleted?
			peld=p.get_attribute "dibac","escalon"
			cota=p.edges[0].start.position.z if !cota
			#extrusiona(p,peld*tabica) #version con escalones numerados
			extrusiona(p,peld) 
		end
	end
	selborrar = []
	escalera.entities.each do |e|
		if e.is_a?(Sketchup::Edge)
			if(e.faces.size == 3)
				#primero las horizontales dos normales verticales
				if e.start.position.z == e.end.position.z and e.faces[0].normal.z+e.faces[1].normal.z+e.faces[2].normal.z>1.999999
					selborrar.push e# if(e.faces[0].normal.dot(e.faces[1].normal) > 0.99999999) 
				end
			end
		end
	end
	escalera.entities.erase_entities selborrar if selborrar != []
	#UI.messagebox('primero')
	#borramos todas las lineas verticales mayores que la tabica
	selborrar=[]
	escalera.entities.each do |e|
		if e.is_a?(Sketchup::Edge)
			if vertical(e)
				if e.length>tabica #de momento borramos los planos verticales mayores que la tabica
					selborrar.push e
				end	
			end
		end
	end
	escalera.entities.erase_entities selborrar if selborrar!=[]
	#UI.messagebox('segundo')
	#borramos el plano del suelo
	selborrar=[]
	escalera.entities.each do |e|
		if e.is_a?(Sketchup::Edge)
			if e.start.position.z==cota && e.end.position.z==cota && e.faces.size==1
				selborrar.push e
			end
		end
	end	
	escalera.entities.erase_entities selborrar
	#UI.messagebox('tercero')
	#borramos las que salgan de cero y tengan solo una cara para los laterales del primer peldaño
	selborrar=[]
	escalera.entities.each do |e|
		if e.is_a?(Sketchup::Edge)
			if e.start.position.z==cota && e.faces.size==1 && vertical(e)
				borrar=false
				escalera.entities.each do |f|
					if f.is_a?(Sketchup::Edge)
						borrar=true if f.start.position==e.end.position && vertical(f)
					end	
				end
				selborrar.push e if borrar 
			end
		end
	end	
	escalera.entities.erase_entities selborrar
	#UI.messagebox('Cuarto')
	#borramos lineas sueltas
	selborrar=[]
	escalera.entities.each do |e|
		if e.is_a?(Sketchup::Edge)
			if e.faces.size==0
				selborrar.push e
			end
		end
	end	
	escalera.entities.erase_entities selborrar
	escalera.set_attribute "dibac","escalera3d",altura
	escalera.set_attribute "dibac","escalera2d",nil
	#escalera.set_attribute "dibac","escalera2d",false dejamos escalera2d como estaba
end
def nolicencia(inhabilitar)
	return false if @@numserie !="" 
	@@veces_que_entra +=1
	@@veces_que_entra = 0 if inhabilitar
	DibacLicencia.informacion(@@datoslicencia) if (@@veces_que_entra % 5 == 0)
	Sketchup.active_model.select_tool nil if inhabilitar	
	return true
end	
def textoevaluacion(view)
	return if @@numserie == ''
	datos_licencia(false) if @@numserie='promo'
	#texto="Dibac: "+ Iscarnet_Dibac.description + ' '
	texto=""
	if @@numserie =='promo' # No tiene licencia
		texto=texto+ CambiaIdioma("Promotional license")+" ("+@@defaultkey+")" 
		x=view.corner(0)[0]
		y=view.corner(0)[1]
	else
		texto=texto+ CambiaIdioma(" ")+"  "+@@usuario+" ("+@@email+")" if @@usuario != ''
		x=view.corner(2)[0]
		y=view.corner(2)[1]-30
	end	
	view.draw_text([x+2,y+12],texto)
end
def deactivate(view)
	view.invalidate
end	
def vertical(edge)
	if edge.start.position.x==edge.end.position.x && edge.start.position.y==edge.end.position.y
		return true
	else
		return false
	end	
end
def extrusiona(face, h)
	face.reverse! if face.normal.z < 0
	face.pushpull h, true
end
def long_valida(valor)
	return nil if !valor
	value = valor.to_l
	return value if value
	begin
        value=con_coma(valor,nil).to_l
    rescue
        # Error parsing the text
        UI.beep
        value = nil
        Sketchup::set_status_text "", SB_VCB_VALUE
    end
	return value
end
def muestra_valor(t)
	Sketchup::set_status_text t, SB_VCB_VALUE
end
def mocheta_real(carp) ##############Por aqui no pasa nunca, hace la mocheta segun el muro lateral de la puerta
	ancho=ancho_carpinteria(carp)
	ptos = []
	# Buscamos los extremos desde el origen y los transformamos para colocarlos sobre la instancia 
	extremo1 = [0, 0, 0].transform! carp.transformation
	extremo2 = [ancho, 0, 0].transform! carp.transformation
	# Dibujamos una linea para tener vertices en las mochetas
	linea = Sketchup.active_model.active_entities.add_line extremo1, extremo2
	# Buscamos las mochetas en cada vertice
	linea.vertices.each do |ver|
		mocheta = nil
		ver.edges.each do |moch|
			# estan en el mismo grupo, componente o modelo
			if mismo_grupo(moch, carp) #########unica llamada a este metodo
				if perpendicular(linea, moch)
					ptos.push(moch.start.position) if !mocheta 
					mocheta = moch
				end
			end	
		end
		ptos.push(mocheta.end.position) if mocheta
	end
	Sketchup.active_model.active_entities.erase_entities linea
	return ptos
end
def busca_trim(bloque) #definicion
	trim=nil
	bloque.entities.each do |e| 
		if e.is_a?(Sketchup::ComponentInstance) || e.is_a?(Sketchup::Group)
			trim= e if e.name == 'DIBAC_TRIM'
		end
	end	
	return trim
end
def borra_nulos(carp)
	return #no borramos nulos
	carp=carp.definition if carp.is_a?(Sketchup::ComponentInstance)
	borrar=[]
	carp.entities.each do |c| 
		if c.is_a?(Sketchup::ComponentInstance)
			if (c.bounds.min-c.bounds.max).length.to_f < 0.05
				borrar.push(c)
			else
				borra_nulos(c)	
			end
		end
	end
	carp.entities.erase_entities(borrar)
end
def muro_carpinteria(carp)
	# devuelve cuatro puntos definidos por las mochetas y todos los puntos de las mochetas
	#  	1-----------------------------4
	#  	|                                         |
	#  	2-----------------------------3
	mocheta=carp.definition.get_attribute('dibac', 'mocheta').to_f
	trim=busca_trim(carp.definition)
	trim.transform!(Geom::Transformation.scaling(1, (mocheta/(trim.bounds.max.y-trim.bounds.min.y)).to_f, 1))
	definicion=trim #por si es grupo
	definicion=trim.definition if trim.is_a?(Sketchup::ComponentInstance)
	p_t= saca_puntos([],[], definicion, trim.transformation, true, true)[1] 
	xmax = xmin = p_t[0][0]
	pt1=pt2=pt3=pt4=false
	mocheta=(trim.bounds.max.y-trim.bounds.min.y).to_f.to_l
	p_t.each do |p|
		xmin=p[0] if xmin > p[0]
		xmax=p[0] if xmax < p[0]
		if p[1].abs < 0.000001 #p[1]==0
			pt1=p if !pt1
			pt1=p if p[0] < pt1[0] 
			pt3=p if !pt3
			pt3=p if p[0] > pt3[0]
		end
		if (p[1]+mocheta).abs <0.000001 #p[1]==-mocheta
			pt2=p if !pt2
			pt2=p if p[0] < pt2[0]
			pt4=p if !pt4
			pt4=p if p[0] > pt2[0]
		end
	end
	pt1=[xmin,0,0] if !pt1
	pt2=[xmin,-mocheta,0] if !pt2
	pt3=[xmax,0,0] if !pt3
	pt4=[xmax,-mocheta,0] if !pt4
	#ancho=(pt3[0]-pt1[0])
	ptos=[] #los cuatro puntos de la mocheta
	ptos.push(Geom::Point3d.new(pt1.transform(carp.transformation)))
	ptos.push(Geom::Point3d.new(pt2.transform(carp.transformation)))
	ptos.push(Geom::Point3d.new(pt4.transform(carp.transformation)))
	ptos.push(Geom::Point3d.new(pt3.transform(carp.transformation)))
	return ptos, p_t 
end
def perpendicular(linea1, linea2) # edges
	#return false if !linea1 || !linea2
	#verdadero si dos edges son perpendiculares
	return true	if(linea1.start.position-linea1.end.position).perpendicular?(linea2.start.position-linea2.end.position)
end
def angulo_inverso(angulo)
	if angulo < Math::PI
		return(angulo + Math::PI) 
	else 
		return(angulo - Math::PI)
	end
end	
def punto_en_segmento(pt, pt1, pt2)
	return false if !pt || !pt1 || !pt2
	pt=Geom::Point3d.new(pt)if pt.class==Array
	pt1=Geom::Point3d.new(pt1)if pt2.class==Array
	pt2=Geom::Point3d.new(pt2)if pt2.class==Array
	return true if(pt-pt1).length+(pt-pt2).length <(pt1-pt2).length+0.0001
	return true if(pt-pt1).length < 0.0001
	return true if(pt-pt2).length < 0.0001
	return false
end
def punto_a_distancia(pt1, pt2, dist)
	return pt1 if dist==0
	@long =(pt1 - pt2).length
	return nil if @long == 0.0 
	return Geom.linear_combination(dist/@long, pt2, 1-(dist/@long), pt1)
end
def punto_medio(pt1, pt2)
	return Geom.linear_combination(0.5, pt1, 0.5, pt2)
end
def otra_cara_perp(cara1,pt)
	return nil if !cara1
	return nil if cara1.deleted?
	return nil if cara1.faces.size != 1
	pt = pt.project_to_line cara1.line if !punto_en_segmento(pt, cara1.start.position, cara1.end.position) #Si no está en cara1
	gru = 100000.0
	resultado = nil
	vec1 = cara1.start.position - cara1.end.position
	face = cara1.faces[0]
	face.edges.each do |e|
		if cara1 != e
			vec2 = e.start.position - e.end.position
			if vec1.parallel? vec2
				pt1 = pt.project_to_line e.line
				vec3 = pt - pt1
				if punto_en_segmento(pt1, e.start.position, e.end.position) #Está en la perpendicular
					# para que no haga muro con dos lineas paralelas myu juntas de la misma face
					if face.classify_point(punto_medio(pt,pt1)) == Sketchup::Face::PointInside 
						ptos=tramo_comun(edge_extremos(cara1),edge_extremos(e))
						if vec3.length < gru
							gru = vec3.length
							resultado = e
							#@dar_vuelta = vec1.normalize != vec2.normalize 
							# @ptperp usado por otros procedimientos
							@ptperp = pt1
						end	if ptos[0] != ptos[1]
					end
				end	
			end
		end	
	end
	return resultado
end	
def edge_extremos(e)
	return([e.start.position,e.end.position])
end
def tramo_comun(l1, l2)
	if (l1[0]-l1[1]).length >0 && (l2[0]-l2[1]).length > 0
		pt1 = l1[0]
		pt2 = l2[0].project_to_line(l1) 
		pt3 = l2[1].project_to_line(l1)
		pt4 = l1[1]
		if(pt2 == pt4) or(pt3 == pt1)
			ptini = pt3
			pt3 = pt2
			pt2 = ptini
		end
		if punto_en_segmento(pt1 , pt2, pt3)
			ptini = pt1 
		elsif punto_en_segmento(pt2 , pt1, pt4)	
			ptini = pt2 	
		elsif punto_en_segmento(pt3 , pt1, pt4)
			ptini = pt3
		elsif
			punto_en_segmento(pt4 , pt2, pt3)
			ptini = pt4
		else
			return []
		end	
		if punto_en_segmento(pt4 , pt2, pt3)
			ptfin = pt4 
		elsif punto_en_segmento(pt3 , pt1, pt4)	
			ptfin = pt3 	
		else
			ptfin = pt2
		end	
		return[ptini, ptfin]
	end
	return []
end
def inicioundo(comando)
	Sketchup.active_model.start_operation comando, false, true, false
end
def finalundo
	Sketchup.active_model.start_operation "finalundo", true, false, true #si aparece finalundo en la lista es que hay algo mal
	#Sketchup.active_model.commit_operation
end
def selecciona_entidades(model) #decide si se debe usar entities o active_enities
	if model==Sketchup.active_model
		return model.entities
	else
		return model.entities
	end	
 
 end
 
def borra_coplanarias_3d(model) #borra planos verticales interiores y coplanarias en  model 
	entidades=selecciona_entidades(model)
	selborrar = []
	entidades.each do |e|
		if e.is_a?(Sketchup::Edge)
			if(e.faces.size == 3)
				#primero las horizontales dos normales verticales
				if e.start.position.z == e.end.position.z and e.faces[0].normal.z+e.faces[1].normal.z+e.faces[2].normal.z>1.999999
					selborrar.push e# if(e.faces[0].normal.dot(e.faces[1].normal) > 0.99999999) 
				end
			end
		end
	end
	entidades.erase_entities selborrar if selborrar != []
	selborrar = []
	entidades=selecciona_entidades(model)
	entidades.each do |e|
		if e.is_a?(Sketchup::Edge)
			if(e.faces.size == 2)
				selborrar.push e if(e.faces[0].normal.dot(e.faces[1].normal) > 0.99999999) 
			end
		end
	end
	entidades.erase_entities selborrar if selborrar != []  
end
 
def mismo_grupo(x, y) ############# no se usa, se llama solo desde mocheta_real
	return true if x.parent == y.parent
	return false
end
 
def interseccion_real(pt1, pt2, pt3, pt4)
	pt1=Geom::Point3d.new(pt1)if pt1.class==Array
	pt2=Geom::Point3d.new(pt2)if pt2.class==Array
	pt3=Geom::Point3d.new(pt3)if pt3.class==Array
	pt4=Geom::Point3d.new(pt4)if pt4.class==Array
	return nil if !pt1 || !pt2
	return pt1 if pt1==pt3 || pt1==pt4
	return pt2 if pt2==pt3 || pt2==pt4
	pt = Geom.intersect_line_line([pt1, pt2],[pt3, pt4])
	return pt if punto_en_segmento(pt, pt1, pt2) && punto_en_segmento(pt, pt3, pt4)
	return nil
end 
def interseccion_real_edges(e1,e2)
	pt1=e1.start.position
	pt2=e1.end.position
	pt3=e2.start.position
	pt4=e2.end.position
	return interseccion_real(pt1,pt2,pt3,pt4)
end	
def es_plano(entidad)
	return false if entidad.bounds.min.z != entidad.bounds.max.z
	return true
end	
def otro_vertice(l, p)
	return l[0] if l[1]==p
	return l[1] if l[0]==p
	return nil
end
def perimetro_concavo(definicion, vertical)
	caja=definicion.bounds
	if vertical
		transf=Geom::Transformation.rotation([0,0,0],[1,0,0],Math::PI/2) #lo tiramos al suelo alrededor de eje x 
	else
		transf=Geom::Transformation.new
	end	
	puntos=saca_puntos([],[],definicion,transf,false, false)[0]
	return nil if puntos.size==0
	lineas=[]
	0.step(puntos.size-1,2) do |i| 
		p1=puntos[i].transform(transf.inverse)
		p2=puntos[i+1].transform(transf.inverse)
		lineas.push([p1, p2]) if p1!=p2
	end	
	#lineas.each{|l| Sketchup.active_model.active_entities.add_line(l[0].transform(transf), l[1].transform(transf))} #Descomentar para compreobacion
	primer_p=lineas[0][0]					
	lineas.each do |p| #todo son lineas
		#buscamos el de mas a la derecha
		primer_p=p[0] if p[0].transform(transf).x > primer_p.transform(transf).x 
		primer_p=p[1] if p[1].transform(transf).x > primer_p.transform(transf).x 
	end
	p_actual=p_anterior=angulocomp=nil
	bordes=[]
	#Sketchup.active_model.active_entities.add_instance(trim, transf)
	while p_actual != primer_p do
		p_actual=primer_p if !p_actual #ponemos el primer punto
		#Sketchup.active_model.active_entities.add_cpoint(p_actual.transform(transf)) #Descomentar para compreobacion
		bordes.push(p_actual) # lo insertamos eb bordes
		lineas_punto=lineas.select{|a| a.include?(p_actual)} #buscamos las lineas en p_actual
		l_actual=lineas_punto[0] if !l_actual
		sig_l=nil
		lineas_punto.each{|l| l_actual=l if (!sig_l)}# && l!=l_actual)}
		sig_p=otro_vertice(l_actual, p_actual)
		if angulocomp
			angulocomp=angulo_recta(p_actual.transform(transf), p_anterior.transform(transf))
		else
			angulocomp=0
		end	
		#UI.messagebox(angulocomp*180/Math::PI)
		angulo1 = 2*Math::PI #para que siempre haya uno menor
		lineas_punto.each do |j|
			#if lineas.select{|a| a.include?(otro_vertice(j, p_actual))}.size>1 #comprobamos que no estamos en un callejon sin salida
				angulo2 = angulo_recta(p_actual.transform(transf), otro_vertice(j, p_actual).transform(transf))
				#angulo2 = 2*Math::PI if angulo2 == 0
				angulo2=angulocomp if !angulo2
				angulo2 = angulo2 - angulocomp #colocamos angulocomp como 0
				angulo2 = 0 if angulo2.abs < 0.000001
				angulo2=angulo2+2*Math::PI if angulo2 < 0
				a=(sig_l[0]-sig_l[1]).length if sig_l
				#UI.messagebox(lineas_punto.size.to_s+' - '+(angulo1*180/Math::PI).to_s+'('+a.to_s+')'+' - '+(angulo2*180/Math::PI).to_s+' - '+j[0].to_s+' - '+j[1].to_s+' - '+(j[0]-j[1]).length.to_l.to_s) #Descomentar para compreobacion
				if (angulo2 - angulo1).abs < 0.000001 #iguales
					if(j[0]-j[1]).length < (sig_l[0]-sig_l[1]).length # nod quedamos con el mas corto
						sig_p=otro_vertice(j, p_actual)
						sig_l=j 
					end	
				elsif angulo2 < angulo1
					angulo1 = angulo2	
					sig_p=otro_vertice(j, p_actual)
					sig_l=j 
				end if angulo2 != 0
				#end if j != l_actual  #if otro_vertice(j, p_actual) != p_anterior
			#end	
		end
		break if bordes.include?(sig_p)
		#Sketchup.active_model.active_entities.add_line(sig_l[0].transform(transf),sig_l[1].transform(transf))
		#break if bordes.include?(sig_p)
		#bordes.push(sig_edge)
		l_actual=sig_l
=begin		
		#ahora buscamos interseccion con el resto de lineas	
		p1=p_actual
		p2=sig_p
		l_nuevas=[]
		lineas.each do |l|
			p3=l[0]
			p4=l[1]
			pt=interseccion_real(p1,p2,p3,p4)
			if pt	
				if pt != p1 && pt != p2
					l_nuevas.push([pt, sig_p])	
					if sig_p == l[0]
						l[0] = pt 
					else
						l[1] = pt
					end	
					sig_p=pt
					p2=pt
				end
				if pt != p3 && pt != p4
					l_nuevas.push([pt, p4])
					l[1] = pt
				end
			end
		end
		l_nuevas.each{|l| lineas.push(l)}
=end		
		p_anterior=p_actual
		p_actual=sig_p
	end
	return bordes
end
def saca_puntos(p_c, p_t, bloque, trans, trim, smooth) #da los puntos de una carpinteria en 2d y las mochetas
	trans=Geom::Transformation.new if !trans
	bloque=bloque.definition if bloque.is_a?(Sketchup::ComponentInstance)
	bloque.entities.each do |e|
		incluir=true
		if e.is_a?(Sketchup::Edge)#if (e.visible? && !e.hidden?)  
			incluir=false if (e.smooth? && smooth)
			if incluir
				punto=e.start.position.transform(trans)
				p_c.push(Geom::Point3d.new(punto[0].to_f,punto[1].to_f))
				p_t.push(Geom::Point3d.new(punto[0].to_f,punto[1].to_f)) if trim
				punto=e.end.position.transform(trans)
				p_c.push(Geom::Point3d.new(punto[0].to_f,punto[1].to_f))
				p_t.push(Geom::Point3d.new(punto[0].to_f,punto[1].to_f)) if trim
			end	
		end #if e.is_a?(Sketchup::Edge)
		saca_puntos(p_c,p_t,e.definition, trans*e.transformation, (e.name=='DIBAC_TRIM') || trim, smooth) if (e.is_a?(Sketchup::ComponentInstance))#recursivo
		saca_puntos(p_c,p_t,e , trans*e.transformation, (e.name=='DIBAC_TRIM') || trim, smooth) if (e.is_a?(Sketchup::Group))#recursivo
	end
	return p_c, p_t
end
def tipo_bloque(carp)
	return false if (!carp.get_attribute('dibac','2d') || !es_plano(carp))
	return 'mobiliario' if (carp.definition.get_attribute('dibac','mocheta').to_f == 0)
	return 'carpinteria'
end
def intermedios(linea,extremos,carpinterias) # Devuelve el primer punto de la line y las intesecciones con muros. 
	puntos = [] 
	Sketchup.active_model.active_entities.each do |e|
		if e.is_a?(Sketchup::Edge)
			if e.faces.size == 1
				pt = interseccion_real(linea[0], linea[1], e.start.position, e.end.position)
				if extremos ||(pt != linea[0] && pt != linea[1] && pt != puntos.last)
					puntos.push(pt)
				end if pt
			end	
		elsif e.is_a?(Sketchup::ComponentInstance) && carpinterias
			if tipo_bloque(e) =='carpinteria'
				ptcarp=muro_carpinteria(e)[0]
  				pt = interseccion_real(linea[0], linea[1], ptcarp[0], ptcarp[3])
				if extremos ||(pt != linea[1] && pt != linea[2] && pt != puntos.last)
					puntos.push(pt)
				end if pt
				pt = interseccion_real(linea[0], linea[1], ptcarp[1], ptcarp[2])
				if extremos ||(pt != linea[0] && pt != linea[1] && pt != puntos.last)
					puntos.push(pt)
				end if pt
			end
		end
	end
	return puntos if puntos.size < 2
	i = -1
	result=[]
	ultimadistancia=-1
	while i < puntos.size-1 do
		j = 0
		k = 0
		distancia = 1000000.0
		while j < puntos.size
			if puntos[j] 
				if(linea[0]-puntos[j]).length < distancia
					distancia =(linea[0]-puntos[j]).length
					punto = puntos[j]
					k = j
				end	
			end 
			j += 1
		end
		result.push(punto) if distancia > ultimadistancia
		ultimadistancia=distancia
		puntos[k] = nil
		i += 1
	end	
	return result
end
def onCancel(flag, view)
	reset
	view.lock_inference if( view.inference_locked? )
	view.invalidate
	#menu if flag==0 #para diferenciarlo de Ctrl-Z
end
def draw(view)
	texto_comando
end	
def onRButtonDown(flags, x, y, view)
	#reset
	view.invalidate
	menu
end	
def menu	
	reset #para las funciones que no tiene menu
end
def pon_cota_lineal(model, pt1, pt2)
	@componente = Sketchup.active_model.definitions.load(Sketchup.find_support_file("DIBAC_COTAL.skp","Plugins/indoor"))
	transform = Geom::Transformation.translation(pt1)
	transform =(Geom::Transformation.scaling(pt1,(pt1-pt2).length,1,1)) * transform 
	transform =(Geom::Transformation.rotation(pt1, [0,0,1], angulo_recta(pt1,pt2))) * transform	
	@instance = model.entities.add_instance(@componente,transform)
	@cota=@instance.explode	
	@cota[0].set_attribute "dibaccotas", "pt1", pt1
	@cota[0].set_attribute "dibaccotas", "pt2", pt2
	return @cota
end
def pon_color(entidad,mat)
	if mat =="<Ninguno>"
		mat = nil
	end
	entidad.material=mat
	entidad.back_material = mat if entidad.is_a?(Sketchup::Face)
end
def saca_definicion(carp)
	definicion=nil
	nombre=carp.split('/').last
	nombre=nombre.gsub('.skp','')
	Sketchup.active_model.definitions.each{|d| definicion=d if d.name==nombre}
	Sketchup.active_model.definitions.each{|d| definicion=d if d.name == carp} #el bloque completo no lo tengo que repetir
	begin
		Sketchup.active_model.start_operation('27-11-13/1', true, true, true)
		definicion=Sketchup.active_model.definitions.load(carp) if !definicion
	rescue
		return
	end	if !definicion
	return definicion
end
def saca_menu
	@carp_attributes = []
	@carp_prompts = Hash.new
	@carp_defaults=Hash.new
	@carp_units=Hash.new
	definicion=saca_definicion(@carp[0])
	return false if !definicion
	@carp_name=definicion.name
	datos_menu(definicion, @carp_attributes , @carp_prompts, @carp_defaults, @carp_units)
	@carp_attributes.uniq!
	@carp_attributes=@carp_attributes.sort
	return true
end
end # de la clase Dibac_Base
# class Dibac_Borrar < Dibac_Base
# =begin
#  Clase	        		:	Borrar
#  Desciende de		:	Dibac
#  Descripción   		:	Realiza el borrado de elementos de Dibac
#  Item de Menu  	:	Dibujo->Dibac->Borrar elementos Dibac // Barra de herramientas Dibac
#  Menú contextual	:	NO
#  Uso         			:	Se marca lo que se quiere borrar y se reparan lo empalmes o se cierran los huecos de
# 								carpinterias.
# 								Para que funcione a borrar muros hay que marcarlos en puntos donde la ortogonal corte a 
# 								la otra cara.
# 								Si se marcan elemento que no son de Dibac se realiza el borrado normal.
# Fecha        			:	14/11/2010
# =end
# def reset
# 	@puntos_muro = []
# 	@carpinterias = []
# 	@previo=true if Sketchup.active_model.selection.count>0
# 	Sketchup::set_status_text "", SB_VCB_LABEL
# 	Sketchup::set_status_text "", SB_VCB_VALUE
# 	texto = CambiaIdioma("Select items to erase or drag across multiple items.")
# 	texto = texto + " " + CambiaIdioma("Shift")+"="+CambiaIdioma("Hide")
# 	texto = texto +", Ctrl=" if WIN
# 	texto = texto +", Option=" if MAC
# 	texto = texto +CambiaIdioma("Soften/Smoth")
# 	texto = texto +", Alt=" if WIN
# 	texto = texto +", Cmd=" if MAC
# 	texto = texto+CambiaIdioma("Dibac")+"."
# 	Sketchup::set_status_text  texto
# 	@cursor = @@borrarcursor_id if !@cursor
# end
# def activate
# 	Sketchup.active_model.active_view.invalidate
# 	reset
# end	
# def onSetCursor
# 	UI.set_cursor(@cursor)
# end
# def selecciona(x, y, view)
# 	return if !@borrando
# 	ph = view.pick_helper
# 	ph.do_pick x, y
# 	# Sketchup.active_model.active_entities.add_cpoint((view.inputpoint x,y).position)
# 	Sketchup.active_model.selection.clear if @previo
# 	@previo=false
# 	@puntos_muro.push [x,y]
# 	for i in 0 ... ph.count
# 		e=ph.element_at(i)
# 		if !ph.leaf_at(i).is_a?(Sketchup::Face)
# 			@carpinterias.push e if e.is_a?(Sketchup::ComponentInstance)
# 			Sketchup.active_model.selection.add e
# 		end
# 	end	
# end
# def onMouseMove(flags, x, y, view)
# 	selecciona(x, y, view)
# end
# def onLButtonDown(flags, x, y, view)
# 	@borrando = true
# 	selecciona(x, y, view)
# end
# def onLButtonUp(flags, x, y, view)
# 	@borrando = false
# 	sel = Sketchup.active_model.selection
# 	if @pulsado_shift && !@pulsado_ctrl
# 		inicioundo(CambiaIdioma("Hide"))
# 		sel.each { |e| e.hidden=true}	
# 		sel.clear
# 		finalundo
# 		return	
# 	end
# 	if @pulsado_ctrl && !@pulsado_shift
# 		inicioundo(CambiaIdioma("Soften edges"))
# 		sel.each { |e| e.soft=true if e.is_a?(Sketchup::Edge)}#if e.typename !="ComponentInstance"}	
# 		sel.clear
# 		finalundo
# 		return	
# 	end
# 	inicioundo(CambiaIdioma("Erase"))	
# 	if @pulsado_alt
# 		@puntos_muro.each do |pt|
# 			borra_muro(pt[0], pt[1], view, true)
# 		end
# 		@carpinterias.each do |carp|
# 			borra_carpinteria(carp, nil) if !carp.deleted?
# 		end
# 		reset
# 	end
# 	Sketchup.active_model.active_entities.erase_entities sel
# 	finalundo
# end
# def onKeyDown(key, rpt, flags, view)
# 	@pulsado_shift = true if key == CONSTRAIN_MODIFIER_KEY
# 	@pulsado_ctrl = true if key == COPY_MODIFIER_KEY
# 	@pulsado_alt = true if key == ALT_MODIFIER_KEY
# 	#@cursor = @@borrarcursordibac_id if key == ALT_MODIFIER_KEY
# end
# def onKeyUp(key, rpt, flags, view)
# 	#@cursor = @@borrarcursor_id
# 	@pulsado_shift = false if key == CONSTRAIN_MODIFIER_KEY
# 	@pulsado_ctrl = false if key == COPY_MODIFIER_KEY
# 	@pulsado_alt = false if key == ALT_MODIFIER_KEY
# end
# def draw(view)
# 	textoevaluacion(view)
# end
# end # de la clase Borrar
class Dibac_Muro < Dibac_Base
=begin
 Clase	        		:	Muro
 Desciende de		:	Dibac
 Descripción   		:	Dibuja muros en planta
 Item de Menu  	:	Dibujo->Dibac->Muro // Barra de herramientas Dibac
 Menú contextual	:	NO
 Uso         			:	Para dibujar el muro primero se tiene que proporcionar el
								punto de arranque. Luego se van marcando los puntos sucesivos.
								Pulsando [Tab] se cambia la cara de enganche entre izquierda,
								centro y derecha sucesivamente.
								Si se introdue un numero positivo se toma como longitud en la direccion marcada.   
								Si se introduce un numero negativo se toma como espesor del	muro.
								Para terminar una secuencia de muro se pulsa [Esc].
								Cuando se engancha a una arista esta se marca en magenta.
								Para cambiar el angulo del de las guias se introduce el caracter "<"(menor que)
								sequido el nuevo angulo
								Si se introduce una secuencia de numeros separados por @@separador_listas se interpretara que cada uno
								de ellos sera un muro girado 90 grados o -90 grados segun el signo y con la longitud del numero
								asi para introducir una planta en L de lados 5,10,5,5,10,15 introducimos lo siguiente desde el
								primer punto saliendo a la derecha 5;10;-5;5;10;15
             		   
             		  
 Fecha        			:	14/11/2010
=end
def initialize
	@ip = Sketchup::InputPoint.new
	@ip1 = Sketchup::InputPoint.new
end
def menu	
	nolicencia(false)
	prompts = 	[CambiaIdioma("墙体厚度")	]
		defaults = [	@@muro_width.to_l.to_s
						]
	list = 			[	""
						]
	input = UI.inputbox prompts, defaults, list, CambiaIdioma("绘制墙体")
	if input
		h1 = a_longitud(input[0]).abs
		@@muro_width = h1 if h1>0
		case input[1].to_s
		when CambiaIdioma("左") 
			@@muro_cara=0.0
		when CambiaIdioma("中") 
			@@muro_cara=0.5
		when CambiaIdioma("右")
			@@muro_cara=1.0
		end
		h1 = input[2].to_s.upcase
	else	
		Sketchup.active_model.select_tool nil	
		return
	end	
end
def reset
	@tramo=nil
	borra_auxiliares
	Sketchup.active_model.commit_operation if @primer_punto
	@primer_punto = @pulsado_tab = false
	# puntos temporales para el muro enganchado al cursor
	@ptini = @ptfin = @pt1 = @pt2 = @pt3 = @pt4 = []
	# aristas a las que se engancha al principio y al final
	@arini = @arfin = @lineai = @linead = @vertice1 = @vertice2 = nil
	Sketchup::set_status_text "", SB_VCB_LABEL
	Sketchup::set_status_text "", SB_VCB_VALUE
	texto_comando
end
def activate
	Sketchup.active_model.active_view.invalidate
	menu
	@comando_en_curso = "墙"
	reset
end
def texto_comando
	return if !@comando_en_curso
	texto = CambiaIdioma(@comando_en_curso) +"["+ @@muro_width.to_l.to_s+"]。"
	if !@primer_punto
		texto = texto+CambiaIdioma("指定开始点")
	else	
		texto= texto+CambiaIdioma("指定结束点")
	end	
	texto = texto + ", " + CambiaIdioma("或者指定厚度，按") + " '-'。"
	if @primer_punto
		texto = texto + " Tab="+CambiaIdioma("切换基线")+"。" if WIN
		texto = texto + " Ctrl="+CambiaIdioma("切换基线")+"。" if MAC
	end	
	Sketchup::set_status_text  texto 
end		
def deactivate(view)
	reset
	view.invalidate
end
def onSetCursor
	UI.set_cursor(@@murocursor_id)
end
def calcula_puntos
	#return false if !@pt1 || !@pt2
	return false if !@primer_punto
	if @comando_en_curso == "墙"
		if @vertice1 && @vertice2
			vec =(@vertice1.position - @vertice2.position)
			@ptini = @vertice1.position.offset(vec, -@@muro_cara*vec.length)
		end	
	end	
	i = 1
	while i < 5  #para ponerse en el lado bueno cuando de sale de una esquina
		if @@muro_cara > 0 then
			vec = @ptini - [@ptini[0] +(@ptfin[1] - @ptini[1]), @ptini[1] - (@ptfin[0] - @ptini[0]),@ptini[2]]
			if vec.length>0
				@pt1 = @ptini.offset(vec, @@muro_cara * @@muro_width)	 
				@pt2 = @ptfin.offset(vec, @@muro_cara * @@muro_width)
			end	
		else
			@pt1 = @ptini	 
			@pt2 = @ptfin	   
		end
		vec = @ptini - [@ptini[0] - (@ptfin[1] - @ptini[1]), @ptini[1] +(@ptfin[0] - @ptini[0]),@ptini[2]]
		if vec.length>0
			@pt3 = @pt1.offset(vec, @@muro_width) if @pt1!=[]
			@pt4 = @pt2.offset(vec, @@muro_width) if @pt2!=[]	  
		end	
		if !@arfin.deleted? 
			pt0 = Geom.intersect_line_line([@pt1, @pt2], @arfin.line) 
			pt1 = Geom.intersect_line_line([@pt3, @pt4], @arfin.line) if @pt4!=[]
			if 	punto_en_segmento(pt0,@arfin.start.position,@arfin.end.position )
				@pt2 = pt0
				@pt4 = pt1
			end	if punto_en_segmento(pt1,@arfin.start.position,@arfin.end.position )
		end if @arfin
		if @lineai && @linead
			# Si existe la interseccion movemos el extremo
			@pt1 = pt0 if pt0 = Geom.intersect_line_line([@pt1, @pt2], @lineai)
			@pt3 = pt0 if pt0 = Geom.intersect_line_line([@pt3, @pt4], @linead)
		elsif @arini
			pt0 = Geom.intersect_line_line([@pt1, @pt2], @arini.line)
			pt1 = Geom.intersect_line_line([@pt3, @pt4], @arini.line) if @pt4!=[]
			if 	punto_en_segmento(pt0,@arini.start.position,@arini.end.position )
				@pt1 = pt0 
				@pt3 = pt1 
				#@pulsado_tab = true
				return true
			end if punto_en_segmento(pt1,@arini.start.position,@arini.end.position )
			if !@pulsado_tab
				i += 1 
				tabulador 
			end 
		end	
		i = 5 if !@arini || @pulsado_tab
	end
	@pulsado_tab = true
end
 
def onMouseMove(flags, x, y, view)
	@ip1.pick(view, view.screen_coords(@ptini).x, view.screen_coords(@ptini).y) if @tramo
    return false if( !@ip.pick(view, x, y, @ip1))
	texto_comando # por si se ha borrado con otro comando
	# pone tooltip segun el elemento al que se aproxime
	view.tooltip = @ip.tooltip
	if !@primer_punto
		view.invalidate if @arini = busca_cara(x, y, view)
    else
		@ptfin = @ip.position
		@ptfin.z=@ptini.z
		vec = @ptini - @ptfin
		Sketchup::set_status_text vec.length.to_s, SB_VCB_VALUE
		calcula_puntos if vec.length > 0
		@arfin = busca_cara(x, y, view)
	end
	view.invalidate
end
 
def haz_muro
	@tramo=true
	puntos = intermedios([@pt1,@pt2], false,false).unshift(@pt1)
	pt1 = puntos.last
	puntos = puntos + intermedios([@pt2,@pt4], false,false).unshift(@pt2)
	x = intermedios([@pt4,@pt3], false,false).unshift(@pt4)
	pt2 = @pt3
	pt2 = x[1] if x.size > 1
	puntos = puntos + x
	puntos = puntos + intermedios([@pt3,@pt1], false,false).unshift(@pt3)
	face = Sketchup.active_model.active_entities.add_face puntos 
	pon_color(face,@@color_superficies)
	selborrar = []
	Sketchup.active_model.active_entities.each do |e|
		if e.is_a?(Sketchup::Edge)
			if face.classify_point(punto_medio(e.start.position,e.end.position)) == Sketchup::Face::PointInside
				selborrar.push(e)
			end
		end
	end
	Sketchup.active_model.active_entities.erase_entities selborrar if selborrar != []
	# conservamos las lineas para interseccion en calcula puntos
	@lineai = [@pt1, @pt2]
	@linead = [@pt3, @pt4]
	# sacamos el extremo frontal
	linea_ult = Sketchup.active_model.active_entities.add_line @pt2, @pt4
	pon_color(linea_ult,@@color_lineas)
	# sacamos los vertices
	@vertice1 = linea_ult.start
	@vertice2 = linea_ult.end
	# guardamos las caras
	caras = face.edges
	caras.each do |e|
		pon_color(e,@@color_lineas)
	end
	# borramos aristas coincidentes
	borra_coplanarias(caras, Sketchup.active_model.active_entities)
	@ptini = @ptfin
	# si se ha borrado la cara frontal del muro
	if linea_ult.deleted? || @vertice2.deleted? || @vertice1.deleted? #|| @arfin
		reset
		# salimos sin inicioundo
		return false
	end
	return true
end
def create_muro
	finalundo
	if @lineai && @linead
		# Si existe la interseccion movemos el extremo
		vec = @pt1-@vertice1.position
		Sketchup.active_model.active_entities.transform_entities(vec, @vertice1) if vec.length > 0 && !@vertice1.deleted?
		vec = @pt3-@vertice2.position
		Sketchup.active_model.active_entities.transform_entities(vec, @vertice2) if vec.length > 0 && !@vertice2.deleted?
	end
	inicioundo(CambiaIdioma("绘制墙体")) if haz_muro
	@pulsado_tab = false
end
def onLButtonDown(flags, x, y, view)
	borra_auxiliares
	#@ip1.copy! @ip  #Con esta da un error Bug Splat al cliquear en el punto medio de extremos de muro
	@ip1.pick(view,x,y,@ip)
	if !@primer_punto
		inicioundo(CambiaIdioma("绘制墙体"))
		@ptini = @ip.position
		Sketchup::set_status_text CambiaIdioma("长度"), SB_VCB_LABEL
		@primer_punto = true
	else
		create_muro
		@arini = nil
		@long_usuario = false
	end
	crea_auxiliares(@ptini)
	texto_comando
	view.lock_inference
end
def longitud_usuario(valores, view) # view por si un dia funciona el posicionar el cursor
	# longitud del muro
	vec = @ptfin - @ptini
	if( vec.length > 0.0 )
		valores.each do |value|
			vec = @ptini - @ptfin if con_coma(value,nil).to_l < 0
			vec.length = value.to_l.abs 
			@ptfin = @ptini.offset(vec)
			calcula_puntos
			ptperp = @ptini.transform(Geom::Transformation.rotation(@ptfin, [0,0,1], Math::PI/2))
			create_muro
			@ip1.pick(view, view.screen_coords(@ptfin).x, view.screen_coords(@ptfin).y) 
			@arini = nil
			#@ptfin = ptperp
			@ptini = @ptfin
			#vec = @ptfin - @ptini
			#view.invalidate
		end
	end
end
def onUserText(text, view)
	text=con_coma(text,nil)
	valores = text.split("*") #muro paralelo
    value = valores[1].to_i
	if value > 0
		muro_multiplica(value)
		return
	end
	if text[0].chr == '/'
		valores = text.split("/") #muro paralelo 
		value = valores[1].to_i
		if value >  0
			muro_multiplica(1.0/value)
			return
		end
	end	
	valores = text.split("<")
	if valores[1]
		angulo = valores[1].to_f.degrees
		@@hv = [Math.cos(angulo), Math.sin(angulo)]
		borra_auxiliares
		crea_auxiliares(@ptini) if @primer_punto
		return
	end
	# Aqui se introducen las longitudes si positivas o el grueso negativo
	valores = text.split(@@separador_listas)
	value=long_valida(valores[0])
    if value
		if value < 0 then
			# grueso del muro
			@@muro_width = value.abs.to_l
			texto_comando
			calcula_puntos
		else
			borra_auxiliares
			longitud_usuario(valores, view)
			crea_auxiliares(@ptini)
		end
		view.invalidate
		#return
	end
end
def draw(view)
 	textoevaluacion(view)
    # Muestra el punto actual
	@ip.draw(view) if( @ip.valid? && @ip.display? )
	@ip1.pick(view, view.screen_coords(@ptini).x, view.screen_coords(@ptini).y) if @tramo
	@ip1.draw(view) if(@ptfin != [] && @ip1.valid? && @ip1.display? )
	# pone en magenta las lineas a las que engancha
    if !@arini.deleted?
		view.line_width = 4
		view.drawing_color = "magenta"
		view.draw(GL_LINES, @arini.start.position,@arini.end.position)
	end if @arini
    if !@arfin.deleted?
		view.line_width = 4
		view.drawing_color = "magenta"
		view.draw(GL_LINES , @arfin.start.position,@arfin.end.position)
	end if @arfin
    # previsualiza el muro
    view.drawing_color = "black"
    view.line_width = 1 
    inference_locked = view.inference_locked?
	view.set_color_from_line(@ip1, @ip) if @primer_punto
	view.line_width = 4 if inference_locked
	if @primer_punto
		view.line_stipple='-.-'
		view.draw(GL_LINE_STRIP, @ptini, @ptfin)
		view.line_stipple=''
		view.draw(GL_LINE_STRIP, @pt2, @pt4) if @pt4!=[]
		view.draw(GL_LINE_STRIP, @pt1, @pt2) if @pt2!=[]
		view.draw(GL_LINE_STRIP, @pt3, @pt4) if @pt4!=[]
		view.draw(GL_LINE_STRIP, @vertice1.position, @pt1) if @vertice1
		view.draw(GL_LINE_STRIP, @vertice2.position, @pt3) if @vertice2
		view.draw(GL_LINE_STRIP, @pt1, @pt3) if !@vertice1 && @pt3!=[]
	end
end
def tabulador
	if @@muro_inc then
		@@muro_cara += 0.5
	elsif
		@@muro_cara -= 0.5
	end	
	@@muro_inc = !@@muro_inc if @@muro_cara != 0.5
end
def onKeyDown(key, rpt, flags, view)
	if(key == 9 && WIN) ||(key==VK_CONTROL && MAC) then
		borra_auxiliares
		tabulador
		calcula_puntos
		crea_auxiliares(@ptini) if @comando_en_curso=="墙"
		view.invalidate
		@pulsado_tab = true if @primer_punto
	elsif key == 119 #F8
		lb = @arfin.line 
		if lb
			@@hv = [lb[1][0],lb[1][1]] #coseno y seno del angulo
			borra_auxiliares
			crea_auxiliares(@ptini) if @primer_punto
		end
	elsif( key == CONSTRAIN_MODIFIER_KEY && rpt == 1 )
        # Si esta activado desactivarlo
        if( view.inference_locked? )
            view.lock_inference
        elsif !@primer_punto
            view.lock_inference @ip
        elsif
            view.lock_inference @ip, @ip1
		end
	end	
end	
def onKeyUp(key, rpt, flags, view)
	if(key == CONSTRAIN_MODIFIER_KEY && view.inference_locked?)
		view.lock_inference
    end
end
end # de la clase Muro
class Dibac_Murop < Dibac_Muro
=begin
 Clase	        		:	Murop
 Desciende de		:	Muro
 Descripción   		:	Dibuja muros paralelos a una linea cualquiera en planta
 Item de Menu  	:	Dibujo->Dibac->Muro paralelo // Barra de herramientas Dibac
 Menú contextual	:	NO
 Uso         			:	Primero se tiene que proporcionar la linea base que aparecera en magenta
								Luego se arrastra el muro hasta la posicion deseada.
								Pulsando [Tab] se cambia la cara de enganche entre izquierda,
								centro y derecha sucesivamente.
								Si se introdue un numero positivo se toma como distancia a la linea base.   
								Si se introduce un numero negativo se toma como espesor del	muro.
								Para terminar una secuencia de muro paralelo se pulsa [Esc].
             		  
 Fecha        			:	14/11/2010
=end
def reset
	@tramo=nil
	@comando_en_curso = "偏移墙体"
	@primer_punto = @pulsado_tab = false
	# puntos temporales para el muro enganchado al cursor
	@ptini = @ptfin = @pt1 = @pt2 = @pt3 = @pt4 = []
	# aristas a las que se engancha al principio y al final
	@arini = @arfin = @lineai = @linead = @vertice1 = @vertice2 = nil
	Sketchup::set_status_text "", SB_VCB_LABEL
	Sketchup::set_status_text "", SB_VCB_VALUE
	texto_comando
end
def deactivate(view)
	view.invalidate
	@@penultima_dist=@ultima_dist if @ultima_dist
end	
def create_muro
	inicioundo(CambiaIdioma("偏移墙体"))
	@ultp1=@lbase.start.position
	@ultp2=@lbase.end.position
	@ultimo_punto=@primer_punto
	@@penultima_dist=@ultima_dist if @ultima_dist
	@ultima_dist=@perp.length
	haz_muro
	finalundo
	reset
end
def muro_multiplica(value)
	if( @perp.length > 0.0 )
		if !@primer_punto 
			Sketchup.undo
			inicioundo(CambiaIdioma("偏移墙体"))
			longitud=@perp.length
			if value>=1
				paso = longitud 
			else
				paso = longitud*value
				value=1/value
			end
			for i in 1..value
				@perp.length=paso*i
				@primer_punto=@ultimo_punto
				@lbase=Sketchup.active_model.active_entities.add_line @ultp1, @ultp2	
				@ptini = @lbase.start.position.offset(@perp)
				@ptfin = @lbase.end.position.offset(@perp)
				calcula_puntos
				haz_muro
			end
			finalundo
			@perp.length = longitud
			reset
		end
	end	
end
def texto_comando
	return if !@comando_en_curso
	texto = CambiaIdioma(@comando_en_curso)+"["+@@muro_width.to_l.to_s+"]。"
	if !@primer_punto
		texto = texto + CambiaIdioma("基线")
	else
		texto = texto + CambiaIdioma("墙的位置")
	end
	texto = texto + ", " + CambiaIdioma("或指定墙体厚度，按") + " '-'。"
	if @primer_punto
		texto = texto + " Tab="+CambiaIdioma("切换基线")+"。" if WIN
		texto = texto + " Ctrl="+CambiaIdioma("切换基线")+"。" if MAC
	end	
	Sketchup::set_status_text texto
end		
def onSetCursor
	UI.set_cursor(@@muropcursor_id)
end
def onMouseMove(flags, x, y, view)
	texto_comando
    return false if !@ip.pick(view, x, y, @ip1) 
	# pone tooltip segun el elemento al que se aproxime
	view.tooltip = @ip.tooltip
	if !@primer_punto
		view.invalidate if @arini = busca_cara(x, y, view)
    else
	    @ptfin = @ip.position
        @ptini = @ptfin.project_to_line [@lbase.start,@lbase.end]
        @perp = @ptfin - @ptini
		Sketchup::set_status_text @perp.length.to_s, SB_VCB_VALUE
		@ptini = @lbase.start.position.offset(@perp)
		@ptfin = @lbase.end.position.offset(@perp)
		calcula_puntos
	end
	view.invalidate
end
def onLButtonDown(flags, x, y, view)
	if !@primer_punto
		#@ip1.copy! @ip
		@ip1.pick(view,x,y,@ip)
		@lbase = busca_cara(x, y, view)
		if @lbase	
			#crea_auxiliares(@ip.position)
			@primer_punto = true
		end	
	else
		create_muro
	end
	texto_comando
	view.lock_inference
end
def onLButtonDoubleClick(flags, x, y, view)
	if @@penultima_dist
		longitud_usuario([@@penultima_dist.to_s],view) if @@penultima_dist>0
	end	
end
def longitud_usuario(valores, view) 
	# distancia a paralela
	if( @perp.length > 0.0 )
		if !@primer_punto 
			Sketchup.undo
			@primer_punto=@ultimo_punto
			@lbase=Sketchup.active_model.active_entities.add_line @ultp1, @ultp2
		end
		@perp.length = valores[0].to_l
		@ptini = @lbase.start.position.offset(@perp)
		@ptfin = @lbase.end.position.offset(@perp)
		calcula_puntos
		create_muro
	end	
end
end # de la clase Murop
class Dibac_Estiramuro < Dibac_Muro
=begin
 Clase	        		:	Estiramuro
 Desciende de		:	Muro
 Descripción   		:   Estira/acorta un muro existente
 Item de Menu  	:	Dibujo->Dibac->Prolongar muro // Barra de herramientas Dibac
 Menú contextual	:	NO
 Uso         			:	Se marca el muro por una de las caras en un punto proximo al extremo que queremos mover
								la linea elegida se marcara en magenta.
								Luego se arrastra el extremo hasta la posicion deseada.
             		  
 Fecha        			:	14/11/2010
=end
def menu
	nolicencia(false)
end	
def reset
	@tramo=nil
	@comando_en_curso = "延伸墙体"
	Sketchup.active_model.abort_operation if @primer_punto
	@primer_punto = false
	@pt1 = @pt2 = @pt3 = @pt4 = @vertice1 = @vertice2 = nil
	@arini = @arfin = nil
end
def create_muro
	haz_muro
	finalundo
end
def texto_comando
	return if !@comando_en_curso
	texto = CambiaIdioma(@comando_en_curso)+": "
	if !@primer_punto
		texto = texto+CambiaIdioma("确定要延伸的边")+"。"
	else
		texto = texto+CambiaIdioma("确定新的位置")+"。"
	end	
	Sketchup::set_status_text texto
end		
def onSetCursor
	UI.set_cursor(@@estiramurocursor_id)
end
def calcula_puntos
	if @arfin 
		pt0 = Geom.intersect_line_line([@pt1, @pt2], @arfin.line)
		@pt1 = pt0 if pt0
		@pt3 = @pt1.project_to_line [@puntos[1], @puntos[3]]
		pt0 = Geom.intersect_line_line([@pt3, @pt4], @arfin.line)
		@pt3 = pt0 if punto_en_segmento(pt0, @arfin.start.position, @arfin.end.position)	
	else
		@pt1 = @ip.position.project_to_line [@puntos[0], @puntos[2]]
		@pt3 = @pt1.project_to_line [@puntos[1], @puntos[3]]
	end
end
def onMouseMove(flags, x, y, view)
	texto_comando
    return false if !@ip.pick(view, x, y, @ip1) 
	# pone tooltip segun el elemento al que se aproxime
	view.tooltip = @ip.tooltip
	if !@primer_punto
		view.invalidate if @arini = busca_cara(x, y, view) #@arini para que se ponga roja
    else
		@arfin = busca_cara(x, y, view)
		calcula_puntos
	end
	view.invalidate
end
def onLButtonDown(flags, x, y, view)
	if !@primer_punto
		pt = @ip.position
		cara = busca_cara(x, y, view)
		if cara	
			otracara=otra_cara_perp(cara, pt)
			return false if !otracara
			inicioundo(CambiaIdioma("延伸墙体"))
			@puntos = borra_muro(x, y, view, false)
			lado =(@puntos[0] - pt).length - (@puntos[2] - pt).length
			if lado	<= 0 
				@pt1 = @puntos[0]
				@pt2 = @puntos[2]
				@pt3 = @puntos[1]
				@pt4 = @puntos[3]
			else
				@pt1 = @puntos[2]
				@pt2 = @puntos[0]
				@pt3 = @puntos[3]
				@pt4 = @puntos[1]
			end	
			@primer_punto = true
			@arini = nil
			calcula_puntos
		end	
		@ip1.copy! @ip # si se pone al principio da error en el punto medio
	else
		@primer_punto = false # para que no haga reset
		create_muro
		reset
	end
	texto_comando
	view.lock_inference
	view.invalidate
end
end # de la clase Estiramuro
class Dibac_Componente < Dibac_Base
def menu
	nolicencia(false)
	prompts=[]
	defaults=[]
	list=[]
	if @carp_attributes
		@carp_attributes.each do |key|
			prompts.push(CambiaIdioma(@carp_prompts[key]))
			if @carp_units[key] == 'INTEGER'
				defaults.push(@carp_defaults[key].to_i)
			else
				defaults.push(@carp_defaults[key].to_f.to_l)
			end
			list.push("") #de momneto hasta que sepamos poner opciones
		end
	else
		Sketchup.active_model.select_tool nil	
		return
	end	
	input = UI.inputbox prompts, defaults, list, CambiaIdioma(@comando_en_curso)+": "+@carp_name
	if input
		texto=@carp[0]
		i=0
		@carp_attributes.each do |key|
			if @carp_units[key] == 'INTEGER'
				valor=input[i].to_i
			else
				valor=a_longitud(input[i]).to_f#.abs #en principio todos positivos
			end
			@carp_defaults[key]=valor
			texto=texto+'#'+valor.to_s
			i += 1
		end	
		Sketchup.write_default('dibac', @carp_registro, texto)
	else
		Sketchup.active_model.select_tool nil	
		return
	end if prompts.size>0
	reset
end
def reset
	#Sketchup.active_model.active_entities.add_instance(@bloque2d.definition, Geom::Transformation.new)
	@mocheta=0 #para que genere la carpinteria
	puntos_2d(false)
end 
def onLButtonDown(flags, x, y, view)
	colocar_bloque
	view.invalidate	
end
def saca_bloque_2d(carpinteria)
	@iguales=false
	definicion=nil
	#inicioundo(CambiaIdioma(@comando_en_curso))
	Sketchup.active_model.definitions.each{|d| definicion=d if d.name == @carp_name} #el bloque completo no lo tengo que repetir
	if !definicion
		Sketchup.active_model.start_operation('', true, true, true)
		definicion=Sketchup.active_model.definitions.load(carpinteria[0])
	end
	bloque2d=carpinterias_2d3d(definicion)[0]
	bloque2d.delete_attribute('dibac','2d') #por si esta en el bloque
	#@@carp_1_attributes.each{|key| bloque2d.set_attribute('dynamic_attributes', key, @@carp_1_defaults[key])}
	#	ahora buscamos en definiciones de nuevo y si esta tiene trim y todo lo demas
	Sketchup.active_model.definitions.each do |d|
		#por si no hay instancias pero si una definicion válida
			#UI.messagebox(d.name + ' - ' + bloque2d.name.to_s+' - ' + d.get_attribute('dibac','2d').to_s) if d.name.split('#')[0] == bloque2d.name.split('#')[0]
			if d.name.split('#')[0] == bloque2d.name.split('#')[0] && d.get_attribute('dibac','2d') #&& d.name.split('#').size > 1
			@iguales=true
			@carp_attributes.each do |a|
				@iguales= false if d.get_attribute('dynamic_attributes', a).to_s != @carp_defaults[a].to_s
#				UI.messagebox(d.name+' - '+@iguales.to_s+' - '+d.get_attribute('dynamic_attributes', a).to_s+' - '+@carp_defaults[a].to_s)
			end
			#UI.messagebox(d.name+' - '+@iguales.to_s)
			@iguales=false if d.get_attribute('dibac', 'mocheta').to_f.to_l != @mocheta.to_f.to_l
			#UI.messagebox(d.name+' - '+@iguales.to_s+' - '+ancho_trim(d).to_f.to_l.to_s+' - '+@mocheta.to_f.to_l.to_s)
			@iguales=false if d.get_attribute('dynamic_attributes', 'dibacmax').to_f.to_l != @dibacmax.to_f.to_l
			#UI.messagebox(d.name+' - '+@iguales.to_s+' - '+d.get_attribute('dynamic_attributes', 'dibacmax').to_f.to_l.to_s+' - '+@dibacmax.to_f.to_l.to_s)
			@iguales=false if d.get_attribute('dynamic_attributes', 'dibacfit').to_f.to_l != @dibacfit.to_f.to_l
			return d if @iguales
		end	
	end
	return bloque2d 
end
def onCancel(flag, view)
	if flag  == 0
		reset 
		hueco_pantalla(false) if !@pulsado_alt
		view.invalidate
	else #Ctrl-Z
		Sketchup.active_model.select_tool nil
	end	
	
	#menu if flag==0 #para diferenciarlo de Ctrl-Z
end
end
class Dibac_Mobiliario < Dibac_Componente
=begin
 Clase	        		:	Mobiliario
 Desciende de		:	Base
 Descripción   		:	Dibuja componentes en 2d y 3d
 Item de Menu  	:	Dibujo->Dibac->Mobiliario // Barra de herramientas Dibac
 Menú contextual	:	NO
 Uso         			:	Se elige el componente y se coloca
								Pulsando [Tab] se cambia elpunto de enganche entre extremo y centro.
								Los parametro por texto anchos se introducen en la forma param1;param2; ...
								Se puede omitir cualquiera los lados del ";" y se actuara solo sobre el lado introducido.
								Si despues del ; ponemos el signo = el dato correspondiente sera igual al anterior.
								Introduciendo un numero negativo indicamos que queremos forzar la colocacion a una distancia. 
								Cuando esta activa la colocacion forzada, la tecla Tab cambia entre extremo y centro. 
								La posicion forzada se calcula siempre sobre el tramo comun entre la cara interior
								y exterior del muro.
 Fecha        			:	24/08/2013
=end
def initialize
	@comando_en_curso = "Choose component"
	@carp = Sketchup.read_default('Dibac', 'Component', Sketchup.find_support_file("dibac_table.skp","plugins/indoor")).split('#')
	@carp= ['./dibac_table.skp'] if @carp.size == 0
	archivo = UI.openpanel(DibacStrings.GetString(@comando_en_curso), File.dirname(@carp[0]) ,File.basename(@carp[0])) 
	if archivo
		if archivo != @carp[0]
			Sketchup.write_default('Dibac','Component', archivo.gsub('\\','/')) 
			@carp = Sketchup.read_default('Dibac', 'Component', Sketchup.find_support_file("dibac_table.skp","plugins/indoor")).split('#')
			@carp= ['./dibac_table.skp'] if @carp.size == 0
		end	
		@carp_registro='Component'
		saca_menu
		Sketchup::set_status_text "", SB_VCB_LABEL
		Sketchup::set_status_text "", SB_VCB_VALUE
		texto_comando
		@ip = Sketchup::InputPoint.new
		@transf_nula = Geom::Transformation.new
	end	
end
def texto_comando
	texto = CambiaIdioma("Select position")
	Sketchup::set_status_text texto
end
def draw(view)
	return if !@p_c
	textoevaluacion(view)
    # Muestra el punto actual
    if( @ip.valid? && @ip.display? )
        @ip.draw(view)
    end
	@transform = Geom::Transformation.translation @ip.position
	ptos = []
	@p_c.each do |pt|
		ptos.push pt.transform(@transform)
	end 
	#@p_t.each do |pt|
		#ptos.push pt.transform(transform)
	#end 
	view.draw(GL_LINES, ptos)  if ptos  != []
end
def onMouseMove(flags, x, y, view)
	#ip.pick(view, x, y)
    return false if( !@ip.pick(view, x, y) )
	# pone tooltip segun el elemento al que se aproxime
    texto_comando #por si se ha borrado
	view.tooltip = @ip.tooltip
	@ph1 = @ip.position
	view.invalidate
end
def puntos_2d(enmuro)
	bloque2d=saca_bloque_2d(@carp)
	if bloque2d.is_a?(Sketchup::ComponentDefinition) && !@iguales
		Sketchup.active_model.start_operation('Esto es lo que hay primero', true, true, true)
		puerta=Sketchup.active_model.active_entities.add_instance(bloque2d, @transf_nula)
		@carp_attributes.each{|key| puerta.set_attribute('dynamic_attributes', key, @carp_defaults[key])} 
		puerta.set_attribute('dibac','2d', @carp) #esto se pone ya en el primero
		#diccionario.each{|key, value| puerta.set_attribute('dynamic_attributes', key, value) if key[0,5] == 'dibac' || key[0,6] =='_dibac'} if diccionario
		puerta.set_attribute('dibac','mocheta', 0) #para diferenciarlo de carpinteria
		$dc_observers.get_latest_class.redraw_with_undo(puerta)
		Sketchup. active_model.start_operation('Esto es lo que hay despues', true, true, true)
		#UI.messagebox(puerta.definition.get_attribute('dibac','2d'))
		@puerta2d=puerta.definition 
		if puerta.definition.name == bloque2d.name #no ha creado cornucopia del bloque
			#Sketchup.active_model.active_entities.erase_entities(Puerto)
			
			bloquenuevo=Sketchup.active_model.definitions.add(Sketchup.active_model.definitions.unique_name(bloque2d.name))
			#puerta=Sketchup.active_model.active_entities.add_instance(bloquenuevo, @transf_nula)
			bloque2d.attribute_dictionaries.each do |d|
				d.each{|key, value| bloquenuevo.set_attribute(d, key, value)}
			end	
			bloquenuevo.entities.add_instance(bloque2d, @transf_nula).explode
			@puerta2d = bloquenuevo
		end
		diccionario=bloque2d.attribute_dictionary('dynamic_attributes')
		diccionario.each{|key, value| @puerta2d.set_attribute('dynamic_attributes', key, value) if key[0,5] == 'dibac' || key[0,6] =='_dibac'} if diccionario
		@carp_attributes.each{|key| @puerta2d.set_attribute('dynamic_attributes', key, @carp_defaults[key])}
		@puerta2d.set_attribute('dibac','2d', @carp) #esto se pone ya en el primero
		@puerta2d.set_attribute('dibac','mocheta', 0) #para diferenciarlo de carpinterias
		$dc_observers.get_latest_class.redraw(puerta)
		borra_nulos(@puerta2d) 
		Sketchup.active_model.active_entities.erase_entities(puerta)
		#Sketchup. active_model.commit_operation
	else
		@puerta2d=bloque2d.definition if bloque2d.is_a?(Sketchup::ComponentInstance)
		@puerta2d=bloque2d if bloque2d.is_a?(Sketchup::ComponentDefinition)
	end	
	ptos= saca_puntos([],[],@puerta2d, nil, false, true) 	#el primer bloque no tiene transformacion
	@p_c = ptos[0]   
end	
def colocar_bloque
	pto_carpinteria = @ip.position
	finalundo
	inicioundo('Colocar carpinteria')
	#puerta=Sketchup.active_model.active_entities.add_instance @puerta2d, @transform
	# sacamos el bloque por si se ha borrado con undo
	puntos_2d(false) 
	puerta=Sketchup.active_model.active_entities.add_instance saca_bloque_2d(@carp), @transform
	puerta.set_attribute('dibac','2d', @carp) #esto se pone ya en el primero 
	finalundo
	Sketchup.active_model.selection.clear
	Sketchup.active_model.selection.add puerta
	Sketchup.send_action "selectMoveTool:"
end
end
class Dibac_Carpinteria < Dibac_Componente
=begin
 Clase	        		:	Carpinteria
 Desciende de	 	:	Base
 Descripción   		:	Dibuja carpinterias en muros
 Item de Menu  	:	Dibujo->Dibac->Puerta/ventana/armario/generica // Barra de herramientas Dibac
 Menú contextual	:	NO
 Uso         			:	Para dibujar la carpinteria primero se tiene que proporcionar la cara del muro
								Cuando la carpinteria se puede colocar se muestra coloreada en coral.
								Pulsando boton izquierdo fuera de un muro se cambia el sentido.
								Pulsando [Tab] se cambia elpunto de enganche entre extremo y centro.
								Los parametro por texto anchos se introducen en la forma param1;param2; ...
								Se puede omitir cualquiera los lados del ";" y se actuara solo sobre el lado introducido.
								asi, por ejemplo,para introducir solo hoja 2 y dejar hoja1 como estaba: ;hoja2
								para hacer puertas de una sola hoja: ;0
								Si despues del ; ponemos el signo = el dato correspondiente sera igual al anterior.
								Introduciendo un numero negativo indicamos que queremos forzar la colocacion a una distancia. 
								Cuando esta activa la colocacion forzada, la tecla Tab cambia entre extremo y centro. 
								La posicion forzada se calcula siempre sobre el tramo comun entre la cara interior
								y exterior del muro.
 Fecha        			:	24/08/2013
=end
def draw(view)
	return if !@ancho || !@p_c
	textoevaluacion(view)
    # Muestra el punto actual 
    if( @ip.valid? && @ip.display? )
        @ip.draw(view)
    end
    # previsualiza la carpinteria
	if @primer_punto 
		pto_carpinteria = @primer_punto
	else
		pto_carpinteria = @ip.position
	end
	if puntos_hueco(pto_carpinteria) #aqui se decide donde se coloca la carpinteria
		#set_transform(true)
		#puntos_2d(true) if !@primer_punto
		view.drawing_color = "magenta"
		view.line_width = 2
		#view.draw(GL_LINES, @ph1, @ph4)  #diagonales
		#view.draw(GL_LINES, @ph3, @ph2)
	else 
		view.drawing_color = "black"
		view.line_width = 1
		@ph1 = pto_carpinteria
		set_transform(false) 
	end
	ptos = []
	@p_c.each do |pt|
		ptos.push pt.transform(@transform)
	end 
	@p_t.each do |pt|
		ptos.push pt.transform(@transform)
	end if @notrim
	view.draw(GL_LINES, ptos)  if ptos  != []
end
def init_carpinteria
	saca_menu
	if @carp.size>0
		i=1
		@carp_attributes.each do |key|
			@carp_defaults[key] = @carp[i] if i<@carp.size
			i += 1
		end if @carp.size>1	
	end 
	@dibacmax = 0 
	@grueso_muro=@@muro_width if !@grueso_muro
	@ip = Sketchup::InputPoint.new
	@transform = Geom::Transformation.new
	@transf_nula = Geom::Transformation.new
	@cara1 = @carpinteria = nil
	@angulo1 = 0.0
	@angulo2 = Math::PI*3/2
	Sketchup::set_status_text "", SB_VCB_LABEL
	Sketchup::set_status_text "", SB_VCB_VALUE
	@simetria_hueco = 1
	@pulsado_alt = false
	texto_comando
end
def texto_comando
	texto = CambiaIdioma(@carp_registro)+" ["
	semicolon=false	
	@carp_attributes.each do |a|
		texto=texto+';' if semicolon
		semicolon=true
		texto=texto+@carp_defaults[a].to_f.to_l.to_s
	end
	texto = texto +"] ["+CambiaIdioma("Force")+" "
	texto = texto + @distancia_carpinteria.to_l.to_s 
	texto = texto +"]. "+CambiaIdioma("Select a wall, new values, or distance preceded by")
	texto=texto+" '-', Ctrl=" if WIN
	texto=texto+" '-', Option=" if MAC
	texto = texto +CambiaIdioma("Force")
	texto = texto +", Tab="+CambiaIdioma("Center/End") if WIN
	texto = texto +", Ctrl="+CambiaIdioma("Center/End") if MAC
	texto = texto + ', '+CambiaIdioma("Shift")+"="+CambiaIdioma("Max.") if @puede_max
	Sketchup::set_status_text texto
end
def set_transform(enmuro)
	return if !@angulo1 || !@angulo2
	pi =Math::PI
	if @angulo1 < pi/2  
		if @angulo2 > pi 
			@angulo2=@angulo2-2*pi
		end
	end	
	if @angulo1 >= 3*pi/2  
		if @angulo2 < pi 
			@angulo2=@angulo2+2*pi
		end
	end	
	if !enmuro
		@transform = Geom::Transformation.translation @ph1-[@carpinteria_hueco*@ancho/2,0,0] 
	else	
		@transform = Geom::Transformation.translation @ph1
	end	
	@transform =(Geom::Transformation.scaling(@ph1,1,-1,1)) * @transform if @angulo2 > @angulo1
	@transform =(Geom::Transformation.rotation @ph1, [0,0,1], @angulo1) * @transform 
	@ph2=@pt2.transform(@transform)
	@ph3=@pt3.transform(@transform)
	@ph4=@pt4.transform(@transform)
end
def hueco_maximo(extremos1, extremos2) # hay una definicion particular en armario
	return tramo_comun(extremos1, extremos2)
end
def extremo_mocheta(p1,p2) #busca el vertice coincidente con el punto contrario del muro que sale de una carpinteria
	Sketchup.active_model.active_entities.each do |e|
		if e.is_a?(Sketchup::Edge)
			otrovertice=nil
			if e.start.position == p1 
				otrovertice=e.end.position
			elsif e.end.position == p1
				otrovertice=e.start.position
			end	
			if otrovertice
				return otrovertice if otrovertice.on_line?([p1,p2])
			end	
		end
	end
	return p1	
end
def puntos_hueco (posicion)
	if !@carpinteria
		@cara1 = @cara_ventana if @cara_ventana
		return false if !@cara1 
		@cara2 = otra_cara_perp(@cara1, posicion)	
		return false if !@cara2
		extremos1=edge_extremos(@cara1)
		extremos2=edge_extremos(@cara2)
	else #si carpinteria buscamos los extremes a partir de las mochetas
		ptos1 = muro_carpinteria(@carpinteria)[0]
		direccion = (ptos1[0]-ptos1[3])
		#Ahora buscamos los extremos de los muros al que van a las mochetas
		#Se almacenan en el mismo orden que los de muro_carpinteria
		ptos2=[]
		ptos2.push(extremo_mocheta(ptos1[0],ptos1[3])	)	
		ptos2.push(extremo_mocheta(ptos1[1],ptos1[2])	)	
		ptos2.push(extremo_mocheta(ptos1[2],ptos1[1])	)	
		ptos2.push(extremo_mocheta(ptos1[3],ptos1[0])	)	
		
		#ptos2.each {|p| Sketchup.active_model.active_entities.add_cpoint(p)}
		
		# Si forzamos o agarramos por el centro utilizamos todo el tramo
		if @maximo_hueco  || @@forzar_carpinteria || @carpinteria_hueco != 0 || @dibacfit
			extremos1=[ptos2[0],ptos2[3]]
			extremos2=[ptos2[1],ptos2[2]]
			posicion=posicion.project_to_line(extremos1)
			posicion=punto_medio(ptos1[0],ptos1[3]) if @carpinteria_hueco != 0
		elsif posicion.distance(ptos1[0]) < posicion.distance(ptos1[3])
			extremos1=[ptos1[0],ptos2[3]]
			extremos2=[ptos1[1],ptos2[2]]
			posicion=ptos1[0]
		else	
			extremos1=[ptos2[0],ptos1[3]]
			extremos2=[ptos2[1],ptos1[2]]
			posicion=ptos1[3]
		end
	end
	#segmento util de @cara1
	ptos = hueco_maximo(extremos1, extremos2)
	return false if !ptos #armario puede devolver false
	ptini = ptos[0]
	ptfin = ptos[1]
	@angulo1 = angulo_recta(ptos[0], ptos[1])
	@angulo2 = angulo_recta(ptos[0], ptos[0].project_to_line(extremos2))
	#gruesoant = @grueso_muro
	@grueso_muro =(ptos[0]- ptos[0].project_to_line(extremos2)).length
	if @mochetamin>0
		return false if @grueso_muro<@mochetamin
	end
	if @mochetamax>0
		return false if @grueso_muro>@mochetamax
	end
	#puntos_2d(true) if @grueso_muro != gruesoant
	# ptref1 y ptref 2 son los extremos del segmento utill
	if @simetria_hueco != 1 
		ptref1 = ptfin 
		ptref2 = ptini
	else
		ptref1 = ptini
		ptref2 = ptfin
	end	
	
	if @dibacfit != (ptini - ptfin).length #para armarios
		@dibacfit=(ptini - ptfin).length 
		@mocheta=0 #para que recalcule puntos
	end if @dibacfit 	
		
	if @maximo_hueco 
		#@ph1 = ptref1 
		if 	@dibacmax != (ptini - ptfin).length
			@dibacmax = (ptini - ptfin).length
			@mocheta=0 #para que recalcule puntos
		end
	end	
	#els
	if @@forzar_carpinteria || @dibacfit || @maximo_hueco
		if(posicion-ptini).length <(posicion-ptfin).length	
			@simetria_hueco = 1
			ptref1 = ptini
			ptref2 = ptfin
		else
			@simetria_hueco = -1
			ptref1 = ptfin
			ptref2 = ptini
		end	
		if @carpinteria_hueco != 0 || @dibacfit  || @maximo_hueco# por el centro
			@ph1 = punto_a_distancia(punto_medio(ptref1, ptref2), posicion, @ancho/2)
		else # por el extremo
			@ph1 = punto_a_distancia(ptref1, posicion, @distancia_carpinteria)
		end	
	else
		@ph1 = punto_a_distancia(posicion, ptref1, @ancho*@carpinteria_hueco/2)
	end
	if !punto_en_segmento(@ph1, ptini, ptfin)
		return false 		
	end if @mocheta != 0
	return false if !@ph1
	#no hace falta buscar @cara2
	#@cara2 = otra_cara_perp(@cara1, @ph1)	
	#if !@cara2
	#	@ancho = @ancho_anterior 
	#	return false 
	#end
	
	@ptperp=@ph1.project_to_line(extremos2) 
	#@ph2 = @ptperp
	vuelta = 0
	#vuelta=1 if @pantalla #no damos la vuelta a la carpinteria
	while vuelta < 2
		if ptref1 == ptini
			ptref1 = ptfin
			ptref2 = ptini
		else	
			ptref1 = ptini
			ptref2 = ptfin
		end  if @ph1 == ptref2
		#sacamos los puntos
		@simetria_hueco = -@simetria_hueco if @ph3 != punto_a_distancia(@ph1, ptref2, @ancho) && @primer_punto #bien porque @ancho es @pt3-@pt1
		@ph3 = punto_a_distancia(@ph1, ptref2, @ancho) #if !@primer_punto #Si @primer_punto viene calculado de puntos carpinteria
		#@ph4 = @ph3.project_to_line(extremos2) 
		@angulo1=0 #por si ancho no es mayor que cero
		@angulo1 = angulo_recta(@ph1, @ph3) if @ancho>0
		@angulo2 = angulo_recta(@ph1, @ptperp)
		set_transform(true)
		puntos_2d(true) if !@primer_punto
		if punto_en_segmento(@ph3, ptini, ptfin) && punto_en_segmento(@ph2, extremos2[0], extremos2[1]) && punto_en_segmento(@ph4, extremos2[0], extremos2[1]) 
			if @carpinteria
				return true
			else 
				return true if otra_cara_perp(@cara1, @ph3) == @cara2
			end	
		end	
		return false if @primer_punto
		@simetria_hueco = -@simetria_hueco 
		if ptref1 == ptini
			ptref1 = ptfin
			ptref2 = ptini
		else	
			ptref1 = ptini
			ptref2 = ptfin
		end  
		vuelta += 1
	end
	#@ancho = @ancho_anterior
	return false
end
def onMouseMove(flags, x, y, view)
	#ip.pick(view, x, y)
    return false if( !@ip.pick(view, x, y) )
	# pone tooltip segun el elemento al que se aproxime
    texto_comando #por si se ha borrado
	view.tooltip = @ip.tooltip
	if !@primer_punto
		@cara1 = busca_cara(x, y, view)
		@carpinteria = nil
		@carpinteria = busca_carpinteria(x, y, view) if !@cara1
		if !@carpinteria
			@ph1 = @ip.position
		else
		end
	else	
		@ancho=0 
		puntos_2d(false)  # cuando estamos en @pantalla o forzando
	end
	view.invalidate
end
def colocar_bloque
	if @cara1 && @pulsado_alt
		#@carpinteria_hueco = 0
		if !@primer_punto
			@primer_punto = @ph1
			@cara_ventana = @cara1
			return
		else
			@ph1 = @primer_punto
			Sketchup::set_status_text CambiaIdioma("Length"), SB_VCB_LABEL
		end
	end
	#@ph1=@ip.position if !@primer_punto
	if @primer_punto  
		pto_carpinteria = @primer_punto
	else
		pto_carpinteria = @ip.position
	end
	if puntos_hueco(pto_carpinteria)
		finalundo
		inicioundo('Colocar carpinteria')
		set_transform(true)
		#Sketchup.active_model.start_operation @comando_en_curso, false, true, true
		if @carpinteria
			borra_carpinteria(@carpinteria, nil)
			@carpinteria=nil
		end
		#mat = @cara1.material.color.to_i if @cara1.material
		#pon_color(Sketchup.active_model.active_entities.add_line(@ph1, @ph2),mat)
		#Sketchup.active_model.active_entities.add_line(@ph1, @ph2)
		#pon_color(Sketchup.active_model.active_entities.add_line(@ph3, @ph4),mat)
		#Sketchup.active_model.active_entities.add_line(@ph3, @ph4)
		0.step(@p_t.size-1, 2) do |i|
			Sketchup.active_model.active_entities.add_line(@p_t[i].transform(@transform), @p_t[i+1].transform(@transform)	)	
		end
		lborrar = Sketchup.active_model.active_entities.add_line @ph1, @ph3
		Sketchup.active_model.active_entities.erase_entities lborrar
		lborrar = Sketchup.active_model.active_entities.add_line @ph2, @ph4
		Sketchup.active_model.active_entities.erase_entities lborrar
		carp = pon_carpinteria
		pon_color(carp,@@color_lineas)
		#$dc_observers.get_latest_class.redraw_with_undo(carp)
		@primer_punto = @cara_ventana = false
		#@maximo_hueco = false
		finalundo
	else
		@simetria_hueco = -@simetria_hueco
		@angulo1 = angulo_inverso(@angulo1)
		@angulo2 = @angulo2 +2*Math::PI if @angulo2<0.0
		#puntos_2d(false)
	end
	
	#reset #creo que no hace falta 
	#puntos_2d
end
def pon_carpinteria
	#puerta = Sketchup.active_model.active_entities.add_instance @puerta2d, @transform
	puntos_2d(true) 
	puerta=Sketchup.active_model.active_entities.add_instance saca_bloque_2d(@carp), @transform
	puerta.set_attribute('dibac','2d', @carp) #esto se pone ya en el primero 
	#puerta.set_attribute('dynamic_attributes','dibacwthick', @mocheta) los dynamic no se pueden poner sin redibujar
	trim=nil
	puerta.definition.entities.each do |e| 
		if e.is_a?(Sketchup::ComponentInstance) || e.is_a?(Sketchup::Group)
			trim= e if e.name == 'DIBAC_TRIM'
		end	
	end
	#saca_puntos(puerta.definition, @transf_nula, false)
	if !trim
		trim=puerta.definition.entities.add_group
		trim.entities.add_line(@p_t[0],@p_t[1])
		trim.entities.add_line(@p_t[2],@p_t[3])
		trim.name = 'DIBAC_TRIM'	
	end		
	trim.transform!(Geom::Transformation.scaling(1, (@mocheta/(trim.bounds.max.y-trim.bounds.min.y)).to_f, 1))
	#@@carp_1_attributes.each{|key| puerta.set_attribute('dynamic_attributes',key, @@carp_1_defaults[key])} if !@iguales
	return puerta
end
def ancho_maximo(vf)
	@maximo_hueco = vf if @puerta2d.get_attribute('dynamic_attributes','dibacmax')
	@pulsado_alt = false
	@mocheta=0 if !vf
	@dibacmax=0 if !vf
end
def hueco_a_distancia(vf)
	@@forzar_carpinteria = vf
	@maximo_hueco = false
end
def hueco_pantalla(vf)
	return if @comando_en_curso != "Place window"
	@pantalla = vf
	@maximo_hueco = false
	reset
	return if !vf
	if otra_cara_perp(@cara1, @ip.position) 
		@primer_punto = @ip.position
		@cara_ventana = @cara1
		@ancho=0
	end if @cara1
end
def onKeyDown(key, rpt, flags, view)
	if(key == 9 && WIN) ||(key==VK_CONTROL && MAC) then #Tab
		@carpinteria_hueco += 1
		@carpinteria_hueco = 0 if @carpinteria_hueco > 1
		view.invalidate
	elsif key == CONSTRAIN_MODIFIER_KEY && !@primer_punto
		ancho_maximo(true)
		view.invalidate
	elsif key == COPY_MODIFIER_KEY && !@primer_punto
		@@forzar_carpinteria=true
		view.invalidate
	elsif key == ALT_MODIFIER_KEY
		@pulsado_alt=true
		if !@primer_punto
			hueco_pantalla(true)
			view.invalidate
		else
			@primer_punto=nil
		end	
	end	
	texto_comando
	no_menu=true if key == ALT_MODIFIER_KEY #No se porque pero funciona, no sale el menu
end	
def onKeyUp(key, rpt, flags, view)
	if key == CONSTRAIN_MODIFIER_KEY && !@primer_punto
		ancho_maximo(false)
		view.invalidate
	elsif key == COPY_MODIFIER_KEY && !@primer_punto
		@@forzar_carpinteria=false
		view.invalidate
	elsif key == ALT_MODIFIER_KEY 
		@pulsado_alt=false
		if !@primer_punto
			hueco_pantalla(false)
			@@forzar_carpinteria=false
			view.invalidate
		end	
	end
end
def forzar_hueco(text)
	return false if text[0].chr != "-"
	valores = text.split("-")
	if valores.size > 1
		#@@forzar_carpinteria = true
		@distancia_carpinteria =(con_coma(valores[1],nil).to_l).abs
	else		
		#@@forzar_carpinteria = !@@forzar_carpinteria
	end
	return true
end
def haz_trim(puerta2d)
	@notrim=true
	#puts((puerta2d.bounds.max.x-puerta2d.bounds.min.x).to_l)
	@p_t.push([puerta2d.bounds.min.x,0])
	@p_t.push([puerta2d.bounds.min.x,-@mocheta])
	@p_t.push([puerta2d.bounds.max.x,0])
	@p_t.push([puerta2d.bounds.max.x,-@mocheta])
end
def puntos_2d(enmuro) 
	return if @mocheta == @grueso_muro
	@mocheta=@grueso_muro
	bloque2d=saca_bloque_2d(@carp)
	@puede_max=bloque2d.get_attribute('dynamic_attributes','dibacmax')
	@mochetamin=bloque2d.get_attribute('dynamic_attributes', 'dibacwmin').to_f
	@mochetamax=bloque2d.get_attribute('dynamic_attributes', 'dibacwmax').to_f
	if bloque2d.is_a?(Sketchup::ComponentDefinition) && !@iguales
		Sketchup.active_model.start_operation('Esto es lo que hay primero', true, true, true)
		trim=busca_trim(bloque2d)
		if trim
			m=@mocheta
			if @mochetamin>0
				m=@mochetamin if @mocheta<@mochetamin
			end
			if @mochetamax>0 
				m=@mochetamax if @mocheta>@mochetamax
			end
			trim.transform!(Geom::Transformation.scaling(1, (m/(trim.bounds.max.y-trim.bounds.min.y)).to_f, 1)) if trim
		end	
		puerta=Sketchup.active_model.active_entities.add_instance(bloque2d, @transf_nula)
		@carp_attributes.each{|key| puerta.set_attribute('dynamic_attributes', key, @carp_defaults[key])} 
		puerta.set_attribute('dibac','2d', @carp) #esto se pone ya en el primero
		#diccionario.each{|key, value| puerta.set_attribute('dynamic_attributes', key, value) if key[0,5] == 'dibac' || key[0,6] =='_dibac'} if diccionario
		puerta.set_attribute('dibac','mocheta', @mocheta.to_f)
		puerta.set_attribute('dynamic_attributes','dibacmax', @dibacmax.to_f) if @puede_max
		puerta.set_attribute('dynamic_attributes','dibacwthick', @mocheta.to_f) if bloque2d.get_attribute('dynamic_attributes','dibacwtick')
		if !@dibacfit
			@dibacfit=bloque2d.get_attribute('dynamic_attributes','dibacfit')
		else
			bloque2d.set_attribute('dynamic_attributes','dibacfit', @dibacfit.to_f)
		end if bloque2d.get_attribute('dynamic_attributes','dibacfit')
		$dc_observers.get_latest_class.redraw_with_undo(puerta)
		Sketchup. active_model.start_operation('Esto es lo que hay despues', true, true, true)
		#UI.messagebox(puerta.definition.get_attribute('dibac','2d'))
		@puerta2d=puerta.definition 
		if puerta.definition.name == bloque2d.name #no ha creado cornucopia del bloque
			#Sketchup.active_model.active_entities.erase_entities(Puerto)
			bloquenuevo=Sketchup.active_model.definitions.add(Sketchup.active_model.definitions.unique_name(bloque2d.name))
			#puerta=Sketchup.active_model.active_entities.add_instance(bloquenuevo, @transf_nula)
			bloque2d.attribute_dictionaries.each do |d|
				d.each{|key, value| bloquenuevo.set_attribute(d, key, value)}
			end	
			bloquenuevo.entities.add_instance(bloque2d, @transf_nula).explode
			@puerta2d = bloquenuevo
		end
		diccionario=bloque2d.attribute_dictionary('dynamic_attributes')
		diccionario.each{|key, value| @puerta2d.set_attribute('dynamic_attributes', key, value) if key[0,5] == 'dibac' || key[0,6] =='_dibac'} if diccionario
		@carp_attributes.each{|key| @puerta2d.set_attribute('dynamic_attributes', key, @carp_defaults[key])}
		@puerta2d.set_attribute('dibac','2d', @carp) #esto se pone ya en el primero
		@puerta2d.set_attribute('dibac','mocheta', @mocheta.to_f)
		@puerta2d.set_attribute('dynamic_attributes','dibacmax', @dibacmax.to_f) if @puerta2d.get_attribute('dynamic_attributes','dibacmax')
		@puerta2d.set_attribute('dynamic_attributes','dibacfit', @dibacfit.to_f) if @puerta2d.get_attribute('dynamic_attributes','dibacfit')
		@puerta2d.set_attribute('dynamic_attributes','dibacwthick', @mocheta.to_f) if @puerta2d.get_attribute('dynamic_attributes','dibacwthick')
		#trim=busca_trim(@puerta2d)
		#trim.set_attribute('dynamic_attributes', 'leny', @mocheta) if trim
		$dc_observers.get_latest_class.redraw(puerta)
		borra_nulos(@puerta2d) 
		Sketchup.active_model.active_entities.erase_entities(puerta)
		Sketchup. active_model.commit_operation
	else
		@puerta2d=bloque2d.definition if bloque2d.is_a?(Sketchup::ComponentInstance)
		@puerta2d=bloque2d if bloque2d.is_a?(Sketchup::ComponentDefinition)
	end	
	ptos= saca_puntos([],[],@puerta2d, nil, false, true) 	#el primer bloque no tiene transformacion
	@p_c = ptos[0]   
	@p_t = ptos[1] #puntos para trim
	@notrim=false
	haz_trim(@puerta2d) if @p_t.size<4 #trim tiene que tener al menos cuatro puntos  
	@pt1=@pt2=@pt3=@pt4 = nil
	xmax = xmin = @p_t[0][0]
	@p_t.each do |p|
#		puts(p[0].to_f.to_l.to_s+','+p[1].to_f.to_l.to_s+','+p[2].to_f.to_l.to_s)
		xmin=p[0] if xmin > p[0]
		xmax=p[0] if xmax < p[0]
		if p[1].abs <= 0.000001
			@pt1=p if !@pt1
			@pt1=p if p[0] < @pt1[0] 
			@pt3=p if !@pt3
			@pt3=p if p[0] > @pt3[0]
		end
		if p[1]+@mocheta < 0.000001
			@pt2=p if !@pt2
			@pt2=p if p[0] < @pt2[0]
			@pt4=p if !@pt4
			@pt4=p if p[0] > @pt2[0]
		end
	end
	@pt1=[xmin,0,0] if !@pt1
	@pt2=[xmin,-@mocheta,0] if !@pt2
	@pt3=[xmax,0,0] if !@pt3
	@pt4=[xmax,-@mocheta,0] if !@pt4
	@ancho=(@pt3[0]-@pt1[0])
#	puts('____PUNTOS_____')
#	puts(@pt1[0].to_f.to_l.to_s+','+@pt1[1].to_f.to_l.to_s+','+@pt1[2].to_f.to_l.to_s)
#	puts(@pt2[0].to_f.to_l.to_s+','+@pt2[1].to_f.to_l.to_s+','+@pt2[2].to_f.to_l.to_s)
#	puts(@pt3[0].to_f.to_l.to_s+','+@pt3[1].to_f.to_l.to_s+','+@pt3[2].to_f.to_l.to_s)
#	puts(@pt4[0].to_f.to_l.to_s+','+@pt4[1].to_f.to_l.to_s+','+@pt4[2].to_f.to_l.to_s)
#	puts(@ancho)
	#Sketchup.undo #Quita la definicion de la puerta para que no se llene
end	
def onUserText(text, view)
    # Aqui se introduce el ancho de hoja si es positiva
    forzar_hueco(text)
	texto_comando
	view.invalidate
end
end # de la clase Carpinteria
class Dibac_Puerta < Dibac_Carpinteria
def initialize
	@distancia_carpinteria = 0.10.m if !@distancia_carpinteria
	@carpinteria_hueco = @@puerta_hueco #por extremo o por centro
	@comando_en_curso = "Place door"
	@carp_registro='Door'
	@carp=Sketchup.read_default('Dibac', 'Door', Sketchup.find_support_file("dibac_door.skp","plugins/indoor")).split('#')
	@carp = ['./dibac_door.skp'] if @carp.size==0 
	init_carpinteria
end
def deactivate(view)
	@@puerta_hueco = @carpinteria_hueco 
	view.invalidate #para que quite el dibujo flotante
end
end # de la clase Puerta
class Dibac_Ventana < Dibac_Carpinteria
def initialize
	@distancia_carpinteria = 0.10.m if !@distancia_carpinteria
	@carpinteria_hueco = @@ventana_hueco #por extremo o por centro
	@comando_en_curso = "Place window"
	@carp_registro='Window'
	@carp = Sketchup.read_default('Dibac', 'Window', Sketchup.find_support_file("dibac_window.skp","plugins/indoor")).split('#')
	@carp =['./dibac_window.skp'] if @carp.size==0
	init_carpinteria
end
def deactivate(view)
	@@ventana_hueco = @carpinteria_hueco 
	view.invalidate
end
end #De la clase Dibac_Ventana
class Dibac_Armario < Dibac_Carpinteria
def initialize
	@distancia_carpinteria = 0.10.m if !@distancia_carpinteria
	@carpinteria_hueco = @@armario_hueco #por extremo o por centro
	@comando_en_curso = "Place wardrobe"
	@carp_registro='Wardrobe'
	@carp = Sketchup.read_default('Dibac', 'Wardrobe', Sketchup.find_support_file("dibac_wardrobe.skp","plugins/indoor")).split('#')
	@carp = ['./dibac_wardrobe.skp'] if @carp.size==0
	init_carpinteria
end
def deactivate(view)
	view.invalidate
end
end #De la clase Dibac_Armario
class Dibac_Elegir < Dibac_Carpinteria
def initialize
	@carp = Sketchup.read_default('Dibac', 'Choose', Sketchup.find_support_file("dibac_door.skp","plugins/indoor")).split('#')
	@carp = ['./dibac_door.skp']  if @carp.size==0
	@comando_en_curso = "Choose joinery"
	archivo = UI.openpanel(CambiaIdioma(@comando_en_curso), File.dirname(@carp[0]),File.basename(@carp[0])) 
	if archivo
		if File.basename(archivo) != File.basename(@carp[0])
			Sketchup.write_default('Dibac','Choose', archivo.gsub('\\','/')) 
			@carp = Sketchup.read_default('Dibac', 'Choose', Sketchup.find_support_file("dibac_door.skp","plugins/indoor")).split('#')
			@carp = './dibac_door.skp' if @carp.size==0
		end	
		@distancia_carpinteria = 0.10.m if !@distancia_carpinteria
		@carpinteria_hueco = @@elegir_hueco #por extremo o por centro
		@carp_registro='Choose'
		init_carpinteria
	end	
end
def deactivate(view)
	view.invalidate
end
end #De la clase Dibac_Armario
class Dibac_CotaContinua < Dibac_Base
=begin
 Clase	        		:	CotaContinua
 Desciende de		:	Dibac
 Descripción   		:	Realiza cotas continuas sobre plantas Dibac
 Item de Menu  	:	Dibujo->Dibac->Acotado continuo // Barra de herramientas Dibac
 Menú contextual	:	NO
 Uso         			:	Se indica punto inicial y final de la linea de corte seguido de la posicion de las cotas.
								El acotado solo tiene en cuenta los muros dibujados con Dibac.
								Si se introduce cualquier numero se entendera como vañor minimo por debajo del cual
								no se visualizara la cota.
Fecha        			:	8/01/2011
=end
def initialize
	@ip = Sketchup::InputPoint.new
	@ip1 = Sketchup::InputPoint.new
	reset
end
def reset
	if @grupo
		pt = @ptpos.project_to_line [@ptini,@ptfin]
		@grupo.transform!(Geom::Transformation.translation(pt - @ptpos))	
		@grupo.explode
		finalundo
	end	
	@ptini = @ptfin = @ptint = @ptpos = @grupo = false
	Sketchup::set_status_text "", SB_VCB_LABEL
	Sketchup::set_status_text "", SB_VCB_VALUE
	texto_comando
end
def texto_comando
	return if !@comando_en_curso
	texto = CambiaIdioma(@comando_en_curso)+"("+CambiaIdioma("min.")+" "+@@cota_minima.to_l.to_s+"): "
	if !@ptini
		texto = texto + CambiaIdioma("Enter start point, or minimun value")
	elsif !@grupo
		texto = texto + CambiaIdioma("Enter end point, or minimun value")
	else
		texto = texto + CambiaIdioma("Enter dimension line position")
	end	
	texto = texto +"."
	Sketchup::set_status_text texto
end	
def onMouseMove(flags, x, y, view)
    return false if( !@ip.pick(view, x, y, @ip1) )
	texto_comando # por si se ha borrado con otro comando
	# pone tooltip segun el elemento al que se aproxime
	view.tooltip = @ip.tooltip
	if !@grupo
		@ptfin = @ip.position
		@ptfin.z=@ptini.z
		@ip.pick(view, view.screen_coords(@ptfin).x, view.screen_coords(@ptfin).y) 
		@ptint = @ptfin
	else	
		@ptint = @ptpos if @ptpos
		@ptpos = @ip.position
		@ptpos.z = @ptini.z
		@ip.pick(view, view.screen_coords(@ptpos).x, view.screen_coords(@ptpos).y) 
        pt = @ptpos.project_to_line [@ptini,@ptfin]
		pt = @ptint.project_to_line [pt,@ptpos]	
		@grupo.transform!(Geom::Transformation.translation(@ptpos-pt))
	end if @ptini
	view.invalidate
end
def onLButtonDown(flags, x, y, view)
	#@ip1.copy! @ip
	@ip1.pick(view,x,y,@ip)
	if !@ptini
		@ptini = @ip.position
		#puts(Sketchup.active_model.active_entities.parent.bounds.min.z)
		@ptini.z=Sketchup.active_model.active_entities.parent.bounds.min.z if !busca_cara(x, y , view) #si no estamos en un linea del grupo nos ponemos en cota del grupo.
	elsif !@grupo
		puntos = intermedios([@ptini,@ptfin],true,true)
		Sketchup.active_model.definitions.load(Sketchup.find_support_file("DIBAC_COTAL.skp","Plugins/indoor")) #para que funcione el undo
		inicioundo(CambiaIdioma("Continuous dimension"))
		@grupo = Sketchup.active_model.active_entities.add_group
		i = 0	
		while i < puntos.size-1 do
			pon_cota_lineal(@grupo,puntos[i],puntos[i+1]) if(puntos[i]-puntos[i+1]).length >= @@cota_minima
			
			i += 1
		end
	else 
		@grupo.explode
		finalundo
		@grupo = false
		reset
	end
	texto_comando
	view.lock_inference
	view.invalidate
end
def onLButtonDoubleClick(flags, x, y, view)
	onLButtonDown(flags, x, y, view)
end
def draw(view)
	textoevaluacion(view)
    # Muestra el punto actual
    if( @ip.valid? && @ip.display? )
        @ip.draw(view)
    end
    # previsualiza la linea de cota
	view.drawing_color = "black"
	view.line_width = 1 
	inference_locked = view.inference_locked?
	view.set_color_from_line(@ip1, @ip) if @ptini
	if !@grupo 
		view.draw(GL_LINE_STRIP, @ptini, @ptfin)
		puntos = intermedios([@ptini,@ptfin],true,true)
		view.draw_points(puntos,6,2,"red") if puntos.size > 0
		return if puntos.size < 2
		Sketchup::set_status_text  CambiaIdioma("Length"), SB_VCB_LABEL
		vec=puntos.first - puntos.last
		Sketchup::set_status_text vec.length.to_s, SB_VCB_VALUE
		i = 0		
		i=-1 if Sketchup.version_number <= 8000999
		while i < puntos.size-1 do
			vec = puntos[i]-puntos[i+1]
			view.draw_text(view.screen_coords(punto_medio(puntos[i], puntos[i+1])),vec.length.to_s) if vec.length >= @@cota_minima
			i += 1
		end
	end if @ptini
end
def onUserText(text, view)
	# Aqui se introduce el espesor minimo para acotar
	text=con_coma(text,nil)
   begin
        valor = text.to_l
    rescue
        # Error al no tratarse de un numero
        UI.beep
        valor = nil
        Sketchup::set_status_text "", SB_VCB_VALUE
    end
    return if !valor
	@@cota_minima = valor
	texto_comando
	view.invalidate
end
def onKeyDown(key, rpt, flags, view)
	Sketchup::set_status_text CambiaIdioma("Minimun dimension"), SB_VCB_LABEL
end
end # de la clase Dibac_CotaContinua
class Dibac_TresDimensiones < Dibac_Base
=begin
 Clase	        		:	TresDimensiones
 Desciende de		:	Dibac
 Descripción   		:	Genera un modelo 3D a partir de la planta
 Item de Menu  	:	Dibujo->Dibac->Convertir en 3D // Barra de herramientas Dibac
 Menú contextual	:	NO
 Uso         			:	
Fecha        			:	10/03/2012
=end
def texto_comando
	texto = CambiaIdioma("Enter new height")+"."
	Sketchup::set_status_text  texto if @h
end		
def menu
	#Sketchup.active_model.selection.add(@grupos)
	prompts = 	[	CambiaIdioma("墙体高度"),
							CambiaIdioma("平面图")
						]
	grupo = CambiaIdioma("保留")
	grupo = CambiaIdioma("删掉") if !@@crear_grupo					
	defaults = 	[	@@altura_planta.to_l,
							grupo
						]
						
	list = 			[	"",
							CambiaIdioma("保留")+"|"+CambiaIdioma("删掉")
						]
	input = UI.inputbox prompts, defaults, list, CambiaIdioma("生成三维墙体")
	if input
		h1 = a_longitud(input[0]).abs
		@@altura_planta = h1 if h1>0
		h1 = input[1].to_s.upcase
		@@crear_grupo = (h1 == CambiaIdioma("保留"))
	else	
		Sketchup.active_model.select_tool nil	
		return false
	end	
	@tiempo=Time.now
	ejecuta_3d
	#puts("Tiempo total="+(Time.now-@tiempo).to_s)
	#Sketchup.active_model.active_view.refresh
	Sketchup.active_model.select_tool(nil)	
end
def ponz(ptos, h)
	ptos.each do |pt|		
		pt.z=pt.z+h
	end	
end	
def draw(view) #para que no haga nada al dibujar
	#puts("Tiempo parcial="+(Time.now-@tiempo).to_s)
end
def activate
	return if nolicencia(true)
	@tiempo=Time.now
	@hay_undo=false #para controlar si hay elementos que convertir no se esta usando
	Sketchup.active_model.active_view.invalidate
	@grupos=Sketchup.active_model.selection.grep(Sketchup::Group)
	if @grupos == []
		UI.messagebox(CambiaIdioma("必须至少选择一个“群组”"))
		Sketchup.active_model.select_tool(nil)	
		return false
	end	
	seguir=false
	@grupos.each do |g|
		seguir=busca_elementos(g) if !seguir
	end
	if !seguir
	    UI.messagebox(CambiaIdioma("没有项目生成 3D。"))
		Sketchup.active_model.select_tool(nil)	
		return false	
	end
	@paso= seguir[0][0]
	@paso= seguir[3][0] if !@paso
	if @paso#para que no diga que la operacion esta tardando mucho
		$dc_observers.get_latest_class.redraw_with_undo(@paso)#para que no diga que la operacion esta tardando mucho
		Sketchup.active_model.start_operation "No pasa nada", true, true, true
	end
	if !@h
		return if !menu
	end	
end
def resume(view)
	view.invalidate
end	
	
def onUserText(text, view)
	# Aqui se introduce la altura
	text=con_coma(text,nil)
   begin
        valor = text.to_l
    rescue
        # Error al no tratarse de un numero
        UI.beep
        valor = nil
        Sketchup::set_status_text "", SB_VCB_VALUE
    end
    return if !valor
	@@altura_planta = valor
	ejecuta_3d 
end
def busca_elementos(model)
	carpinterias = []
	mobiliario = []
	muros = []
	escaleras=[]
	resto=[]
	explotar=false
    if model.get_attribute  "dibac","escalera2d"
		escaleras.push model
	else	
		model.entities.each do |entidad|
			if	entidad.is_a?(Sketchup::ComponentInstance	)
				tipo=tipo_bloque(entidad)
				if tipo == 'carpinteria'
					carpinterias.push(entidad)
				elsif	tipo == 'mobiliario'
					mobiliario.push(entidad)
				else resto.push(entidad)	
					# dos veces la primera para hacer undo al leer archivo nuevo en el paso a 3D
				end 
			elsif entidad.is_a?(Sketchup::Face)
				esmuro = true
				entidad.edges.each do |e|
					esmuro = false if e.faces.size > 2
					if e.faces.size == 2
						esmuro=false if !(e.faces[0].normal.dot(e.faces[1].normal) > 0.99999999)
					end
				end
				muros.push(entidad) if esmuro
			elsif  entidad.get_attribute  "dibac","escalera2d"	
				escaleras.push entidad
			else
				if entidad.is_a?(Sketchup::Edge)
					resto.push entidad if entidad.faces.size != 1
				else
					resto.push entidad
				end	
			end
		end
	end
	#if carpinterias+muros+escaleras+mobiliario==[]
		#Sketchup.active_model.select_tool(nil)	
		#return false	
	#else
		return carpinterias, muros, escaleras, mobiliario, resto
	#end
end
def ejecuta_3d
	Sketchup.active_model.selection.clear
	Sketchup.undo if @h
	@h=@@altura_planta
	@h = 3.m if @h<=0
	inicioundo(CambiaIdioma("生成三维墙体")) 
	@grupos.each do |g|
		if @@crear_grupo
			grupo=g.copy
			altura=g.get_attribute "dibac","escalera2d"
			grupo.set_attribute "dibac","escalera2d",altura if altura
			#Sketchup.active_model.active_entities.erase_entities(g) if !@@crear_grupo
		end	
		model_3d(g)
	end
	finalundo
	#texto_comando
end
def perimetro_convexo(trim)
	caja=trim.bounds
	transf=Geom::Transformation.rotation([0,0,0],[1,0,0],Math::PI/2) if caja.min.y == caja.max.y #lo tiramos al suelo alrededor de eje x
 	transf=Geom::Transformation.rotation([0,0,0],[0,1,0],Math::PI/2) if caja.min.x == caja.max.x #lo tiramos al suelo alrededor de eje y
	transf=Geom::Transformation.new if caja.min.z == caja.max.z #ya esta en el suelo
	return nil if !transf #no es plano
	bordes=[]
	trim.entities.each do |e| #todo son edges
		linea1=[e.start.position.transform(transf),e.end.position.transform(transf)]
		angulo1 = angulo_recta(e.start.position.transform(transf), e.end.position.transform(transf))
		#puts(angulo1*180/Math::PI)
		lado=nil
		primerlado=nil
		mismolado=true
		trim.entities.each do |e2|
			angulo2 = angulo_recta(e2.start.position.transform(transf), e2.start.position.transform(transf).project_to_line(linea1))
			lado=angulo2 if !lado
			if angulo2
				#puts((lado-angulo2)*180/Math::PI)
				mismolado=false if (lado - angulo2).abs > 0.000001
			end
			angulo2 = angulo_recta(e2.end.position.transform(transf), e2.end.position.transform(transf).project_to_line(linea1))
			lado=angulo2 if !lado
			if angulo2
				mismolado=false if (lado - angulo2).abs > 0.000001
			end	
			break if !mismolado
		end
		bordes.push(e)	if mismolado
		#Sketchup.active_model.active_entities.add_line(e.start.position.transform(transf),e.end.position.transform(transf)) if mismolado
	end
	return bordes
end
def carpinteria_3d(carpinteria)
	definicion=nil
	#inicioundo(CambiaIdioma(@comando_en_curso))
	Sketchup.active_model.definitions.each{|d| definicion=d if d.name == @carp_name} #el bloque completo no lo tengo que repetir
	if !definicion
		Sketchup.active_model.start_operation('Cargo carpinteria para 3d',true,true,true) #para que sea transparente al undo
		definicion=Sketchup.active_model.definitions.load(carpinteria) 
	end
	inicioundo('puturru') #esto hace que funcione aunque el bloque este cargado. 
	bloque3d=carpinterias_2d3d(definicion)[1]
	bloque3d.delete_attribute('dibac','3d') #por si esta en el bloque
	#@@carp_1_attributes.each{|key| bloque2d.set_attribute('dynamic_attributes', key, @@carp_1_defaults[key])}
	#	ahora buscamos en definiciones de nuevo y si esta tiene trim y todo lo demas
	@iguales=false
	Sketchup.active_model.definitions.each do |d|
		#por si no hay instancias pero si una definicion válida
			#UI.messagebox(d.name + ' - ' + bloque2d.name.to_s+' - ' + d.get_attribute('dibac','2d').to_s) if d.name.split('#')[0] == bloque2d.name.split('#')[0]
			if d.name.split('#')[0] == bloque3d.name.split('#')[0] && d.get_attribute('dibac','3d') #&& d.name.split('#').size > 1
			@iguales=true
			@carp_attributes.each do |a|
				@iguales= false if d.get_attribute('dynamic_attributes', a).to_s != @carp_defaults[a].to_s
#				UI.messagebox(d.name+' - '+@iguales.to_s+' - '+d.get_attribute('dynamic_attributes', a).to_s+' - '+@carp_defaults[a].to_s)
			end
			#UI.messagebox(d.name+' - '+@iguales.to_s)
			@iguales=false if d.get_attribute('dibac','mocheta').to_f.to_l != @mocheta.to_f.to_l
			#UI.messagebox(d.name+' - '+@iguales.to_s+' - '+ancho_trim(d).to_f.to_l.to_s+' - '+@mocheta.to_f.to_l.to_s)
			@iguales=false if d.get_attribute('dynamic_attributes', 'dibacmax').to_f.to_l != @dibacmax.to_f.to_l
			#UI.messagebox(d.name+' - '+@iguales.to_s+' - '+d.get_attribute('dynamic_attributes', 'dibacmax').to_f.to_l.to_s+' - '+@dibacmax.to_f.to_l.to_s)
			@iguales=false if d.get_attribute('dynamic_attributes', 'dibacfit').to_f.to_l != @dibacfit.to_f.to_l
			return [d, bloque3d]  if @iguales
		end	
	end
	return bloque3d, bloque3d
end
def explota_trim (trim, para_explotar)
	definicion=trim
	definicion=trim.definition if trim.is_a?(Sketchup::ComponentInstance)
	definicion.entities.each {|t| explota_trim(t, para_explotar) if (t.is_a?(Sketchup::ComponentInstance) || t.is_a?(Sketchup::Group))}
	para_explotar.push(trim) if (trim.is_a?(Sketchup::ComponentInstance) || trim.is_a?(Sketchup::Group))
end	
def suaviza(entidades)
	entidades.grep(Sketchup::Face).each do |f|
		f.edges.each do |e|
			if(e.faces.size == 2) 
				e.soft=true if(e.faces[0].normal.dot(e.faces[1].normal) > 0.95) 
				e.smooth=true if(e.faces[0].normal.dot(e.faces[1].normal) > 0.95) 
			end	
		end
	end
end	
def model_3d(model)
	raiz=model.parent
	raiz = raiz.parent while !(raiz.is_a?(Sketchup::Model)) #buscamos el origen
	transf_nula=Geom::Transformation.new
	escaleras=[] #por si el grupo solo es una escalera
	if model.get_attribute "dibac","escalera2d"
		escaleras.push(model)
		model=Sketchup.active_model.active_entities.add_group(model) 
		explotar=true
	end	
	solomuros=raiz.entities.add_group.transform!(model.transformation)
	pp=solomuros.entities.add_instance(model.entities.parent, transf_nula).explode
	#pp.explode
	#return
	elementos=busca_elementos(solomuros)
	carpinterias=elementos[0]
	muros=elementos[1] 
	escaleras=elementos[2]
	mobiliario=elementos[3]
	resto=elementos[4]
	solomuros.entities.erase_entities(escaleras, mobiliario, resto)
	carpinterias.each{|e| borra_carpinteria(e, solomuros.entities)} 
	elementos=busca_elementos(solomuros)
	muros=elementos[1] #if elementos #buscamos los muros despues de borrar las carpinterias
	#__________________________RITKONSULT (Suelo)______________________
		#suelo=solomuros.copy
		#suelo.entities.grep(Sketchup::Edge).each {|e| e.find_faces}
		#borra_coplanarias(suelo.entities.grep(Sketchup::Edge), suelo.entities)
	#_______________________________________________________________	
	muros.each do |entidad|
		face = entidad
		extrusiona(face,@h) if !face.deleted?
	end	
	elementos=busca_elementos(model)
	carpinterias=elementos[0]
	muros=elementos[1]
	escaleras=elementos[2]
	mobiliario=elementos[3]
	definiciones=[]
	carpinterias.each{|c| definiciones.push(c.definition)}
	mobiliario.each{|c| definiciones.push(c.definition)} 
	definiciones.uniq!
	#Sketchup.active_model.close_active while Sketchup.active_model.active_path
	definiciones.each do |d|
		contador=0
		esta=false
		@trim=nil
		instancias=d.instances.to_a
		instancias.each do |i|
			if carpinterias.include?(i)
				contador += 1
				if !esta
					@carp=d.get_attribute('dibac', '2d')
					saca_menu
					@carp_attributes.each{|key| @carp_defaults[key]=d.get_attribute('dynamic_attributes', key)}
					@mocheta=d.get_attribute('dibac','mocheta').to_f
					@dibacmax=d.get_attribute('dynamic_attributes','dibacmax')
					@dibacfit=d.get_attribute('dynamic_attributes','dibacfit')
					bloques=carpinteria_3d(@carp)
					bloque3d=bloques[1] #el componente original
					#if bloque3d.typename=='ComponentDefinition' && !@iguales
					trim=busca_trim(bloque3d)	
					trim.transform!(Geom::Transformation.scaling(1, (@mocheta/(trim.bounds.max.y-trim.bounds.min.y)).to_f, 1)) if trim
					#trim.set_attribute('dynamic_attributes', 'leny', @mocheta) if trim
					diccionario=d.attribute_dictionary('dynamic_attributes')
					@puerta3d=nil
					if diccionario || @paso #es que hay atributos dinamicos que hay que redibujar aunque no tengan menu
						@paso=nil #redibujamos el primero
						puerta=Sketchup.active_model.active_entities.add_instance(bloque3d, transf_nula)
						@carp_attributes.each{|key| puerta.set_attribute('dynamic_attributes', key, @carp_defaults[key])} 
						puerta.set_attribute('dibac','3d', @carp) #esto se pone ya en el primero
						puerta.set_attribute('dibac','mocheta', @mocheta.to_f)
						diccionario=d.attribute_dictionary('dynamic_attributes')
						diccionario.each{|key, value| puerta.set_attribute('dynamic_attributes', key, value) if key[0,5] == 'dibac' || key[0,6] =='_dibac'} if diccionario
						$dc_observers.get_latest_class.redraw(puerta)
						@puerta3d=puerta.definition if puerta.definition.name != bloque3d.name
						Sketchup.active_model.active_entities.erase_entities(puerta)
					end
					if !@puerta3d
						bloquenuevo=Sketchup.active_model.definitions.add(Sketchup.active_model.definitions.unique_name(bloque3d.name))
						bloquenuevo.entities.add_instance(bloque3d, Geom::Transformation.new).explode
						#puerta=Sketchup.active_model.active_entities.add_instance(bloquenuevo, @transf_nula)
						@puerta3d = bloquenuevo
					end
					@carp_attributes.each{|key| @puerta3d.set_attribute('dynamic_attributes', key, @carp_defaults[key])}
					@puerta3d.set_attribute('dibac','3d', @carp) #esto se pone ya en el primero
					@puerta3d.set_attribute('dibac','mocheta', i.definition.get_attribute('dibac', 'mocheta').to_f)
					diccionario.each{|key, value| @puerta3d.set_attribute('dynamic_attributes', key, value) if key[0,5] == 'dibac' || key[0,6] =='_dibac'} if diccionario
					#trim.set_attribute('dynamic_attributes', 'leny', @mocheta) if trim
					#$dc_observers.get_latest_class.redraw(puerta)
					borra_nulos(@puerta3d) 
					@trim=busca_trim(@puerta3d)	
					if @trim
						para_explotar=[]
						explota_trim(@trim, para_explotar)
						para_explotar.pop #quitamos el ultimo que es el bloque padre
						para_explotar.each{|e| e.explode}
						@trim_definition=@trim.definition
					else
						@trim=@puerta3d.entities.add_group
						#haz_trim(entidades, nil, @trim) 
						#bordes=perimetro_convexo(trim)
						bordes=perimetro_concavo(@puerta3d, true)
						#UI.messagebox(bordes)
						#borrar=[]
						#@trim.entities.each{|e| borrar.push(e) if !bordes.include?(e)}
						@trim.entities.clear!
						cara=@trim.entities.add_face(bordes)
						#comparamos trim con bounds
						p1=Geom::Point3d.new(@puerta3d.bounds.min.x, 0, @puerta3d.bounds.min.z) 
						p2=Geom::Point3d.new(@puerta3d.bounds.max.x, 0, @puerta3d.bounds.min.z)
						p3=Geom::Point3d.new(@puerta3d.bounds.max.x, 0, @puerta3d.bounds.max.z) 
						p4=Geom::Point3d.new(@puerta3d.bounds.min.x, 0, @puerta3d.bounds.max.z) 
						#UI.messagebox(@trim.bounds.min.x.to_s+' --- '+p1.x.to_s)
						#UI.messagebox(@trim.bounds.max.x.to_s+' --- '+p3.x.to_s)
						#UI.messagebox(@trim.bounds.min.z.to_s+' --- '+p1.z.to_s)
						#UI.messagebox(@trim.bounds.max.z.to_s+' --- '+p3.z.to_s)
						if 	@trim.bounds.min.x>p1.x || @trim.bounds.max.x<p3.x || @trim.bounds.min.z>p1.z || @trim.bounds.max.z<p3.z
							@trim.entities.erase_entities(cara)
							cara=@trim.entities.add_face(p1, p2, p3, p4)
						end	
						#UI.messagebox(@puerta3d)
						cara.reverse! if cara.normal.y>0
						#@trim.entities.erase_entities(borrar)
						cara.pushpull(@mocheta)
						if !@trim.manifold? #Si no es un solido
							@trim.entities.clear!
							cara=@trim.entities.add_face(p1, p2, p3, p4)
							cara.pushpull(@mocheta)
						end
						@trim_definition=@trim.entities[0].parent #es un definition
						#@trim=@puerta3d.entities.add_instance(trim_definition, Geom::Transformation.new)
						@trim.name='DIBAC_TRIM'
						@trim.visible=false
						borra_coplanarias(@trim.entities.grep(Sketchup::Edge), @trim.entities) #borra lineas ocultas en mochetas y dinteles
						suaviza(@trim.entities) #para no tener que suavizar los muros
					end
					if @iguales
						bloque3d=bloques[0]
						@puerta3d=bloque3d.definition if bloque3d.is_a?(Sketchup::ComponentInstance)
						@puerta3d=bloque3d if bloque3d.is_a?(Sketchup::ComponentDefinition)
					end	
					esta=true
				end
				if @trim.manifold?
					interseccion=@trim_definition.entities.intersect_with true, solomuros.transformation*i.transformation*@trim.transformation , solomuros,solomuros.transformation, true, solomuros
					elementos=solomuros.entities.add_instance(@trim_definition, i.transformation*@trim.transformation).explode
					borrar=[]
					elementos.grep(Sketchup::Edge).each do |e|
						if (e.start.position.z > @h && e.end.position.z > @h) || (e.start.position.z < 0 && e.end.position.z < 0)
							borrar.push(e)
						else	
							if e.faces.size==3
								caramuro=nil
								e.faces.each{|f| caramuro=f if !elementos.include?(f)} #el muro no esta en trim
								if caramuro
									e.faces.each{|f| borrar.push(f) if f != caramuro && f.normal.dot(caramuro.normal) > 0.99999}
								end
							end	
						end 
					end
					solomuros.entities.erase_entities(borrar)
					elementos.grep(Sketchup::Face).each{|f| f.reverse! if !f.deleted?} #para que salga la cara buena
				end if @trim
				model.entities.add_instance(@puerta3d, i.transformation)
				#Sketchup.active_model.active_view.refresh
			elsif mobiliario.include?(i)
				if !esta
					@carp=d.get_attribute('dibac', '2d')
					saca_menu
					@carp_attributes.each{|key| @carp_defaults[key]=d.get_attribute('dynamic_attributes', key)}
					bloques=carpinteria_3d(@carp)
					bloque3d=bloques[1] #el componente original
					diccionario=d.attribute_dictionary('dynamic_attributes')
					@puerta3d=bloque3d
					if diccionario || @paso #es que hay atributos dinamicos con menu en los bloques
						#@puerta3d=nil if @carp_attributes.size>0 
						@paso=nil #redibujamos el primero
						puerta=Sketchup.active_model.active_entities.add_instance(bloque3d, transf_nula)
						@carp_attributes.each{|key| puerta.set_attribute('dynamic_attributes', key, @carp_defaults[key])} 
						puerta.set_attribute('dibac','3d', @carp) #esto se pone ya en el primero
						puerta.set_attribute('dibac','mocheta', @mocheta.to_f)
						diccionario=d.attribute_dictionary('dynamic_attributes')
						diccionario.each{|key, value| puerta.set_attribute('dynamic_attributes', key, value) if key[0,5] == 'dibac' || key[0,6] =='_dibac'} if diccionario
						$dc_observers.get_latest_class.redraw(puerta)
						@puerta3d=puerta.definition if puerta.definition.name != bloque3d.name
						Sketchup.active_model.active_entities.erase_entities(puerta)
					end
					if !@puerta3d
						bloquenuevo=Sketchup.active_model.definitions.add(Sketchup.active_model.definitions.unique_name(bloque3d.name))
						bloquenuevo.entities.add_instance(bloque3d, Geom::Transformation.new).explode
						#puerta=Sketchup.active_model.active_entities.add_instance(bloquenuevo, @transf_nula)
						@puerta3d = bloquenuevo
					end
					@carp_attributes.each{|key| @puerta3d.set_attribute('dynamic_attributes', key, @carp_defaults[key])}
					@puerta3d.set_attribute('dibac','3d', @carp) #esto se pone ya en el primero
					@puerta3d.set_attribute('dibac','mocheta', 0)
					diccionario.each{|key, value| @puerta3d.set_attribute('dynamic_attributes', key, value) if key[0,5] == 'dibac' || key[0,6] =='_dibac'} if diccionario
					###borra_nulos(@puerta3d) 
					if @iguales
						bloque3d=bloques[0] 
						@puerta3d=bloque3d.definition if bloque3d.is_a?(Sketchup::ComponentInstance)
						@puerta3d=bloque3d if bloque3d.is_a?(Sketchup::ComponentDefinition)
					end	
					esta=true
				end
				model.entities.add_instance(@puerta3d, i.transformation)
				#Sketchup.active_model.active_view.refresh
			end
		end	
		@puerta3d.entities.erase_entities(@trim) if @trim
	end	#if solido
	borrar=[]
	if solomuros.entities.count>0
		solomuros.entities.grep(Sketchup::Edge){|e| borrar.push(e) if ((e.start.position.z >= @h && e.end.position.z >= @h) || (e.start.position.z <= 0 && e.end.position.z <= 0)) && e.faces.size<=1}
		solomuros.entities.erase_entities(borrar)
	end	
	Sketchup.active_model.close_active while Sketchup.active_model.active_path
	# .each{|g| solomuros=g.subtract(solomuros) if g.manifold?}
	model.entities.erase_entities(carpinterias, mobiliario)
	muros.each{|m| m.edges.each{|b| model.entities.erase_entities(b) if !b.deleted?} if !m.deleted?}
	#grupo=model.entities.add_group #or si queremos un grupo dentro con los muros
	#suaviza(solomuros.entities)
	if solomuros.entities.count>0 
		model.entities.add_instance(solomuros.entities.parent, transf_nula).explode 
		Sketchup.active_model.active_entities.erase_entities(solomuros) 
	end	
	#borra_coplanarias_3d(model)
	escaleras.each do |escalera|
		#escalera.name='escalera' #Evita el Warning de make_unique
		#escalera.make_unique
		escalera_3d(escalera)
	end	
	model.explode if explotar
	# modelraiz.select_tool nil
end	
end # de la clase TresDimensiones
class Dibac_Escalera < Dibac_Base
def initialize
    @ip = Sketchup::InputPoint.new
    @ip1 = Sketchup::InputPoint.new
	@comando_en_curso = "Stair"
end
def menu
	nolicencia(false)
	prompts = [	CambiaIdioma("Width"),
						CambiaIdioma("Height"),
						CambiaIdioma("Going"),
						CambiaIdioma("Rise"),
						CambiaIdioma("Slope")
					 ] 
	huella =(@@escalera_huella.to_l).to_s
	huella = '>'+(@@escalera_huellamin.to_l).to_s if @@escalera_huellamin > 0
	tabica =(@@escalera_tabica.to_l).to_s
	tabica = '<'+(@@escalera_tabicamax.to_l).to_s if @@escalera_tabicamax > 0
	defaults=Sketchup.read_default('Dibac', 'Stair', 'nada').split('#')
	
	defaults = [	@@escalera_width.to_l.to_s,
						@@escalera_height.to_l.to_s,
						huella,
						tabica,
						@@escalera_slope.to_l.to_s
					 ] if defaults ==['nada']
					 
	list = 		[	"",
						"",
						"",
						"",
						""
					 ]				 
	input = UI.inputbox prompts, defaults, list, CambiaIdioma(@comando_en_curso)
	if input
		h1 =a_longitud(input[0]).abs #ancho
		@@escalera_width = h1 if h1>0
		texto=@@escalera_width.to_l.to_s
		h1 = a_longitud(input[1]).abs #alto
		@@escalera_height = h1
		texto=texto+'#'+@@escalera_height.to_l.to_s
		h1 = con_coma(input[2],nil) #huella
		if h1[0].chr == ">"		
			@@escalera_huellamin = h1.split(">")[1].to_l.abs 
			texto=texto+'#'+ '>'+@@escalera_huellamin.to_l.to_s
		else
			h1=a_longitud(h1).abs
			if h1  > 0
				@@escalera_huella = h1
				@@escalera_huellamin = 0 
			end	
			texto=texto+'#'+ @@escalera_huella.to_l.to_s
		end	
		h1 = con_coma(input[3],nil) #tabica
		if h1[0].chr == "<"		
			@@escalera_tabicamax = h1.split("<")[1].to_l.abs 
			texto=texto+'#'+ '<'+@@escalera_tabicamax.to_l.to_s
		else
			h1=a_longitud(h1).abs
			if h1  > 0
				@@escalera_tabica = h1
				@@escalera_tabicamax = 0 
			end	
			texto=texto+'#'+ @@escalera_tabica.to_l.to_s
		end	
		h1 =a_longitud(input[4]) .abs#comodidad
		@@escalera_slope = h1
		texto=texto+'#'+@@escalera_slope.to_l.to_s
		Sketchup.write_default('dibac', 'Stair', texto)
	else	
		Sketchup.active_model.select_tool nil	
		return
	end	
	@huella=@@escalera_huellamin
	@huella=@@escalera_huella if @@escalera_huellamin==0
	huella_tabica
	reset				 
end
def reset
	borra_auxiliares
	@puntos = @total_peld = 0
	@ptini = @ptfin = @pt1 = @pt2 = @pt3 = @pt4 = []
    @pts_d = [] #puntos cara derecha
	@pts_i = [] #Puntos cara izquierda
	@pts_cursor = [] #Puntos cursor
	@cara_tramo =[] #cara en que se construyo el tamo
	@arfin = nil
	@cl1=nil
	@recorrido=false
	@cancelar=false #Para distinguir entre Ctrl-Z y Esc.
    Sketchup::set_status_text "", SB_VCB_LABEL
    Sketchup::set_status_text "", SB_VCB_VALUE
    texto_comando
end
def activate
	Sketchup.active_model.active_view.invalidate
    menu
end
def texto_comando
	return if !@comando_en_curso
	texto = CambiaIdioma(@comando_en_curso) 
	if !@recorrido
		texto= texto+"["+ @@escalera_width.to_l.to_s+'].'
	else
		texto= texto+"["+ CambiaIdioma("Path")+'].'
	end
	if @puntos == 0
		texto = texto+CambiaIdioma("Starting point")+"("+ CambiaIdioma("Dbl_Click for Path")+")"
	else	
		texto= texto+CambiaIdioma("End point")
		texto = texto + ", " + CambiaIdioma("or specify width preceded by") + " '-'" if !@recorrido
		
		
	end	
	texto = texto+"."
	if @puntos>0
		texto = texto + " Tab=" if WIN
		texto = texto + " Ctrl=" if MAC	
		texto=texto + CambiaIdioma("Change edge")+"." 	
		texto=texto+" Ctrl=" if WIN
		texto=texto+" Option=" if MAC
		texto = texto +CambiaIdioma("Force")+"."
	end if !@recorrido
	Sketchup::set_status_text  texto 
end		
def deactivate(view)
	view.invalidate
	reset
end
def onSetCursor
	UI.set_cursor(@@escaleracursor_id)
end
def auxiliares(punto)
	borra_auxiliares
	inicioundo('Tramo de escalera')
	crea_auxiliares(punto)
	finalundo
end
def crea_auxiliares(pt)
	#return #no hay auxiliares
	return if pt==[]
	@cl1 = Sketchup.active_model.active_entities.add_cpoint pt
	return
	@cl1 = Sketchup.active_model.active_entities.add_cline pt, [0,0]
	@cl2 = Sketchup.active_model.active_entities.add_cline pt, [0,0]
	@cl1.direction = [@@hv[0], @@hv[1]]
	@cl2.direction = [-@@hv[1], @@hv[0]]
	@cl1.stipple = @cl2.stipple = "."
	@cl1.start = @cl1.end = @cl2.start = @cl2.end = nil
end
def borra_auxiliares
	if !@cl1.deleted?
		Sketchup.undo
	end if @cl1
end	
def calcula_puntos
	if(@puntos == 0) then 
 		@ptini = @ip.position
    else
		if @puntos > 1 
			vertice1=@ptini.project_to_line [@pts_i[@puntos-1],@pts_i[@puntos-2]]
			vertice2=@ptini.project_to_line [@pts_d[@puntos-1],@pts_d[@puntos-2]]
			vec =(vertice1 - vertice2)
			@ptini = vertice1.offset(vec, -@@escalera_cara*vec.length)
		end	
 		if @@escalera_cara > 0 then
			vec = @ptini - [@ptini[0] +(@ptfin[1] - @ptini[1]), @ptini[1] - (@ptfin[0] - @ptini[0]),@ptini[2]]
			return if vec.length == 0
			@pt1 = @ptini.offset(vec, @@escalera_cara * @@escalera_width)	 
			@pt2 = @ptfin.offset(vec, @@escalera_cara * @@escalera_width)
		else
			@pt1 = @ptini	 
			@pt2 = @ptfin	   
		end
		vec = @ptini - [@ptini[0] - (@ptfin[1] - @ptini[1]), @ptini[1] +(@ptfin[0] - @ptini[0]),@ptini[2]]
		Sketchup::set_status_text vec.length.to_s, SB_VCB_VALUE
		if vec.length > 0
			@pt3 = @pt1.offset(vec, @@escalera_width)	 
			@pt4 = @pt2.offset(vec, @@escalera_width)	   
		end	
		if(@puntos > 1) 
			if !((@pt3- @pt4).parallel?(@pts_d[@puntos-2]-@pts_d[@puntos-1]))
				vec =(@pts_d[@puntos-2]-@pts_d[@puntos-1])
				vec =(@pts_i[@puntos-2]-@pts_i[@puntos-1]) if vec.length < 0.000001
				@pt3 = Geom.intersect_line_line([@pt3, @pt4], [@pts_d[@puntos-2], vec])
				@pt1 = Geom.intersect_line_line([@pt1, @pt2], [@pts_i[@puntos-2], vec])
			end if ((@pt3- @pt4).length >0) && ((@pts_d[@puntos-2]-@pts_d[@puntos-1]).length >0)
		end
	end
end
def onMouseMove(flags, x, y, view)
    return false if(!@ip.pick(view, x, y, @ip1))
	texto_comando
    # pone tooltip segun el elemento
    view.tooltip = @ip.tooltip
	@ptfin=@ip.position
	@ptfin.z=@ptini.z if @ptini!=[]
    calcula_puntos
	view.invalidate
	@arfin = busca_cara(x, y, view) #para F8 
end
def tramo_escalera
	@pt_final_i=@pt_rest_i
	@pt_final_d=@pt_rest_d
	@pts_cursor[@puntos] = @ptini
	@ptini = @ptfin
	@pts_i[@puntos] = @pt2
	@pts_d[@puntos-1] = @pt3
	@pts_d[@puntos] = @pt4
	@pts_i[@puntos-1] = @pt1
	@cara_tramo[@puntos] = @@escalera_cara
end
def escalones(linea) # Devuelve los escalones de usuario. 
	lineas_ini = []
	puntos =[]
	Sketchup.active_model.active_entities.grep(Sketchup::Edge).each do |e|
		pt=interseccion_real(linea[0], linea[1], e.start.position, e.end.position)
		if pt
			puntos.push pt
			lineas_ini.push e
		end	
	end		
	i = -1
	ultimadistancia=-1
	lineas_ordenadas=[] 
	while i < puntos.size-1 do
		j = 0
		k = 0
		distancia = 1000000.0
		while j < puntos.size
			if puntos[j] 
				if(linea[0]-puntos[j]).length < distancia
					distancia =(linea[0]-puntos[j]).length
					linea_mas_cerca = lineas_ini[j]
					k = j
				end	
			end 
			j += 1
		end
		lineas_ordenadas.push(linea_mas_cerca) if distancia > ultimadistancia
		ultimadistancia=distancia
		puntos[k] = nil
		i += 1
	end	
	caras=[]
	lineas_ordenadas.each do |e|		
		if e.faces.size == 2 ||(e.faces.size ==1 && caras.size==0 && @huellas_recorrido.size==0)
			normales=0
			e.faces.each do |f|
				normales=normales+f.normal.z.abs
			end
			if normales>0.999999+e.faces.size-1
				e.faces.each do |f|
					caras.push f if f != @ultima_huella
				end
				@ultima_huella=caras[caras.size-1]
			end	
		end 
	end	
	return caras
end
def onLButtonDown(flags, x, y, view)
	#@ip1.copy! @ip
	@ip1.pick(view,x,y,@ip)
	if @puntos == 0 then
		@pts_i[@puntos] = @ip.position
		@pts_cursor[@puntos] = @ip.position
	else
		@ptfin=@ptescalon if !@pulsado_control  && !@recorrido
		calcula_puntos
		tramo_escalera
	end
	@puntos +=1
	auxiliares(@ptini)
	texto_comando
end
def onRButtonDown(flags, x, y, view)
	ejecuta_escalera
end	
def onLButtonDoubleClick(flags, x, y, view)
	if @puntos==1 
		@recorrido=true
	else	
		ejecuta_escalera
	end	
	texto_comando
	view.invalidate
end	
def ejecuta_escalera
	borra_auxiliares
	inicioundo(@comando_en_curso)
	if @recorrido
		escalera_recorrido 
	else
		escalera_generada
	end	
	finalundo
	Sketchup.active_model.select_tool nil
end
def escalera_recorrido
	escalera2=Sketchup.active_model.active_entities.add_group
	huellas=@huellas_final
	peld=0
	huellas.each do |face|
		peld+=1
		face.set_attribute "dibac","escalon",peld*@tabica
		face.reverse! if face.normal.z<0
	end
	escalera2=Sketchup.active_model.active_entities.add_group(huellas)
	#@tabica=@@escalera_height/peld if @@escalera_height>0
	escalera2.set_attribute "dibac","escalera2d",peld*@tabica
	#escalera_3d(escalera2,3.20.m)
end
def escalera_generada
	escalera = Sketchup.active_model.active_entities.add_group
	escalera2=Sketchup.active_model.active_entities.add_group
	punto=nil
	peld=0
	#Completamos el ultimo escalon
	@pts_i[@puntos-1]=@pt_final_i
	@pts_d[@puntos-1]=@pt_final_d
	for i in 1 ... @puntos
		temp=[@pts_i[i-1], @pts_i[i], @pts_d[i], @pts_d[i-1]]
		ptos=[temp[0]]
		for j in 1 ... temp.size
			ptos.push(temp[j]) if ptos[ptos.size-1]!=temp[j] #para que no haya repetidos
		end
		face=escalera.entities.add_face ptos
		#borra_coplanarias(face.edges)
		if punto
			edges=face.edges
			edges.each do |e|
				escalera.entities.erase_entities e if e.faces.size==2 && !punto_en_segmento(punto, e.start.position, e.end.position)
			end			
		end		
		ht=huellas_tramo([@pts_i[i-1],@pts_i[i]],[@pts_d[i-1],@pts_d[i]], punto)
		if ht
			1.step(ht.size-1,2) do |j|
				escalera.entities.add_line ht[j-1],ht[j]
			end	
			punto=punto_medio(ht[ht.size-2],ht[ht.size-1])
		end	if @pts_i[i-1]!=@pts_i[i] && @pts_d[i-1] != @pts_d[i]	
		escalera.entities.add_line @pts_i[i-1],@pts_i[i]
		escalera.entities.add_line @pts_d[i-1],@pts_d[i]
		huellas=escalera.entities.grep(Sketchup::Face)
		for j in 0..huellas.size-2
			e=huellas[j]
			vert=[]
			e.vertices.each do |v|
				vert.push v.position
			end	
			peld+=1
			face=escalera2.entities.add_face vert
			face.set_attribute "dibac","escalon",peld*@tabica
			face.reverse! if face.normal.z<0
		end
		e=huellas[huellas.size-1]
		vert=[]
		e.vertices.each do |v|
			vert.push v.position
		end
		Sketchup.active_model.active_entities.erase_entities escalera
		escalera=Sketchup.active_model.active_entities.add_group
		escalera.entities.add_face vert
	end	
	peld+=1
	face=escalera2.entities.add_face vert
	face.set_attribute "dibac","escalon",peld*@tabica
	face.reverse! if face.normal.z<0
	Sketchup.active_model.active_entities.erase_entities escalera
	escalera2.set_attribute "dibac","escalera2d",peld*@tabica
	#escalera_3d(escalera2,3.20.m)
end
def onCancel(flag, view)
	@cancelar=true
	if @puntos==1
		view.lock_inference if( view.inference_locked? )
		reset
	end	
end
def longitud_usuario(value, view) # view por si un dia funciona el posicionar el cursor
	# longitud del muro
	
end
def onUserText(text, view)
	valores = text.split("<")
	if valores[1]
		angulo = valores[1].to_f.degrees
		@@hv = [Math.cos(angulo), Math.sin(angulo)]
		auxiliares(@ptini) if @puntos > 0
		return
	end
	valores=valores[0].split(@@separador_listas)
	if valores[1] #longitud de peldaño
		valores2 = valores[1].split('>')
		if valores2[1]
			l=long_valida(valores2[1]).abs
			@@escalera_huellamin = l if l
		else
			l=long_valida(valores2[0]).abs
			if l
				@@escalera_huella=l
				@@escalera_huellamin=0
			end
		end
		huella_tabica
	end
	valores = valores[0].split'*'
	if valores[1]
		l=valores[1].to_i
		value=@primer_peld+l*@huella+0.000001
	else
		value=long_valida(valores[0])
	end	
	if value
		if value < 0 then
			# ancho de la escalera
			@@escalera_width = value.abs.to_l
			texto_comando
			calcula_puntos
		elsif @puntos > 0 && value>0
			vec = @ptfin - @ptini
			if( vec.length > 0.0 )
				vec.length = value
				@ptfin = @ptini.offset(vec)
				calcula_puntos
				tramo_escalera
				@puntos +=1
			end	
		end
	end
	auxiliares(@ptini)
	texto_comando
	view.invalidate
 end
 
def huella_tabica # @huella para el primer tramo
	return if !@huella
	@huella=0 if @huella.to_s=='NaN'
	if @huella==0
		@huella=@@escalera_huellamin
		@huella=@@escalera_huella if @huella==0
	end
	if @@escalera_tabicamax > 0
		@tabica=1000000.0 
		@tabica=(@@escalera_slope-@huella)/2  if @@escalera_slope>0   #calculamos la tabica en funcion de la huella
		@tabica=@@escalera_tabicamax if @tabica>@@escalera_tabicamax
	else
		@tabica=@@escalera_tabica
	end	
	if @@escalera_height>0
		n=((@@escalera_height/@tabica)).to_i
		@tabica=@@escalera_height/n
		tabicamax=@@escalera_tabicamax
		tabicamax=@@escalera_tabica if tabicamax==0
		while @tabica>tabicamax
			n+=1
			@tabica=@@escalera_height/n
		end	
		@total_peld=n
	end	
	if @@escalera_huellamin>0 #No hace falta comprobar @@escalera_huella porque ya viene hecho
		@huella=@@escalera_slope-(2*@tabica)
		while @huella<@@escalera_huellamin
			n+=1
			@tabica=@@escalera_height/n
			@huella=@@escalera_slope-(2*@tabica)
		end if @@escalera_height > 0	
	end  if @@escalera_slope > 0
end
def huellas_tramo(lineai, linead, punto)
	huellas=[]
	extremos =tramo_comun(lineai, linead) #maximo tramo para peldaños
	return nil if extremos == []
	tramo =(extremos[0]-extremos[1])
	return nil if tramo.length < 0.000001
	peld1 = [extremos[0],extremos[0].project_to_line(linead)] #primer peldaño del tramo
	dist = punto.distance_to_line peld1 if punto
	
	if dist<@huella
		if punto_en_segmento(punto.project_to_line(peld1), peld1[0], peld1[1])
			extremos[0]=punto_a_distancia(extremos[0],extremos[1],@huella-dist)
		end		
	end if dist
	return if !extremos[1] || !extremos[0]
	if(extremos[1]-lineai[0]).length <(extremos[0]-lineai[0]).length 
		@primer_peld=0.0 #Para sumar al numero de peldaños en longitud de usuario
		return
	end	
	tramo =(extremos[0]-extremos[1])
	if @huella==0
		@huella=tramo.length/((tramo.length/@@escalera_huellamin).to_i)
		huella_tabica
	end	
	n=(tramo.length/@huella).to_i
	for i in 0 .. n
		pt1=punto_a_distancia(extremos[0],extremos[1],i*@huella) 
		huellas.push(pt1)
		huellas.push(pt1.project_to_line(linead))
	end
	return huellas
end
def texto_descansillo(view, punto, peld_tramo, peld)
	#view.draw_text(view.screen_coords(punto), peld_tramo.to_s+'/'+peld.to_s+'/'+(peld*@tabica).to_l.to_s) if peld_tramo > 0	
	return if !punto
	view.draw_text(view.screen_coords(punto), peld.to_s+'/'+(peld*@tabica).to_l.to_s) if peld_tramo > 0	
end	
def draw(view)
	return if !@huella
	textoevaluacion(view)
	x=view.corner(0)[0]
	y=view.corner(0)[1]
	#view.draw2d GL_LINE_LOOP, [[x+1,y+20],[x+111,y+20],[x+111,y+110],[x+1,y+110]]
	if !@recorrido
		view.draw_text([x+2,y+24],CambiaIdioma(@comando_en_curso))
		huella_tabica
		view.draw_text([x+2,y+38],CambiaIdioma("Going")+':'+@huella.to_l.to_s)
		view.draw_text([x+2,y+50],CambiaIdioma("Rise")+':'+@tabica.to_l.to_s)
		view.draw_text([x+2,y+62],CambiaIdioma("Slope")+':'+(2*@tabica+@huella).to_l.to_s)
	end	
	# si no hay auxiliares tira para atras
	if @cl1.deleted? && @cancelar
		@cancelar=false if @puntos>1
		@puntos -=1
		@@escalera_cara = @cara_tramo[@puntos]
		@ptini = @pts_cursor[@puntos]
		auxiliares(@ptini)
		calcula_puntos
	elsif @cancelar
		ejecuta_escalera
		return
	end if @cl1
	reset if @cancelar
	# Muestra el punto actual
    @ip.draw(view) if( @ip.valid? && @ip.display? )
	@ip1.pick(view, view.screen_coords(@ptini).x, view.screen_coords(@ptini).y) if @puntos > 0
	@ip1.draw(view) if(@puntos>0 && @ip1.valid? && @ip1.display? )	
    # previsualiza la escalera
    view.drawing_color = "black"
    inference_locked = view.inference_locked?
	peld=0
	if @recorrido && @puntos>0 #recorrido de usuario
		if @@escalera_height>0
			if @huellas_recorrido
				@tabica=@@escalera_height/@huellas_recorrido.size if @huellas_recorrido.size>0
			end	
		end
		@ultima_huella=nil
		@huellas_recorrido=[]
		if @puntos>1
			view.draw(GL_LINE_STRIP, @pts_cursor[0..@puntos-1])
			view.draw(GL_LINE_STRIP, @pts_cursor[@puntos-1],@ptini)
		end
		if @puntos > 1
			for i in 1...@puntos
				h=escalones([@pts_cursor[i-1],@pts_cursor[i]])
				@huellas_recorrido=@huellas_recorrido+h
				peld_tramo=h.size
				peld +=peld_tramo
				pt_texto=@pts_cursor[i]
				texto_descansillo(view,pt_texto, peld_tramo,peld)
			end 
			h=escalones([@pts_cursor[@puntos-1],@ptini])
			@huellas_recorrido=@huellas_recorrido+h
			peld_tramo=h.size
			peld +=peld_tramo
			pt_texto=@ptini
			texto_descansillo(view,pt_texto, peld_tramo,peld)
		end 
		@huellas_final=@huellas_recorrido
		view.draw(GL_LINE_STRIP, @ptini, @ptfin)
		h=escalones([@ptini,@ptfin])
		@huellas_recorrido=@huellas_recorrido+h
		peld_tramo=h.size
		peld+=peld_tramo
		pt_texto=@ptfin
		texto_descansillo(view,pt_texto, peld_tramo,peld)
		return
	end
	# escalera generada
	@huella=@@escalera_huella
	@huella=0.0 if @@escalera_huellamin > 0
	punto = nil
	peld_tramo=0
    if @puntos > 1 then
		if @puntos >2
			view.draw(GL_LINE_STRIP, @pts_i[0..@puntos-2])
			view.draw(GL_LINE_STRIP, @pts_d[0..@puntos-2])
			for i in 1..@puntos-2 
				ht=huellas_tramo([@pts_i[i-1],@pts_i[i]],[@pts_d[i-1],@pts_d[i]], punto)
				if ht
					peld_tramo=ht.size/2
					peld=peld+peld_tramo
					view.draw(GL_LINES, ht)
					punto=punto_medio(ht[ht.size-2],ht[ht.size-1])
					texto_descansillo(view,punto, peld_tramo,peld)
				end	if @pts_i[i-1]!=@pts_i[i] && @pts_d[i-1] != @pts_d[i]
			end	
		end
		if @ptini != @ptfin	
			view.draw(GL_LINE_STRIP, @pts_i[@puntos-2], @pt1)
			view.draw(GL_LINE_STRIP, @pts_d[@puntos-2], @pt3)
			ht=huellas_tramo([@pts_i[@puntos-2], @pt1],[@pts_d[@puntos-2], @pt3], punto)
			if ht
				peld_tramo=ht.size/2
				peld=peld+peld_tramo
				punto=punto_medio(ht[ht.size-2],ht[ht.size-1])
				texto_descansillo(view,punto, peld_tramo,peld)
				view.draw(GL_LINES, ht)
			end	
		end
	end	
	# Ultimo tramo
 	view.set_color_from_line(@ip1, @ip) if @puntos>0
	ht = huellas_tramo([@pt1, @pt2],[@pt3, @pt4], punto) if (@pt1 != @pt2 && @pt3 != @pt4)
	if ht.size > 0
		pt = @ptini.project_to_line [ht[0],ht[1]]
		@primer_peld=(@ptini-pt).length
		peld_tramo=ht.size/2
		peld=peld+peld_tramo
		pt_texto=punto_medio(ht[ht.size-2],ht[ht.size-1])
	end if ht
	texto_descansillo(view,pt_texto, peld_tramo,peld)
	view.draw(GL_LINES,ht) if ht
	view.line_width = 3 if inference_locked
	if @puntos>0
		view.set_color_from_line(@ip1, @ip) 
		view.line_stipple='-.-'
		view.draw(GL_LINE_STRIP, @ptini, @ptfin)
		view.line_stipple=''
	end	
	view.draw(GL_LINE_STRIP, @pt1, @pt2) if @pt1 !=[]  && @pt2 !=[]
    view.draw(GL_LINE_STRIP, @pt3, @pt4) if @pt3 !=[]  && @pt3 !=[]
    view.line_width = 1 if inference_locked
	return if !ht
	pt = @ptfin.project_to_line [ht[ht.size-2],ht[ht.size-1]]
	vec=@ptfin-pt
	dist_peld=vec.length
	return if vec.length == 0
	vec.length=0.000001
	@ptescalon=pt.offset(vec) #punto en escalon
	vec=(@ptfin-@ptini)
	value=@huella+0.000001
	return if vec.length == 0
	vec.length = value-dist_peld
	# ultimo peldaño completo
	@pt_rest_i = @pt2.offset(vec)
	@pt_rest_d = @pt4.offset(vec)
	if peld<@total_peld+1
		# Resto de escalera si se ha indicado altura
		resto=@total_peld-peld+1
	else
		resto=1
	end
	value=resto*@huella+0.000001
	return if vec.length == 0
	vec.length = value-dist_peld
	pt_rest_1 = @pt2.offset(vec)
	pt_rest_2 = @pt4.offset(vec)
	ht = huellas_tramo([@pt2, pt_rest_1],[@pt4, pt_rest_2], pt_texto)
	view.drawing_color = "magenta"
	view.draw(GL_LINES,ht)
	view.draw(GL_LINE_STRIP, @pt2, pt_rest_1)
	view.draw(GL_LINE_STRIP, @pt4, pt_rest_2)
end
def tabulador
	return if @recorrido
	if @@escalera_inc then
		@@escalera_cara += 0.5
	elsif
		@@escalera_cara -= 0.5
	end	
	@@escalera_inc = !@@escalera_inc if @@escalera_cara != 0.5
end
def onKeyDown(key, rpt, flags, view)
	if(key == 9 && WIN) ||(key==VK_CONTROL && MAC) then
		tabulador
		calcula_puntos
		auxiliares(@ptini)
		view.invalidate
	elsif key == 119 #F8
		lb = @arfin.line 
		if lb
			@@hv = [lb[1][0],lb[1][1]] #coseno y seno del angulo
			auxiliares(@ptini) if @puntos > 0
		end
	elsif( key == CONSTRAIN_MODIFIER_KEY && rpt == 1 )
        # Si esta activado desactivarlo
        if( view.inference_locked? )
            view.lock_inference
        elsif !@primer_punto
            view.lock_inference @ip
        elsif
            view.lock_inference @ip, @ip1
		end
	elsif(key == COPY_MODIFIER_KEY)
		@pulsado_control = true
	end	
end
def onKeyUp(key, rpt, flags, view)
	if(key == CONSTRAIN_MODIFIER_KEY && view.inference_locked?)
		view.lock_inference
	elsif(key == COPY_MODIFIER_KEY)
		@pulsado_control=false
    end
end
end # de la clase Escalera
class Dibac_Preferencias < Dibac_Base
def texto_comando
	Sketchup::set_status_text(CambiaIdioma("Select language"))
end
def menu
	path =(Sketchup.find_support_file("dibac_cmd.rb",  "plugins/indoor"+"/")).to_s
	path=path [0 .. path.length-15] #longitud de dibac_cmd.rbs
	path=path + '/resources'
	lenguajes = []
	Dir.foreach(path) { |f|
		lenguajes.push(f.to_s) if f.to_s != '.' && f.to_s !='..'
	}
	
	prompts=[]
	prompts = 	[	CambiaIdioma("Language")+":"
						]
						
	defaults = 	[	CambiaIdioma(Sketchup.read_default("Dibac","Language",Sketchup.get_locale[0,2]))
					]
	lista=""
	lenguajes.each do |l|
		lista=lista+CambiaIdioma(l)+"|"
	end	
	list=[lista]
	input = UI.inputbox prompts, defaults, list,CambiaIdioma("Dibac for Sketchup")+": "+CambiaIdioma("Options")
	if input
		lista=lista.split("|")
		i=0
		i += 1 while lista[i] != input[0]
		Sketchup.write_default("Dibac","Language",lenguajes[i])
		DibacStrings.ParseLangFile
		cambia_idioma_comandos
	end
	Sketchup.active_model.select_tool nil	
end
def cambia_idioma_comandos
	@@murocmd.tooltip = CambiaIdioma("绘制墙体")  
	@@murocmd.status_bar_text = CambiaIdioma("Draw walls from point to point.")
	#Muro paralelo
	@@muropcmd.tooltip = CambiaIdioma("偏移墙体")
	@@muropcmd.status_bar_text = CambiaIdioma("Draw walls parallel to a edge.")
	#Estirar muros
	@@Estiramurocmd.tooltip = CambiaIdioma("延伸墙体")
	@@Estiramurocmd.status_bar_text = CambiaIdioma("Extend / shorten walls.")
	#Puertas
	#@@puertacmd.tooltip = CambiaIdioma("Door")
	#@@puertacmd.status_bar_text = CambiaIdioma("Place doors in walls.")
	#Ventanas
	#@@ventanacmd.tooltip = CambiaIdioma("Window")
	#@@ventanacmd.status_bar_text = CambiaIdioma("Place windows in walls.")
	#Armarios
	#@@armariocmd.tooltip = CambiaIdioma("Wardrobe")
	#@@armariocmd.status_bar_text = CambiaIdioma("Place wardrobes in walls.")
	#Escaleras
	#@@escaleracmd.tooltip = CambiaIdioma("Stair")
	#@@escaleracmd.status_bar_text = CambiaIdioma("Draw stairs from point to point or by path.")
	#Acotado continuo
	#@@cotacontinuacmd.tooltip = CambiaIdioma("Continuous dimension")
	#@@cotacontinuacmd.status_bar_text = CambiaIdioma("Continuous interior dimensions between two points.")
	# 3D
	@@tresdcmd.tooltip = CambiaIdioma("生成三维墙体")	
	@@tresdcmd.status_bar_text = CambiaIdioma("Transforms the 2D model into a 3D model with height defined.")
	#Preferencias
	#@@preferenciascmd.tooltip = CambiaIdioma("Options")
	#@@preferenciascmd.status_bar_text = CambiaIdioma("Select language")
end
	
end # de la clase preferencias
Sketchup.extensions.each{|e| Iscarnet_Dibac=e if e.name=='TC-绘制墙体'}
#MAC =( Object::RUBY_PLATFORM =~ /darwin/i ? true : false )
#WIN =((Object::RUBY_PLATFORM =~ /mswin/i || Object::RUBY_PLATFORM =~ /mingw/i) ? true : false )
MAC=Mac.mac
WIN=Mac.win
DibacStrings = Dibac_Lenguaje.new
DibacLicencia = Dibac_Licencia.new
DibacMac = Mac.address
#DibacMac='Prueba'
Iscarnet_Dibac.description=Iscarnet_Dibac.description+'#'+DibacMac
DibacHoraInicio = Time.now
Dibac_Inicio.new
=begin
module_function
@paths=[Sketchup.active_model.active_entities]
def paths; @paths end
def paths= v; @paths.push(v) end
=end
end # del modulo Dibac_Extensions
end # del modulo Iscarnet_Extensions
#Cargamos Solid Section si no esta
ss=Sketchup.find_support_file("indoor.rb","plugins")
if !ss
	dibac=nil
	Sketchup.extensions.each{|e| dibac=e if e.name=='TC-绘制墙体'}
	if dibac
		ss = SketchupExtension.new "SolidSection", "indoor/SolidSection.rb"
		ss.version = dibac.version + ' (Dibac)'
		ss.creator = '原作Dibac，TC优化'
		ss.copyright='2014-Dibac & 2020-TC'
		ss.description = "Plugin for make cut faces in section planes."
		Sketchup.register_extension ss, true
	end
end
